	SUBROUTINE FATBND(IPNT,IPAN,IENW)
**********************************************************
* Program calculates tlm-characters of wave functions    *
* to plot fat bands.                                     *
**********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,IDMF,NPFR          !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB,ILST! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                        !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                    !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                       !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SWZ                           !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC           !!! from readini
      USE COM_LMTPAR  ,ONLY: GAM,AAH,BBH,AAJ,BBJ               !!! from potpar
      USE COM_SUMPAR  ,ONLY: OHH,OJH,OHJ,OJJ                   !!! from ovrpar
      USE COM_KMESH   ,ONLY: NPNT,PNT                          !!! from tetra
	USE COM_ENERGY  ,ONLY: EARR                              !!! from energy
	USE COM_LMTOUT  ,ONLY: ICFAT,ICDOS                       !!! from readini
	USE COM_CHANNELS,ONLY: IUWFK,IUDOS                       !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: TLMM(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: APH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: APS(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: APJ(:,:,:,:)
	LOGICAL LOG
      CALL ABORTNOW()
C RETURN KEYS
	IF(ICFAT.EQ.0.AND.ICDOS.EQ.0)RETURN
	IF(IPAN.GT.1)RETURN
	IF(IENW.EQ.1)RETURN
C MEMORY ALLOCATIONS
	ALLOCATE(TLMM(LIMB2MEM,NATOMMEM,NORBSMEM,NDIMMEM,NSPINMEM))
	ALLOCATE(APH(LIMBMEM, NATOMMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(APS(LIMBMEM, NATOMMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(APJ(LIMT1MEM,NATOMMEM,NKAPMEM,NSPINMEM))
C START CODE
      DO 2000 IBNDS=1,NSPIN            !!! over spin subbands
      DO 1000 IBNDT=1,NBNDF(IPAN)      !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
C READ WAVE FUNCTIONS
	DO IORBS=1,NORBS
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
	DO IKAP=1,NKAP(IPAN)
      IREC=IKAP+NKAP(IPAN)*(IBNDT-1)+
     &NKAP(IPAN)*NBNDF(IPAN)*(IBNDS-1)+
     &NKAP(IPAN)*NBNDF(IPAN)*NSPIN*(ISPIN-1)*(NORBS-1)
      READ(UNIT=IUWFK,REC=IREC)
     &((APH(LM,IATOM,IKAP,IORBS),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((APS(LM,IATOM,IKAP,IORBS),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((APJ(LM,IATOM,IKAP,IORBS),LM=1,(ILST(IS(IATOM))+1)**2),
     &IATOM=1,NATOM)
	ENDDO
	ENDDO
C SET NORMALIZATION
	ANORM=0.D0
	DO IORBS=1,NORBS                 !!! over spinors   
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
	DO IKAP1=1,NKAP(IPAN)            !!! over energies
	DO IKAP=1,NKAP(IPAN)             !!! over energies
	DO IATOM=1,NATOM                 !!! over atoms
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)               !!! over l
	DO M=-L,L                        !!! over m
	LM=L*(L+1)+M+1
	IF(LTPAN(L,IATOM,IKAP1,IPAN).AND.LTPAN(L,IATOM,IKAP,IPAN))
     &ANORM=ANORM+CONJG(APH(LM,IATOM,IKAP1,IORBS))*
     &OHH(IKAP1,IKAP,L,ISORT,IPAN,ISPIN,1)*
     &APH(LM,IATOM,IKAP,IORBS)
	IF(LTPAN(L,IATOM,IKAP,IPAN))
     &ANORM=ANORM-CONJG(APJ(LM,IATOM,IKAP1,IORBS))*
     &OJH(IKAP1,IKAP,L,ISORT,IPAN,ISPIN,1)*
     &APH(LM,IATOM,IKAP,IORBS)
	IF(LTPAN(L,IATOM,IKAP1,IPAN))
     &ANORM=ANORM-CONJG(APH(LM,IATOM,IKAP1,IORBS))*
     &OHJ(IKAP1,IKAP,L,ISORT,IPAN,ISPIN,1)*
     &APJ(LM,IATOM,IKAP,IORBS)
	ANORM=ANORM+CONJG(APJ(LM,IATOM,IKAP1,IORBS))*
     &OJJ(IKAP1,IKAP,L,ISORT,IPAN,ISPIN,1)*
     &APJ(LM,IATOM,IKAP,IORBS)
      ENDDO                            !!! over m
      ENDDO                            !!! over l
      ENDDO                            !!! over atoms
      ENDDO                            !!! over energies
      ENDDO                            !!! over energies
      ENDDO                            !!! over spinors
	IF(ABS(ANORM).LE.1.D-10)ANORM=1.D0
C SET TLM-CHARACTER IN SPHERICAL HARMONIC REPRESENTATION
	DO IORBS=1,NORBS                 !!! over spinors   
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
	DO IATOM=1,NATOM                 !!! over atoms
	ISORT=IS(IATOM)
	DO L=0,MIN(ILSB(ISORT),3)        !!! over l
	DO M1=-L,L                       !!! over m1
	LM1=L*(L+1)+M1+1
	DO M=-L,L                        !!! over m
	LM=L*(L+1)+M+1
      LM1M=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1           !  (l,m1 m) packed
	TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS)=(0.D0,0.D0)
	DO IKAP1=1,NKAP(IPAN)
	DO IKAP =1,NKAP(IPAN)
	IF(LTPAN(L,IATOM,IKAP1,IPAN).AND.LTPAN(L,IATOM,IKAP,IPAN))
     &TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS)=
     &TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS)+
     &CONJG(APH(LM1,IATOM,IKAP1,IORBS))*
     &OHH(IKAP1,IKAP,L,ISORT,IPAN,ISPIN,1)*
     &APH(LM,IATOM,IKAP,IORBS)
	IF(LTPAN(L,IATOM,IKAP,IPAN))
     &TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS)=
     &TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS)-
     &CONJG(APJ(LM1,IATOM,IKAP1,IORBS))*
     &OJH(IKAP1,IKAP,L,ISORT,IPAN,ISPIN,1)*
     &APH(LM,IATOM,IKAP,IORBS)
	IF(LTPAN(L,IATOM,IKAP1,IPAN))
     &TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS)=
     &TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS)-
     &CONJG(APH(LM1,IATOM,IKAP1,IORBS))*
     &OHJ(IKAP1,IKAP,L,ISORT,IPAN,ISPIN,1)*
     &APJ(LM,IATOM,IKAP,IORBS)
	TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS)=
     &TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS)+
     &CONJG(APJ(LM1,IATOM,IKAP1,IORBS))*
     &OJJ(IKAP1,IKAP,L,ISORT,IPAN,ISPIN,1)*
     &APJ(LM,IATOM,IKAP,IORBS)
	ENDDO
	ENDDO
 	TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS)=
     &TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS)/ANORM
	ENDDO                            !!! over m
	ENDDO                            !!! over m1
      ENDDO                            !!! over l
      ENDDO                            !!! over atoms
      ENDDO                            !!! over spinors
C  SAVE TLM-CHARACTERS IN FILE
1000	CONTINUE                         !!! over bands
2000	CONTINUE                         !!! over spin subbands
      DO IORBS=1,NORBS
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)
      LMS=L*(2*L-1)*(2*L+1)/3+1
      LME=LMS+(2*L+1)**2-1
	IBAS=0
      DO IKAP=1,NKAP(IPAN)
      IF(LTPAN(L,IATOM,IKAP,IPAN))IBAS=1
	ENDDO
      IF(IBAS.EQ.0)CYCLE
      WRITE(IUDOS)(((TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS),
     &LM1M=LMS,LME),IBNDT=1,NBNDT(1)),IBNDS=1,NSPIN)
      ENDDO
      ENDDO
      ENDDO
	IF(IPAN.EQ.1.AND.IPNT.EQ.NPNT(1))CLOSE(IUDOS)
C MEMORY DEALLOCATIONS
	DEALLOCATE(TLMM,APH,APS,APJ)
	END
