	SUBROUTINE INTMAT(IPNT,IPAN,IENW)
***********************************************************
*  Calculates pseudopotential contribution to the         *
*  hamiltonian and overlap matrix using fourier transform.* 
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM
      USE COM_CONTROL ,ONLY: LMTO,IASA,NOVR,NPFR              !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS
     &                      ,IS,ILST,ILSB                     !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SWZ                          !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT                !!! from readini
      USE COM_LATTICE ,ONLY: TAU                              !!! from readstr
      USE COM_POTDAT  ,ONLY: POTPS1                           !!! from potfull
      USE COM_LMTIND  ,ONLY: LMTIND                           !!! from lmtpar
      USE COM_PLWMESH ,ONLY: NPLW,GPLW                        !!! from plwmesh
      USE COM_RINPAR  ,ONLY: VINT0=>RINT0,XFUN=>RFUN          !!! from intpar
      USE COM_STRCON  ,ONLY: SSCON                            !!! from strgnt
      USE COM_SCRINP  ,ONLY: ALPHA                            !!! from alpcon
      USE COM_TEILORG ,ONLY: MBAS,KEYT                        !!! from readini
	USE COM_LMTMAT  ,ONLY: HMAT,OMAT                        !!! from intmat
      USE COM_ETAPAR  ,ONLY: NBAS,LBAS                        !!! from setpar
      USE COM_INPTTR  ,ONLY: SH                               !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                         !!! from tetra
      USE COM_WMESH   ,ONLY: NPNW,PNW                         !!! from tetra
      USE COM_CHANNELS,ONLY: IUPIN                            !!! from setup
      USE COM_MASHDEP ,ONLY: LENCMP                           !!! from setup
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT                      !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, INTRINSIC :: SIZE
      COMPLEX*16, ALLOCATABLE :: YLM(:,:)
      COMPLEX*16, ALLOCATABLE :: CFTR(:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: CHIK(:)
      COMPLEX*16, ALLOCATABLE :: CHIS(:)
      COMPLEX*16, ALLOCATABLE :: CONV(:)
      COMPLEX*16, ALLOCATABLE :: EXPS(:)
      COMPLEX*16, ALLOCATABLE :: EXPK(:)
      COMPLEX*16, ALLOCATABLE :: CONK(:)
      COMPLEX*16, ALLOCATABLE :: CONS(:)
      COMPLEX*16, ALLOCATABLE :: WORK(:)
      COMPLEX*16 GINT,HHH,OOO
      DIMENSION PNTR(3),PNTK(3)
      LOGICAL EXIST
      DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
      NDIM=NBNDT(IPAN)*NSPIN
      ALLOCATE(HMAT(NDIM,NDIM),STAT=IALLOC)
      IF(IALLOC.EQ.1)CALL INTMAT_MESG01
      ALLOCATE(OMAT(NDIM,NDIM),STAT=IALLOC)
      IF(IALLOC.EQ.1)CALL INTMAT_MESG02
      SIZE_MAT=2.D0*DBLE(SIZE(OMAT)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_MAT
      IF(TOTMEM.LT.CURMEM)TXTMEM='<INTMAT> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C SET ZEROES
      DO IDIM1=1,NDIM
      DO IDIM =1,NDIM
      HMAT(IDIM1,IDIM)=(0.D0,0.D0)
      OMAT(IDIM1,IDIM)=(0.D0,0.D0)
      ENDDO
      ENDDO
C RETURN KEYS
	IF(NPLWMEM.EQ.-1)RETURN
C MEMORY ALLOCATIONS
      ALLOCATE(YLM(LIMBMEM,0:NBASMEM))
      SIZE_YLM=DBLE(SIZE(YLM)*LENCMP)/1024.D0**2
      ALLOCATE(CFTR(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM))
      SIZE_CFTR=DBLE(SIZE(CFTR)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_YLM+SIZE_CFTR 
      ALLOCATE(CHIK(0:NBASMEM))
      ALLOCATE(CHIS(0:NBASMEM))
      ALLOCATE(CONV(0:NBASMEM))
      ALLOCATE(EXPK(0:NBASMEM))
      ALLOCATE(EXPS(0:NBASMEM))
      ALLOCATE(CONK(0:NBASMEM))
      ALLOCATE(CONS(0:NBASMEM))
      ALLOCATE(WORK(NDIMMEM))
C FIND K-POINT PNTR=K+G WHICH HAS A MINIMAL LENGTH
      IF(IENW.EQ.0)THEN
      XK=PNT(1,IPNT,IPAN)+SH(1,IPAN)
      YK=PNT(2,IPNT,IPAN)+SH(2,IPAN)
      ZK=PNT(3,IPNT,IPAN)+SH(3,IPAN)
      ELSE
      XK=PNW(1,IPNT,IPAN)+SH(1,IPAN)
      YK=PNW(2,IPNT,IPAN)+SH(2,IPAN)
      ZK=PNW(3,IPNT,IPAN)+SH(3,IPAN)
      ENDIF
      CALL REDUC2(XK,YK,ZK,NBAS,GPLW(1,0),PNTK(1),PNTK(2),PNTK(3),
     &GRX,GRY,GRZ)
C SET PSEUDOLMTOS FOR THE POINT IPNTK
      CALL FTRMAT(PNTK,0,IPAN,PNTR,YLM,CFTR)
C DO OVER SPINS
	DO 2000 IORBS=1,NORBS                      !!! over spins
	DO 1000 IUPDN=1,NSPIN                      !!! over spins
	IF(IORBS.EQ.1)THEN
	IUPDN1=IUPDN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNF=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	IUPDN1=NSPIN+1-IUPDN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNF=-SQRT(2.D0) ! B^{+}*S_{+}
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNF=+SQRT(2.D0) ! B^{-}*S_{-}
	ENDIF
C READ POTENTIAL PARAMETERS
      IREC=IUPDN+NSPIN*(IORBS-1)
      IF(KEYT.GT.0)
     &READ(IUPIN,REC=IREC)((VINT0(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((XFUN(IPAR1,IBAS),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C DO OVER LEFT INDEX
	DO IATOM1=1,NATOM                          !!! over iatom1
	ISORT1=IS(IATOM1)
C CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,MIN(NBAS,MBAS)                   !!! NGMAX{small}
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM1)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM1)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM1)
	EXPS(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
      ENDDO    
	DO IKAP1=1,NKAP(IPAN)                      !!! over energy
	DO L1=0,ILSB(ISORT1)                       !!! over l1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))CYCLE
	DO M1=-L1,L1                               !!! over m1
	L1M1=L1*(L1+1)+M1+1
	IDIM1=LMTIND(L1M1,IATOM1,IKAP1,ISPIN1,IPAN)
	IPAR1=LMTIND(L1M1,IATOM1,IKAP1,1     ,IPAN)
	MINB1=MIN(LBAS(L1,ISORT1,IKAP1,IPAN) ,MBAS)
C FOURIER TRANSFORM OF THE PSEUDOORBITAL
	DO IBAS=0,MINB1                           !!! NG_1{small}
	CHIS(IBAS)=DCONJG(CFTR(L1,ISORT1,IKAP1,IBAS)*
     &YLM(L1M1,IBAS)*EXPS(IBAS))
      ENDDO    
C CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
      CALL CONVOL1(POTPS1(0,IUPDN1,IORBS),CHIS(0),CONV(0),'L',
     &             0,MIN(NBAS,MBAS),0,MINB1)
C SET CONVOLUTION FROM THE TEILOR EXPANSION
	IF(KEYT.GT.0)THEN
	DO IBAS=0,MIN(NBAS,MBAS)                   !!! NGMAX{small}
	CONS(IBAS)=XFUN(IPAR1,IBAS)*DCONJG(EXPS(0))
      ENDDO    
	ENDIF
C DO OVER RIGHT INDEX
	DO IATOM=1,NATOM                           !!! over iatom
	ISORT=IS(IATOM)
C CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,MIN(NBAS,MBAS)                   !!! NGMAX{small}
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
	EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
      ENDDO    
	DO IKAP=1,NKAP(IPAN)                       !!! over energy
	DO L=0,ILSB(ISORT)                         !!! over l
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))CYCLE
	DO M=-L,L                                  !!! over m
	LM=L*(L+1)+M+1
	IDIM=LMTIND(LM,IATOM,IKAP,ISPIN,IPAN)
	IPAR=LMTIND(LM,IATOM,IKAP,1    ,IPAN)
	MINB=MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
	IF(IDIM1.GE.IDIM)THEN
C FOURIER TRANSFORM OF THE PSEUDOORBITAL
	DO IBAS=0,MINB                             !!! NG_0{small}
	CHIK(IBAS)=CFTR(L,ISORT,IKAP,IBAS)*YLM(LM,IBAS)*EXPK(IBAS)
      ENDDO    
C SET CONVOLUTION FROM THE TEILOR EXPANSION
	IF(KEYT.GT.0)THEN
	DO IBAS=0,MIN(NBAS,MBAS)                   !!! NGMAX{small}
	CONK(IBAS)=DCONJG(XFUN(IPAR,IBAS))*EXPK(0) 
      ENDDO    
	ENDIF
C ******** PSEUDOPOTENTIAL MATRIX ************
	HHH=(0.D0,0.D0)
C  1) CONTRIBUTION FROM SMALL G, FULL K-DEPENDENCE
	DO IBAS=0,MINB                             !!! NG_0{small}
	HHH=HHH+CONV(IBAS)*CHIK(IBAS)
      ENDDO
	HHH=HHH*SIGNF
	IF(KEYT.GT.0)THEN
C  2) CONTRIBUTION FROM LARGE G, K-DEPENDENCE BY TEILOR
	DO IBAS=0,MINB1                            !!! NG_1{small}
	HHH=HHH+CHIS(IBAS)*CONK(IBAS)
      ENDDO    
C  3) CONTRIBUTION FROM LARGE G, K-DEPENDENCE BY TEILOR
	DO IBAS=0,MINB                             !!! NG_0{small}
	HHH=HHH+CONS(IBAS)*CHIK(IBAS)
      ENDDO    
C  4) CONTRIBUTION FROM LARGE G, K-DEPENDENCE BY TEILOR
	HHH=HHH+DCONJG(EXPS(0))*VINT0(IPAR1,IPAR)*EXPK(0)
	ENDIF
C PSEUDOOVERLAP MATRIX CAN IN PRINCIPLE BE ALSO CALCULATED
C	OOO=(0.D0,0.D0)
C	IF(NOVR.EQ.1)THEN
C	CALL FULLSTOP('NOVR.EQ.1 NOT READY')
C	DO JBAS=0,LBAS(L1,ISORT1,IKAP1,IPAN)
C	DO IBAS=0,LBAS(L,ISORT,IKAP,IPAN)
C	OOO=OOO+CHIS(IBAS)*CHIK(IBAS)*GINT
C	ENDDO
C	ENDDO
C	ENDIF
C FILL UP THE MATRICES
	HRE= DREAL(HHH)  ! real part of the hamiltonian matrix
	HIM= DIMAG(HHH)  ! imaginary part of the hamiltonian matrix
C     IF(ABS(HRE).LE.1.D-10)HRE=0.D0
C     IF(ABS(HIM).LE.1.D-10)HIM=0.D0
	IF(IDIM1.EQ.IDIM)HIM=0.D0
      HMAT(IDIM1,IDIM)=DCMPLX(+HRE,+HIM)
      HMAT(IDIM,IDIM1)=DCONJG(HMAT(IDIM1,IDIM))
	ENDIF
      ENDDO                                      !!! over m
      ENDDO                                      !!! over l
      ENDDO                                      !!! over energy
      ENDDO                                      !!! over iatom
      ENDDO                                      !!! over m1
      ENDDO                                      !!! over l1
      ENDDO                                      !!! over energy
      ENDDO                                      !!! over iatom1
1000  CONTINUE                                   !!! over spins
2000  CONTINUE                                   !!! over iorbs
C ************************************
C TRANSFORM TO SCREENED REPRESENTATION
	IF(LMTO.NE.1)THEN                          !!! lmto.ne.1
      DO 4000 IORBS=1,NORBS                      !!! over spins
      DO 3000 IUPDN=1,NSPIN                      !!! over spins
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
C Start looping over IDIM
      DO IKAP=1,NKAP(IPAN)                       !!! over energy
      DO IATOM=1,NATOM                           !!! over iatom
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)                         !!! over l
      IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))CYCLE
      DO M=-L,L                                  !!! over m
      LM=L*(L+1)+M+1
      IDIM=LMTIND(LM,IATOM,IKAP,ISPIN,IPAN)
      IPAR=LMTIND(LM,IATOM,IKAP,1    ,IPAN)
C TRANSFORM RIGHT INDEX
      DO IKAP1=1,NKAP(IPAN)                      !!! over energy
      DO IATOM2=1,NATOM                          !!! over iatom2
      ISORT2=IS(IATOM2)
      DO L2=0,ILSB(ISORT2)                       !!! over l2
      IF(.NOT.LTPAN(L2,IATOM2,IKAP1,IPAN))CYCLE
      DO M2=-L2,L2                               !!! over m2
      L2M2=L2*(L2+1)+M2+1
      IDIM2=LMTIND(L2M2,IATOM2,IKAP1,ISPIN1,IPAN)
      IPAR2=LMTIND(L2M2,IATOM2,IKAP1,1     ,IPAN)
	WORK(IPAR2)=(0.D0,0.D0)
      DO IATOM3=1,NATOM                          !!! over iatom3
      ISORT3=IS(IATOM3)
      DO L3=0,ILSB(ISORT3)                       !!! over l3
      IF(.NOT.LTPAN(L3,IATOM3,IKAP,IPAN))CYCLE
      DO M3=-L3,L3                               !!! over m3
      L3M3=L3*(L3+1)+M3+1
      IDIM3=LMTIND(L3M3,IATOM3,IKAP,ISPIN,IPAN)
      IPAR3=LMTIND(L3M3,IATOM3,IKAP,1    ,IPAN)
	IF(IDIM.EQ.IDIM3)ONE=1.D0
	IF(IDIM.NE.IDIM3)ONE=0.D0
	WORK(IPAR2)=WORK(IPAR2)+HMAT(IDIM2,IDIM3)*(ONE+
     &ALPHA(L3,ISORT3,IKAP,IPAN)*SSCON(L3M3,IATOM3,LM,IATOM,IKAP))
      ENDDO                                      !!! over m3
      ENDDO                                      !!! over l3
      ENDDO                                      !!! over iatom3
      ENDDO                                      !!! over m2
      ENDDO                                      !!! over l2
      ENDDO                                      !!! over iatom2
      ENDDO                                      !!! over ikap1
C TRANSFORM LEFT INDEX
      DO IKAP1=1,NKAP(IPAN)                      !!! over energy
      DO IATOM1=1,NATOM                          !!! over iatom1
      ISORT1=IS(IATOM1)
      DO L1=0,ILSB(ISORT1)                       !!! over l1
      IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))CYCLE
      DO M1=-L1,L1                               !!! over m1
      L1M1=L1*(L1+1)+M1+1
      IDIM1=LMTIND(L1M1,IATOM1,IKAP1,ISPIN1,IPAN)
      IPAR1=LMTIND(L1M1,IATOM1,IKAP1,1     ,IPAN)
	OMAT(IDIM1,IDIM)=(0.D0,0.D0) ! save current result in overlap matrix
      DO IATOM2=1,NATOM                          !!! over iatom2
      ISORT2=IS(IATOM2)
      DO L2=0,ILSB(ISORT2)                       !!! over l2
      IF(.NOT.LTPAN(L2,IATOM2,IKAP1,IPAN))CYCLE
      DO M2=-L2,L2                               !!! over m2
      L2M2=L2*(L2+1)+M2+1
      IDIM2=LMTIND(L2M2,IATOM2,IKAP1,ISPIN1,IPAN)
      IPAR2=LMTIND(L2M2,IATOM2,IKAP1,1     ,IPAN)
	IF(IDIM1.EQ.IDIM2)ONE=1.D0
	IF(IDIM1.NE.IDIM2)ONE=0.D0
	OMAT(IDIM1,IDIM)=OMAT(IDIM1,IDIM)+
     &DCONJG(ONE+ALPHA(L2,ISORT2,IKAP1,IPAN)*
     &SSCON(L2M2,IATOM2,L1M1,IATOM1,IKAP1))*WORK(IPAR2)
      ENDDO                                      !!! over m2
      ENDDO                                      !!! over l2
      ENDDO                                      !!! over iatom2
      ENDDO                                      !!! over m1
      ENDDO                                      !!! over l1
      ENDDO                                      !!! over iatom1
      ENDDO                                      !!! over ikap1
C End looping over idim
      ENDDO                                      !!! over m
      ENDDO                                      !!! over l
      ENDDO                                      !!! over iatom
      ENDDO                                      !!! over energy
3000  CONTINUE                                   !!! over spins
4000  CONTINUE                                   !!! over spins
C RESET HAMILTONIAN NOW
      DO IDIM1=1,NDIM
      DO IDIM =1,NDIM
      HMAT(IDIM1,IDIM)=OMAT(IDIM1,IDIM)
      OMAT(IDIM1,IDIM)=(0.D0,0.D0)
      ENDDO
      ENDDO
	ENDIF                                      !!! lmto.ne.1
C MEMORY DEALLOCATIONS
      DEALLOCATE(YLM,CFTR,CHIK,CHIS,CONV,EXPK,EXPS,CONK,CONS,WORK)
      CURMEM=CURMEM-SIZE_YLM-SIZE_CFTR 
C ERROR HANDLINGS
      CONTAINS
      SUBROUTINE INTMAT_MESG01
	LSIZE=NDIM*NDIM
      WRITE(IUT,*)'Terminated in <INTMAT>:'
      WRITE(IUT,*)'Memory allocation problem detected from'
      WRITE(IUT,*)'the system. Complex array HMAT of the size:'
      WRITE(IUT,*) DBLE(LSIZE*LENCMP)/1024.D0**2,' Mbyte'
      WRITE(IUT,*)'cannot be allocated.'
      CALL FULLSTOP(' ')
      END SUBROUTINE INTMAT_MESG01
      SUBROUTINE INTMAT_MESG02
	LSIZE=NDIM*NDIM
      WRITE(IUT,*)'Terminated in <INTMAT>:'
      WRITE(IUT,*)'Memory allocation problem detected from'
      WRITE(IUT,*)'the system. Complex array OMAT of the size:'
      WRITE(IUT,*) DBLE(LSIZE*LENCMP)/1024.D0**2,' Mbyte'
      WRITE(IUT,*)'cannot be allocated.'
      CALL FULLSTOP(' ')
      END SUBROUTINE INTMAT_MESG02
	END
