	SUBROUTINE ORBMAT(IPNT,IPAN,IENW)
************************************************************
*  Subroutine calculates contribution from spin-orbit      *
*  coupling to the hamiltonian.                            *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL ,ONLY: LMTO,IASA,NOVR,NPFR              !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILST  !!! from readini
     &                      ,ILSB
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,SMT,SWZ                     !!! from readini
      USE COM_LMTIND  ,ONLY: LMTIND                           !!! from lmtpar
      USE COM_ORBPAR  ,ONLY: SPARHH,SPARJH,SPARHJ,SPARJJ      !!! from orbpar
      USE COM_LMTMAT  ,ONLY: HMAT,OMAT                        !!! from orbmat
      USE COM_STRCON  ,ONLY: SSCON,SDCON                      !!! from strgnt
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: SLM(:,:,:)
	COMPLEX*16 HHH,OOO,HSO(2,2)
      CALL ABORTNOW()
C RETURN KEYS
	IF(NORBS.EQ.1)RETURN
C MEMORY ALLOCATIONS
	ALLOCATE(SLM(LIMTMEM,2,2))
C SET <Ylm|s*l|Ylm>/2 MATRIX ELEMENT
	DO L=0,LMAXTMEM
	DO M=-L,L
	LM=L*(L+1)+M+1
	SLM(LM,1,1)=0.5D0*DBLE(+M)
	SLM(LM,1,2)=0.5D0*SQRT(DBLE((L+M)*(L-M+1)))
	SLM(LM,2,1)=0.5D0*SQRT(DBLE((L-M)*(L+M+1)))
	SLM(LM,2,2)=0.5D0*DBLE(-M)
	ENDDO
	ENDDO
C ADD SPIN-ORBIT COUPLING TO THE HAMILTONIAN 
	DO IKAP1=1,NKAP(IPAN)                         !!! over energy
	DO IKAP =1,NKAP(IPAN)                         !!! over energy
	DO IATOM1=1,NATOM                             !!! over iatom1
	ISORT1=IS(IATOM1)
	DO L1=0,ILSB(ISORT1)                          !!! over l1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))CYCLE
	DO M1=-L1,L1                                  !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO IATOM=1,NATOM                              !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                            !!! over l
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))CYCLE
	DO M=-L,L                                     !!! over m
	LM=L*(L+1)+M+1
	DO 2000 IUPDN1=1,NSPIN                        !!! over iupdn1
	DO 1000 IUPDN =1,NSPIN                        !!! over iupdn
	ISIGN=IUPDN1-IUPDN
	HHH=(0.D0,0.D0)
C ONE-CENTER TERM :
	IF(IATOM1.EQ.IATOM.AND.L1.EQ.L.AND.M1.EQ.M+ISIGN)
     &HHH=HHH+SPARHH(IKAP1,IKAP,L,ISORT,IUPDN1,IUPDN)*
     &SLM(LM,IUPDN1,IUPDN)
C TWO-CENTER TERM :
	M2=M+ISIGN
	LM2=L*(L+1)+M2+1
	IF(ABS(M2).LE.L)
     &HHH=HHH-SPARJH(IKAP1,IKAP,L,ISORT,IUPDN1,IUPDN)*
     &SLM(LM,IUPDN1,IUPDN)*
     &CONJG(SSCON(LM2,IATOM,L1M1,IATOM1,IKAP1))
C TWO-CENTER TERM :
	M2=M1-ISIGN
	L1M2=L1*(L1+1)+M2+1
	IF(ABS(M2).LE.L1)
     &HHH=HHH-SPARHJ(IKAP1,IKAP,L1,ISORT1,IUPDN1,IUPDN)*
     &SLM(L1M2,IUPDN1,IUPDN)*
     &SSCON(L1M2,IATOM1,LM,IATOM,IKAP)
C THREE-CENTER TERM :
	DO KATOM=1,NATOM                             !!! over katom
	KSORT=IS(KATOM)
	DO L2=0,ILST(KSORT)                          !!! over l2
	DO M2=-L2,L2                                 !!! over m2
	M3=M2-ISIGN
	L2M2=L2*(L2+1)+M2+1
	L2M3=L2*(L2+1)+M3+1
	IF(ABS(M3).LE.L2)
     &HHH=HHH+CONJG(SSCON(L2M2,KATOM,L1M1,IATOM1,IKAP1))*
     &SPARJJ(IKAP1,IKAP,L2,KSORT,IUPDN1,IUPDN)*
     &SLM(L2M3,IUPDN1,IUPDN)*
     &SSCON(L2M3,KATOM,LM,IATOM,IKAP)
      ENDDO                                        !!! over m2
      ENDDO                                        !!! over l2
      ENDDO                                        !!! over katom
	HSO(IUPDN1,IUPDN)=HHH
1000	CONTINUE                                     !!! over iupdn
2000	CONTINUE                                     !!! over iupdn1
C SET SPIN-ORBIT COUPLING IN THE HAMILTONIAN
	DO IUPDN1=1,NSPIN
	DO IUPDN =1,NSPIN
C SET ZEROES WHERE NECESSARY
	HRE= DREAL(HSO(IUPDN1,IUPDN))  ! real part of the hamiltonian 
	HIM= DIMAG(HSO(IUPDN1,IUPDN))  ! imaginary part of the hamiltonian
C     IF(ABS(HRE).LE.1.D-10)HRE=0.D0
C     IF(ABS(HIM).LE.1.D-10)HIM=0.D0
	IDIM1=LMTIND(L1M1,IATOM1,IKAP1,IUPDN1,IPAN)
	IDIM =LMTIND(LM,IATOM,IKAP,IUPDN,IPAN)
      HMAT(IDIM1,IDIM)=HMAT(IDIM1,IDIM)+DCMPLX(HRE,+HIM)
C     HMAT(IDIM,IDIM1)=DCONJG(HMAT(IDIM1,IDIM))
	ENDDO
	ENDDO
      ENDDO                                        !!! over m
      ENDDO                                        !!! over l
      ENDDO                                        !!! over iatom
      ENDDO                                        !!! over m1
      ENDDO                                        !!! over l1
      ENDDO                                        !!! over iatom1
      ENDDO                                        !!! over energy
      ENDDO                                        !!! over energy
C MEMORY DEALLOCATIONS
	DEALLOCATE(SLM)
	END
