	SUBROUTINE SETDOS
******************************************************
*   Save density of states                           *
******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,LRWF,NPFR,IEXC    !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS       !!! from readini
     &                      ,ILST,ILSB,ILSV,LRTV,NHSORT
      USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC                  !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS            !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SWZ                          !!! from readini
      USE COM_INPPAR  ,ONLY: ENY,DNY,TNY,NODES,MNY            !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC          !!! from readini
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,NDIW                   !!! from readstr
      USE COM_KMESH   ,ONLY: NPNT,PNT                         !!! from tetra
      USE COM_FERMI   ,ONLY: EF                               !!! from ttrints
      USE COM_FREQU   ,ONLY: NENRDOS,ENRDOS                   !!! from ttrints
      USE COM_ENERGY  ,ONLY: EARR,WEIGH,WEIGD                 !!! from bands
      USE COM_GROUPS  ,ONLY: NGROUP,INV,KELTAB,IKOV,IP        !!! from groups
     &                      ,RDC,SHIFT,SOPHS,U,UJ
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                  !!! from setup
      USE COM_CHANNELS,ONLY: IUAIN,IUDOS                      !!! from channels
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                      !!! from setup
      USE COM_LMTOUT                                          !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: ILMTBAS(:,:)
	INTEGER, ALLOCATABLE :: INODBAS(:,:)
      COMPLEX*16, ALLOCATABLE :: TLMM(:,:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: TLMS(:,:,:)
      COMPLEX*16, ALLOCATABLE :: TLMT(:,:,:)
      COMPLEX*16 TC(-3:3,7,0:3),TS(7,-3:3,0:3)
      DIMENSION VEL(3),SPVEL(3,2),SPDOS(2),SPTOS(2)
     &    ,VELM(3,3),SPVELM(3,3,2)
	CHARACTER*40 HELP
	LOGICAL EXIST,OPEN
	IF(ICDOS.LE.0)RETURN
	CALL TRANSS(TS)                  !!! built transformation matrices
      CALL TRANSC(TC)                  !!! built transformation matrices
C FIND LIMITS
	IF(ABS(ENRDOS(NENRDOS)-ENRDOS(0)).LE.1.D-10)THEN
	EMIN=+1.D+15
	EMAX=-1.D+15
	DO IPNT=1,NPNT(1)
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDF(1)
	EMIN=MIN(EARR(IBNDS+NSPIN*(IBNDT-1),IPNT,1),EMIN)
	EMAX=MAX(EARR(IBNDS+NSPIN*(IBNDT-1),IPNT,1),EMAX)
	ENDDO
	ENDDO
	ENDDO
	IF(EF.NE.0.D0)EMAX=EF+0.5
	IF(NENRDOS.NE.0)ESTEP=(EMAX-EMIN)/DBLE(NENRDOS)
	IF(NENRDOS.EQ.0)ESTEP=0.D0
	DO IENR=0,NENRDOS
	ENRDOS(IENR)=EMIN+DBLE(IENR)*ESTEP
	ENDDO
	ENDIF
C STORE HEADER INFO.
	INQUIRE(FILE=DOSFILE,EXIST=EXIST)
	IF(EXIST)THEN
      OPEN(UNIT=IUAIN,FILE=DOSFILE,STATUS='OLD',FORM='FORMATTED')
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
	OPEN(UNIT=IUAIN,FILE=DOSFILE,STATUS='NEW',FORM='FORMATTED')
	WRITE(IUAIN,10010)
	WRITE(IUAIN,10020)
10010	FORMAT(1X,'<FILE=DOSFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUAIN,10030)
10030 FORMAT(1X,'<SECTION=CTRL>               ! CONTROL PARAMETERS:')
      HELP='! Energy mesh for DOS                  '
	WRITE(IUAIN,10040)NENRDOS,HELP
10040 FORMAT(1X,'nEnrDOS=',I5,16X,A40)
      HELP='! Min.Energy (Ry) for DOS              '
	WRITE(IUAIN,10050)ENRDOS(0),HELP
10050 FORMAT(1X,'EminDOS=',G14.7,7X,A40)
      HELP='! Max.Energy (Ry) for DOS              '
	WRITE(IUAIN,10060)ENRDOS(NENRDOS),HELP
10060 FORMAT(1X,'EmaxDOS=',G14.7,7X,A40)
	HELP='! Tetrahedron mesh                     '
	WRITE(IUAIN,10070)NDIV,HELP
10070 FORMAT(1X,'nDiv(:)=',I2,1X,I2,1X,I2,1X,12X,A40)
	HELP='! Tetrahedron mesh for weights         '
	WRITE(IUAIN,10080)NDIW,HELP
10080 FORMAT(1X,'nDiw(:)=',I2,1X,I2,1X,I2,1X,12X,A40)
C STORE DOS DATA
	WRITE(IUAIN,10110)
10110 FORMAT(1X,'<SECTION=DATA>               ! DOS DATA:')
      WRITE(IUAIN,*)NATOM,NSORT,NSPIN,NORBS,(IS(IATOM),IATOM=1,NATOM),
     &(ILSB(ISORT),ISORT=1,NSORT),(NHSORT(ISORT),ISORT=1,NSORT),
     &EF,ENRDOS(0),ENRDOS(NENRDOS),NENRDOS
      WRITE(IUAIN,FMT='(5A10)')(TXTAT(ISORT),ISORT=1,NSORT)
C Store basis set
      ALLOCATE(ILMTBAS(0:LMAXBMEM,NATOMMEM))
      ALLOCATE(INODBAS(0:LMAXBMEM,NATOMMEM))
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(IS(IATOM))
      ILMTBAS(L,IATOM)=0
      INODBAS(L,IATOM)=0
      DO IKAP=1,NKAP(1)
      IF(LTPAN(L,IATOM,IKAP,1))ILMTBAS(L,IATOM)=1
      IF(LTPAN(L,IATOM,IKAP,1))INODBAS(L,IATOM)=
     &NODES(L,ISORT,IKAP,1)+L+1
      ENDDO
      ENDDO
      ENDDO
      WRITE(IUAIN,*)((ILMTBAS(L,IATOM),L=0,ILSB(IS(IATOM))),
     &IATOM=1,NATOM)
      WRITE(IUAIN,*)((INODBAS(L,IATOM),L=0,ILSB(IS(IATOM))),
     &IATOM=1,NATOM)
C Compute and store
	DELTAE=(EMAX-EMIN)/NENRDOS
      ALLOCATE(TLMM(LIMB2MEM,NATOMMEM,NSPINMEM,NDIMMEM,NSPINMEM))
      ALLOCATE(TLMS(LIMB2MEM,NATOMMEM,NSPINMEM))
      ALLOCATE(TLMT(LIMB2MEM,NATOMMEM,NSPINMEM))
	DO IPNTDOS=0,NENRDOS                    !!! over energies
	E0=ENRDOS(IPNTDOS)
	CALL TTRINT(E0,TOS,DOS,0)
      CALL TTRVEL(E0,DOS,VEL,SPTOS,SPDOS,SPVEL,VELM,SPVELM,1)
	WRITE(IUAIN,*)E0,(SPTOS(ISPIN),ISPIN=1,NSPIN),
     &                 (SPDOS(ISPIN),ISPIN=1,NSPIN)
C INTEGRATE PARTIAL NUMBERS OF STATES
      DO ISPIN=1,NSPIN
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)
      DO M1=-L,L
      LM1=L*(L+1)+M1+1
      DO M=-L,L
      LM=L*(L+1)+M+1
      LM1M=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1           !  (l,m1 m) packed
      TLMS(LM1M,IATOM,ISPIN)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C Sum over BZ
	OPEN(IUDOS,FILE=SCRFILE(IUDOS),STATUS='OLD',FORM='UNFORMATTED')
	DO IPNT=1,NPNT(1)           !!! over k-points
      DO IORBS=1,NORBS
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)
      LMS=L*(2*L-1)*(2*L+1)/3+1
      LME=LMS+(2*L+1)**2-1
      IF(ILMTBAS(L,IATOM).EQ.0)CYCLE
      READ(IUDOS)(((TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS),
     &LM1M=LMS,LME),IBNDT=1,NBNDT(1)),IBNDS=1,NSPIN)
      ENDDO
      ENDDO
      ENDDO
      DO IBNDS=1,NSPIN            !!! over spin subbands
      DO IBNDT=1,NBNDF(1)         !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	IF(ABS(WEIGD(IBAND,IPNT)).LE.1.D-12)CYCLE
      DO IORBS=1,NORBS
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)
      IF(ILMTBAS(L,IATOM).EQ.0)CYCLE
      DO M1=-L,L
      LM1=L*(L+1)+M1+1
      DO M=-L,L
      LM=L*(L+1)+M+1
      LM1M=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1           !  (l,m1 m) packed
      TLMS(LM1M,IATOM,ISPIN)=TLMS(LM1M,IATOM,ISPIN)+
     &TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS)*WEIGD(IBAND,IPNT)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
	ENDDO                       !!! over bands
	ENDDO                       !!! over spin subbands
	ENDDO                       !!! over k-points
	CLOSE(IUDOS)
C Symmetrize
      DO ISPIN=1,NSPIN
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)
      DO M1=-L,L
      LM1=L*(L+1)+M1+1
      DO M=-L,L
      LM=L*(L+1)+M+1
      LM1M=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1           !  (l,m1 m) packed
      TLMT(LM1M,IATOM,ISPIN)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      DO IR=1,NGROUP                         !!! over point group
      IG=IKOV(IR)
      DO ISPIN=1,NSPIN
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)
      DO M1=-L,L
      DO M=-L,L
      LM1M=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1           !  (l,m1 m) packed
	DO M2=-L,L
      LM1M2=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M2)+L+M1+1         !  (l,m1 m2) packed
	DO M3=-L,L
      LMM3=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M3)+L+M+1           !  (l,m m3) packed
      LM2M3=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M3)+L+M2+1         !  (l,m2 m3) packed
	TLMT(LM1M,IATOM,ISPIN)=TLMT(LM1M,IATOM,ISPIN)+
     &CONJG(U(LM1M2,IG))*TLMS(LM2M3,IP(IATOM,IR),ISPIN)*
     &U(LMM3,IG)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO                                  !!! over group
C Normalize
      DO ISPIN=1,NSPIN
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)
      DO M1=-L,L
      LM1=L*(L+1)+M1+1
      DO M=-L,L
      LM=L*(L+1)+M+1
      LM1M=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1           !  (l,m1 m) packed
      TLMS(LM1M,IATOM,ISPIN)=TLMT(LM1M,IATOM,ISPIN)/DBLE(NGROUP)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C Store now
      DO ISPIN=1,NSPIN
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)
      LMS=L*(2*L-1)*(2*L+1)/3+1
      LME=LMS+(2*L+1)**2-1
      IF(ILMTBAS(L,IATOM).EQ.0)CYCLE
      WRITE(IUAIN,*)(TLMS(LM1M,IATOM,ISPIN),LM1M=LMS,LME)
      ENDDO
      ENDDO
      ENDDO
	ENDDO                      !!! over energies
	CLOSE(IUAIN)
	DEALLOCATE(TLMM,TLMS,TLMT)
      DEALLOCATE(ILMTBAS,INODBAS)
	END SUBROUTINE SETDOS


