	SUBROUTINE SYMTOS
***********************************************************
* Symmterizes numbers of states matrix                    *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS          !!! from readini
     &                      ,IS,ILST,ILSB,ILSV
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC          !!! from readini
      USE COM_LATTICE ,ONLY: RBAS,GBAS,TAU                    !!! from readstr
      USE COM_DENDAT  ,ONLY: RHOPS,RHOPN                      !!! from rhofull
      USE COM_PLWMESH ,ONLY: NPLW,GPLW,INDG,KVEC,KGMIN,KGMAX  !!! from plwmesh
      USE COM_TEILORG ,ONLY: KEYT,MBAS,BZM,GOPT               !!! from readini
      USE COM_ETAPAR  ,ONLY: NBAS,LBAS,ETA,CUT                !!! from setpar
      USE COM_KMESH   ,ONLY: NPNT,PNT                         !!! from tetra
      USE COM_GROUPS  ,ONLY: NGROUP,INV,KELTAB,IKOV,IP        !!! from groups
     &                      ,RDC,SHIFT,U,SJ
      USE COM_HAMPAR  ,ONLY: ATOSHH=>HPARHH                   !!! from tospar
     &                      ,ATOSJH=>HPARJH
     &                      ,ATOSHJ=>HPARHJ
     &                      ,ATOSJJ=>HPARJJ
	USE COM_PULAYF  ,ONLY: PFVAL                            !!! from ttrint
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                      !!! from setup
	USE COM_LMTOUT  ,ONLY: ICSCR,SCRFILE                    !!! from readini
	USE COM_CHANNELS,ONLY: IUNMT,IUTOS                      !!! from channels
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                      !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
	COMPLEX*16, ALLOCATABLE :: ATMP1(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: ATMP2(:,:,:)
	COMPLEX*16, ALLOCATABLE :: TMPARR(:,:)
	COMPLEX*16, ALLOCATABLE :: PFTMP(:,:,:)
	COMPLEX*16 EXPGR
	LOGICAL LOG1,LOG
	DATA PI/3.141592653589793D0/
C MEMORY ALLOCATIONS
	ALLOCATE(ATMP1(-LMAXTMEM:LMAXTMEM,-LMAXTMEM:LMAXTMEM,NATOMMEM,4))
	ALLOCATE(ATMP2(LIMTMEM,LIMTMEM,4))
	ALLOCATE(TMPARR(-LMAXTMEM:LMAXTMEM,4))
	ALLOCATE(PFTMP(-1:1,NATOMMEM,2))
C OPEN SCRATCH FILE FOR STORING TOS-MATRIX
	NRECL=0
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	LMAXH=((ILSB(ISORT)+1)**2+(ILST(ISORT)+1)**2)**2
	NRECL=MAX(NRECL,NVAL*LMAXH)
	ENDDO
	OPEN(UNIT=IUNMT,FILE=SCRFILE(IUNMT),STATUS='NEW',
     &ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
C DO THE SAME OPERATIONS FOR EVERY SPIN AND ENERGY PANEL
	DO 7000 IPAN=1,NPAN                            !!! over panels
C Initialize scratch file
	DO IORBS=1,NORBS                               !!! over iorbs
	DO IUPDN=1,NSPIN                               !!! over spins
	DO IKAP=1,NKAP(IPAN)                           !!! over energies
	DO JKAP=1,NKAP(IPAN)                           !!! over energies
	DO IATOM=1,NATOM                               !!! over iatom
	ISORT=IS(IATOM)
	DO L1=0,ILST(ISORT)
	DO M1=-L1,L1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	ATMP2(L1M1,LM,1)=(0.D0,0.D0)
	ATMP2(L1M1,LM,2)=(0.D0,0.D0)
	ATMP2(L1M1,LM,3)=(0.D0,0.D0)
	ATMP2(L1M1,LM,4)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	IREC=IKAP+NKAP(IPAN)*(JKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)
	WRITE(IUNMT,REC=IREC)
     &((ATMP2(L1M1,LM,1),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATMP2(L1M1,LM,2),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATMP2(L1M1,LM,3),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((ATMP2(L1M1,LM,4),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
      ENDDO                                          !!! over iatom
      ENDDO                                          !!! over jkap
      ENDDO                                          !!! over ikap
      ENDDO                                          !!! over spins
      ENDDO                                          !!! over iorbs
	NSHIFT=0
	DO JPAN=1,NPAN
	IF(JPAN.LT.IPAN)
     &NSHIFT=NSHIFT+NKAP(JPAN)**2*NATOM*NSPIN*NORBS
      ENDDO
C  ********  SYMMETRISATION OF THE MT-PART ********
	DO 6000 IORBS=1,NORBS                          !!! over iorbs
	DO 5000 IUPDN=1,NSPIN                          !!! over spins
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNI=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNI=+SQRT(2.D0) ! M^{-}=<S^{-}>=-<S_{+}>
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNI=-SQRT(2.D0) ! M^{+}=<S^{+}>=-<S_{-}>
	ENDIF
	DO 4000 JORBS=1,NORBS
	DO 3000 JUPDN=1,NSPIN    
	IF(JORBS.EQ.1)THEN
	JSPIN1=JUPDN
	JSPIN =JUPDN
	SIGNJ=1.D0
	ELSEIF(JORBS.EQ.2)THEN
	JSPIN1=JUPDN
	JSPIN =NSPIN+1-JUPDN
	IF(JSPIN1.EQ.1.AND.JSPIN.EQ.2)SIGNJ=+SQRT(2.D0) ! M^{-}=<S^{-}>=-<S_{+}>
	IF(JSPIN1.EQ.2.AND.JSPIN.EQ.1)SIGNJ=-SQRT(2.D0) ! M^{+}=<S^{+}>=-<S_{-}>
	ENDIF
	IF(NORBS.EQ.1.AND.JUPDN.NE.IUPDN)CYCLE
	DO 2000 IKAP=1,NKAP(IPAN)                      !!! over energies
	DO 1000 JKAP=1,NKAP(IPAN)                      !!! over energies
	DO IATOM=1,NATOM                               !!! over iatom
	ISORT=IS(IATOM)
	IREC=IKAP+NKAP(IPAN)*(JKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(JUPDN-1)+NKAP(IPAN)**2*NATOM*NSPIN*(JORBS-1)+
     &NSHIFT
	READ(IUTOS,REC=IREC)
     &((ATOSHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((ATOSJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
      ENDDO                                          !!! over iatom
	ILSTMAX=0
	DO ISORT=1,NSORT
	ILSTMAX=MAX(ILST(ISORT),ILSTMAX) 
	ENDDO
	DO L1=0,ILSTMAX                                !!! over l1
	NLS1=L1*(2*L1-1)*(2*L1+1)/3
	LP1=L1*L1+L1+1
	DO L=0,ILSTMAX                                 !!! over l
	NLS=L*(2*L-1)*(2*L+1)/3
	LP=L*L+L+1
	DO IATOM=1,NATOM                               !!! over atoms in cell
	ISORT=IS(IATOM)
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP,IPAN))LOG1=.TRUE.
	IF(L1.GT.ILST(ISORT))CYCLE
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,JKAP,IPAN))LOG=.TRUE.
	IF(L.GT.ILST(ISORT))CYCLE   
	DO M1=-L1,L1                                   !!! over m1
	DO M=-L,L                                      !!! over m
	ATMP1(M1,M,IATOM,1)=(0.D0,0.D0)
	ATMP1(M1,M,IATOM,2)=(0.D0,0.D0)
	ATMP1(M1,M,IATOM,3)=(0.D0,0.D0)
	ATMP1(M1,M,IATOM,4)=(0.D0,0.D0)
      ENDDO                                          !!! over m
      ENDDO                                          !!! over m1
	DO IR=1,NGROUP                                 !!! over point group
	IG=IKOV(IR)
	DO M=-L,L                                      !!! over m
	LM=LP+M
	MM=L+M+1
	DO M2=-L1,L1
	L1M2=LP1+M2
	TMPARR(M2,1)=(0.D0,0.D0)
	TMPARR(M2,2)=(0.D0,0.D0)
	TMPARR(M2,3)=(0.D0,0.D0)
	TMPARR(M2,4)=(0.D0,0.D0)
	DO M3=-L,L
	LM3=LP+M3
	IWIG03=NLS+(2*L+1)*(L+M3)+MM
	IF(LOG1.AND.LOG) 
     &TMPARR(M2,1)=TMPARR(M2,1)+U(IWIG03,IG)*
     &ATOSHH(L1M2,LM3,IP(IATOM,IR))
	IF(LOG) 
     &TMPARR(M2,2)=TMPARR(M2,2)+U(IWIG03,IG)*
     &ATOSJH(L1M2,LM3,IP(IATOM,IR))
	IF(LOG1) 
     &TMPARR(M2,3)=TMPARR(M2,3)+U(IWIG03,IG)*
     &ATOSHJ(L1M2,LM3,IP(IATOM,IR))
	TMPARR(M2,4)=TMPARR(M2,4)+U(IWIG03,IG)*
     &ATOSJJ(L1M2,LM3,IP(IATOM,IR))
      ENDDO   
      ENDDO   
	DO M1=-L1,L1                                      !!! over m1
	L1M1=LP1+M1
	MM1=L1+M1+1
	DO M2=-L1,L1                                      !!! over m2
	IWIG12=NLS1+(2*L1+1)*(L1+M2)+MM1
	IF(LOG1.AND.LOG) 
     &ATMP1(M1,M,IATOM,1)=ATMP1(M1,M,IATOM,1)+
     &CONJG(U(IWIG12,IG))*TMPARR(M2,1)*SIGNI/SIGNJ*
     &DCONJG(SJ(ISPIN1,JSPIN1,IR))*SJ(ISPIN,JSPIN,IR)
	IF(LOG) 
     &ATMP1(M1,M,IATOM,2)=ATMP1(M1,M,IATOM,2)+
     &CONJG(U(IWIG12,IG))*TMPARR(M2,2)*SIGNI/SIGNJ*
     &DCONJG(SJ(ISPIN1,JSPIN1,IR))*SJ(ISPIN,JSPIN,IR)
	IF(LOG1) 
     &ATMP1(M1,M,IATOM,3)=ATMP1(M1,M,IATOM,3)+
     &CONJG(U(IWIG12,IG))*TMPARR(M2,3)*SIGNI/SIGNJ*
     &DCONJG(SJ(ISPIN1,JSPIN1,IR))*SJ(ISPIN,JSPIN,IR)
	ATMP1(M1,M,IATOM,4)=ATMP1(M1,M,IATOM,4)+
     &CONJG(U(IWIG12,IG))*TMPARR(M2,4)*SIGNI/SIGNJ*
     &DCONJG(SJ(ISPIN1,JSPIN1,IR))*SJ(ISPIN,JSPIN,IR)
      ENDDO                                            !!! over m2
      ENDDO                                            !!! over m1
      ENDDO                                            !!! over m
      ENDDO                                            !!! over group
      ENDDO                                            !!! over atoms in cell
C NORMALIZATION
	DO IATOM=1,NATOM                                 !!! over atoms in cell
	ISORT=IS(IATOM)
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP,IPAN))LOG1=.TRUE.
	IF(L1.GT.ILST(ISORT))CYCLE
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,JKAP,IPAN))LOG=.TRUE.
	IF(L.GT.ILST(ISORT))CYCLE   
	DO M1=-L1,L1                                     !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO M=-L,L                                        !!! over m
	LM=L*(L+1)+M+1
	IF(LOG1.AND.LOG)
     &ATOSHH(L1M1,LM,IATOM)=ATMP1(M1,M,IATOM,1)/DBLE(NGROUP)
	IF(LOG)
     &ATOSJH(L1M1,LM,IATOM)=ATMP1(M1,M,IATOM,2)/DBLE(NGROUP)
	IF(LOG1)
     &ATOSHJ(L1M1,LM,IATOM)=ATMP1(M1,M,IATOM,3)/DBLE(NGROUP)
	IF(.TRUE.)
     &ATOSJJ(L1M1,LM,IATOM)=ATMP1(M1,M,IATOM,4)/DBLE(NGROUP)
      ENDDO                                           !!! over m
      ENDDO                                           !!! over m1
      ENDDO                                           !!! over atoms
      ENDDO                                           !!! over l
      ENDDO                                           !!! over l1
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	IREC=IKAP+NKAP(IPAN)*(JKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)
	READ(IUNMT,REC=IREC)
     &((ATMP2(L1M1,LM,1),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATMP2(L1M1,LM,2),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATMP2(L1M1,LM,3),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((ATMP2(L1M1,LM,4),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
	DO L1=0,ILST(ISORT)
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP,IPAN))LOG1=.TRUE.
	DO M1=-L1,L1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,JKAP,IPAN))LOG=.TRUE.
	DO M=-L,L
	LM=L*(L+1)+M+1
	IF(LOG1.AND.LOG)
     &ATMP2(L1M1,LM,1)=ATMP2(L1M1,LM,1)+ATOSHH(L1M1,LM,IATOM)
	IF(LOG)
     &ATMP2(L1M1,LM,2)=ATMP2(L1M1,LM,2)+ATOSJH(L1M1,LM,IATOM)
	IF(LOG1)
     &ATMP2(L1M1,LM,3)=ATMP2(L1M1,LM,3)+ATOSHJ(L1M1,LM,IATOM)
      IF(.TRUE.)
     &ATMP2(L1M1,LM,4)=ATMP2(L1M1,LM,4)+ATOSJJ(L1M1,LM,IATOM)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	IREC=IKAP+NKAP(IPAN)*(JKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)
	WRITE(IUNMT,REC=IREC)
     &((ATMP2(L1M1,LM,1),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATMP2(L1M1,LM,2),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATMP2(L1M1,LM,3),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((ATMP2(L1M1,LM,4),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
      ENDDO   
1000  CONTINUE                                    !!! over energies
2000  CONTINUE                                    !!! over energies
3000  CONTINUE                                    !!! over spins
4000  CONTINUE                                    !!! over iorbs
5000  CONTINUE                                    !!! over spins
6000  CONTINUE                                    !!! over iorbs
	DO IORBS=1,NORBS                            !!! over spins
	DO IUPDN=1,NSPIN                            !!! over spins
	DO IKAP=1,NKAP(IPAN)                        !!! over energies
	DO JKAP=1,NKAP(IPAN)                        !!! over energies
	DO IATOM=1,NATOM                            !!! over iatom
	ISORT=IS(IATOM)
	IREC=IKAP+NKAP(IPAN)*(JKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)
	READ(IUNMT,REC=IREC)
     &((ATOSHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((ATOSJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
	IREC=IKAP+NKAP(IPAN)*(JKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)+
     &NSHIFT
	WRITE(IUTOS,REC=IREC)
     &((ATOSHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((ATOSJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
      ENDDO                                       !!! over iatom
      ENDDO                                       !!! over jkap
      ENDDO                                       !!! over ikap
      ENDDO                                       !!! over ispin
      ENDDO                                       !!! over iorbs
7000  CONTINUE                                    !!! over panels
	CLOSE(IUNMT,STATUS='DELETE')
C SYMMETRIZE PULAY FORCE
	DO IPAN=1,NPAN                              !!! over panels
	DO ISPIN=1,NSPIN                            !!! over spins
      DO INUC=1,NATOM                             !!! over displacements
      DO MY=-1,1                                  !!! over polarizations
      PFTMP(MY,INUC,1)=(0.D0,0.D0)
      PFTMP(MY,INUC,2)=(0.D0,0.D0)
      DO IR=1,NGROUP                              !!! over crystalline group
      IG=IKOV(IR)
      DO MY1=-1,1                                 !!! over polarizations
      IWIG=6+MY+3*MY1                             !!! U(L=1,MY,MY1)
      PFTMP(MY,INUC,1)=PFTMP(MY,INUC,1)+CONJG(U(IWIG,IG))*
     &PFVAL(MY1,IP(INUC,IR),IPAN,ISPIN,1)
      PFTMP(MY,INUC,2)=PFTMP(MY,INUC,2)+CONJG(U(IWIG,IG))*
     &PFVAL(MY1,IP(INUC,IR),IPAN,ISPIN,2)
      ENDDO                                       !!! over polarizations
      ENDDO                                       !!! over crystalline group
      ENDDO                                       !!! over polarizations
      ENDDO                                       !!! over displacements
C NORMALIZATION
      DO INUC=1,NATOM                             !!! over displacements
      DO MY=-1,1                                  !!! over polarizations
      PFRE=DREAL(PFTMP(MY,INUC,1))/DBLE(NGROUP)
      PFIM=DIMAG(PFTMP(MY,INUC,1))/DBLE(NGROUP)
C     IF(ABS(PFRE).LE.1.D-10)PFRE=0.D0
C     IF(ABS(PFIM).LE.1.D-10)PFIM=0.D0
      PFVAL(MY,INUC,IPAN,ISPIN,1)=DCMPLX(PFRE,PFIM)
      PFRE=DREAL(PFTMP(MY,INUC,2))/DBLE(NGROUP)
      PFIM=DIMAG(PFTMP(MY,INUC,2))/DBLE(NGROUP)
C     IF(ABS(PFRE).LE.1.D-10)PFRE=0.D0
C     IF(ABS(PFIM).LE.1.D-10)PFIM=0.D0
      PFVAL(MY,INUC,IPAN,ISPIN,2)=DCMPLX(PFRE,PFIM)
      ENDDO                                       !!! over polarizations
      ENDDO                                       !!! over displacements
      ENDDO                                       !!! over spins
	ENDDO                                       !!! over panels
C SYMMETRIZE FOURIER TRANSFORM FOR THE PSEUDOCHARGE DENSITY
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN    
	DO IPLW=0,NPLW
	RHOPS(IPLW,IUPDN,IORBS)=(0.D0,0.D0)
      ENDDO   
      ENDDO   
      ENDDO   
	DO IPLW=0,NPLW                              !!! over iplw
C RECIPROCAL LATTICE VECTOR IS GIVEN BY
	GX=GPLW(1,IPLW)
	GY=GPLW(2,IPLW)
	GZ=GPLW(3,IPLW)
	DO IR=1,NGROUP                              !!! over point group
C APPLY SYMMETRY OPERATION        
	IG=IKOV(IR)
	CALL ROTATE(GX,GY,GZ,GRX,GRY,GRZ,U(2,IG),2)
C GET COORDINATES IN G1,G2,G3
	X1R=GRX*RBAS(1,1)+GRY*RBAS(2,1)+GRZ*RBAS(3,1)
	X2R=GRX*RBAS(1,2)+GRY*RBAS(2,2)+GRZ*RBAS(3,2)
	X3R=GRX*RBAS(1,3)+GRY*RBAS(2,3)+GRZ*RBAS(3,3)
	M1R=ANINT(X1R)
	M2R=ANINT(X2R)
	M3R=ANINT(X3R)
	IF(ABS(DBLE(M1R)-X1R).GE.1.D-04.OR.
     &   ABS(DBLE(M2R)-X2R).GE.1.D-04.OR.
     &   ABS(DBLE(M3R)-X3R).GE.1.D-04)
     &CALL FULLSTOP('<TTRINT2>: WRONG VECTOR')
	IDIM=1+M1R-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2R-KGMIN(2))+
     &(KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3R-KGMIN(3))
	IPLWR=INDG(IDIM)
	IF(IPLWR.EQ.-1)CALL FULLSTOP('<TTRINT2>:: ERROR IN IPLWR')
	SCP=GRX*SHIFT(1,IR)+GRY*SHIFT(2,IR)+GRZ*SHIFT(3,IR)
	EXPGR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
C SYMMETRIZE CHARGE DENSITY
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN    
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNI=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNI=+SQRT(2.D0) ! M^{-}=<S^{-}>=-<S_{+}>
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNI=-SQRT(2.D0) ! M^{+}=<S^{+}>=-<S_{-}>
	ENDIF
	DO JORBS=1,NORBS
	DO JUPDN=1,NSPIN
	IF(NORBS.EQ.1.AND.IUPDN.NE.JUPDN)CYCLE
	IF(JORBS.EQ.1)THEN
	JSPIN1=JUPDN
	JSPIN =JUPDN
	SIGNJ=1.D0
	ELSEIF(JORBS.EQ.2)THEN
	JSPIN1=JUPDN
	JSPIN =NSPIN+1-JUPDN
	IF(JSPIN1.EQ.1.AND.JSPIN.EQ.2)SIGNJ=+SQRT(2.D0) ! M^{-}=<S^{-}>=-<S_{+}>
	IF(JSPIN1.EQ.2.AND.JSPIN.EQ.1)SIGNJ=-SQRT(2.D0) ! M^{+}=<S^{+}>=-<S_{-}>
	ENDIF
	RHOPS(IPLW,IUPDN,IORBS)=RHOPS(IPLW,IUPDN,IORBS)+
     &RHOPN(IPLWR,JUPDN,JORBS)*EXPGR*SIGNI/SIGNJ*
     &DCONJG(SJ(ISPIN1,JSPIN1,IR))*SJ(ISPIN,JSPIN,IR)
      ENDDO                                        !!! over iupdn
      ENDDO                                        !!! over iorbs
      ENDDO                                        !!! over iupdn
      ENDDO                                        !!! over iorbs
      ENDDO                                        !!! over group
      ENDDO                                        !!! over iplw
C NORMALIZATION
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN    
	DO IPLW=0,NPLW
	RHOPS(IPLW,IUPDN,IORBS)=RHOPS(IPLW,IUPDN,IORBS)/DBLE(NGROUP)
      ENDDO   
      ENDDO                                        !!! over iupdn
      ENDDO                                        !!! over iorbs
C MEMORY DEALLOCATIONS
	DEALLOCATE(ATMP1,ATMP2,TMPARR,PFTMP)
	IF(NPLWMEM.NE.-1)THEN
      SIZE_RHOPN=DBLE(SIZE(RHOPN)*LENCMP)/1024.D0**2
	DEALLOCATE(RHOPN)
      CURMEM=CURMEM-SIZE_RHOPN
	ENDIF
	END
