	SUBROUTINE TOSPAR(IPNT,IPAN,IC)
***********************************************************
*  Calculates partial numbers-of-states matrix.           *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,IDMF,NPFR         !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS          !!! from readini
     &                      ,IS,ILST,ILSB                     !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC          !!! from readini
      USE COM_SYMMLM  ,ONLY: SYM,LMSYM                        !!! from symlmm
	USE COM_HAMPAR  ,ONLY: ATOSHH=>HPARHH                   !!! from tospar
     &                      ,ATOSJH=>HPARJH
     &                      ,ATOSHJ=>HPARHJ
     &                      ,ATOSJJ=>HPARJJ 
      USE COM_KMESH   ,ONLY: NPNT,PNT,WGT                     !!! from tetra
      USE COM_FERMI   ,ONLY: ATOS,ADOS                        !!! from ttrints
	USE COM_CHANNELS,ONLY: IUTOS,IUWFK,IUPSI                !!! from channels
      USE COM_ENERGY  ,ONLY: EARR,WEIGH,WEIGD                 !!! from bands
C SET LOCAL VARIBLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: APH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: APS(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: APJ(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: ASUM(:,:,:,:)
	LOGICAL LOG1,LOG
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C RETURN KEYS
	IF(LIFT.LE.2)RETURN
	IF(IDMF.GT.1.AND.IPAN.EQ.1)RETURN
C MEMORY ALLOCATIONS
	ALLOCATE(APH(LIMBMEM,NATOMMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(APS(LIMBMEM,NATOMMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(APJ(LIMTMEM,NATOMMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(ASUM(0:LMAXTMEM,NSORTMEM,NKAPMEM,NKAPMEM))
C START CODE
	NSHIFT=0
	DO JPAN=1,NPAN
	IF(JPAN.LT.IPAN)
     &NSHIFT=NSHIFT+NKAP(JPAN)**2*NATOM*NSPIN*NORBS
      ENDDO
      DO 2000 IORBS=1,NORBS                          !!! over iorbs
      DO 1000 IUPDN=1,NSPIN                          !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNF=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNF=+SQRT(2.D0) ! M^{-}=<S^{-}>=-<S_{+}>
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNF=-SQRT(2.D0) ! M^{+}=<S^{+}>=-<S_{-}>
	ENDIF
      DO IKAP=1,NKAP(IPAN)                           !!! over energies
      DO JKAP=1,NKAP(IPAN)                           !!! over energies
	DO IATOM=1,NATOM                               !!! over iatom
	ISORT=IS(IATOM)
	IREC=IKAP+NKAP(IPAN)*(JKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)+
     &NSHIFT
	READ(IUTOS,REC=IREC)
     &((ATOSHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((ATOSJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
      ENDDO                                          !!! over iatom
C *********** TETRAHEDRON METHOD ASSUMING FULL FILLING *****
      DO IBNDS=1,NSPIN                               !!! over spin subbands
      IF(NORBS.EQ.1.AND.IUPDN.NE.IBNDS)CYCLE
      DO IBNDT=1,NBNDF(IPAN)                         !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
C SET WEIGHT
      IF(IC.EQ.0.AND.IBNDT.GE.NBNDE(IPAN))CYCLE
      IF(IC.EQ.1.AND.IBNDT.LT.NBNDE(IPAN))CYCLE
      IF(IC.EQ.0)WHT=WGT(IPNT,IPAN)/DBLE(NSPIN)*SIGNF
      IF(IC.EQ.1)WHT=WEIGH(IBAND,IPNT)*SIGNF
C READ VARIATIONAL COEFFICIENTS
      IF(IC.EQ.0)THEN !!! called after diagonalization
      IREC=IKAP+NKAP(IPAN)*(IBNDT-1)+
     &NKAP(IPAN)*NBNDF(IPAN)*(IBNDS-1)+
     &NKAP(IPAN)*NBNDF(IPAN)*NSPIN*(ISPIN1-1)*(NORBS-1)
      READ(UNIT=IUWFK,REC=IREC)
     &((APH(LM,IATOM,IKAP,ISPIN1),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((APS(LM,IATOM,IKAP,ISPIN1),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((APJ(LM,IATOM,IKAP,ISPIN1),LM=1,(ILST(IS(IATOM))+1)**2),
     &IATOM=1,NATOM)
      IREC=JKAP+NKAP(IPAN)*(IBNDT-1)+
     &NKAP(IPAN)*NBNDF(IPAN)*(IBNDS-1)+
     &NKAP(IPAN)*NBNDF(IPAN)*NSPIN*(ISPIN-1)*(NORBS-1)
	IF(IKAP.NE.JKAP.OR.ISPIN1.NE.ISPIN)
     &READ(UNIT=IUWFK,REC=IREC)
     &((APH(LM,IATOM,JKAP,ISPIN),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((APS(LM,IATOM,JKAP,ISPIN),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((APJ(LM,IATOM,JKAP,ISPIN),LM=1,(ILST(IS(IATOM))+1)**2),
     &IATOM=1,NATOM)
      ELSEIF(IC.EQ.1.AND.IBNDT.GE.NBNDE(IPAN))THEN !!! from ttrint
      IF(IPAN.GT.1)
     &CALL FULLSTOP('<LMTBND>: RECORD FOR IPAN.GT.1 NOT ALLOWED')
      IREC=IKAP+NKAP(1)*(IBNDT-NBNDE(1))+
     &NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*(IBNDS-1)+
     &NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*(ISPIN1-1)*(NORBS-1)+
     &NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*NORBS*(IPNT-1)
      READ(IUPSI,REC=IREC)
     &((APH(LM,IATOM,IKAP,ISPIN1),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((APS(LM,IATOM,IKAP,ISPIN1),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((APJ(LM,IATOM,IKAP,ISPIN1),LM=1,(ILST(IS(IATOM))+1)**2),
     &IATOM=1,NATOM)
      IREC=JKAP+NKAP(1)*(IBNDT-NBNDE(1))+
     &NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*(IBNDS-1)+
     &NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*(ISPIN-1)*(NORBS-1)+
     &NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*NORBS*(IPNT-1)
	IF(IKAP.NE.JKAP.OR.ISPIN1.NE.ISPIN)
     &READ(IUPSI,REC=IREC)
     &((APH(LM,IATOM,JKAP,ISPIN),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((APS(LM,IATOM,JKAP,ISPIN),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((APJ(LM,IATOM,JKAP,ISPIN),LM=1,(ILST(IS(IATOM))+1)**2),
     &IATOM=1,NATOM)
      ENDIF
C COMPUTE CONTRIBUTION FROM THIS K-POINT
      DO IATOM=1,NATOM                               !!! over atoms in cell
      ISORT=IS(IATOM)
      DO L1=0,ILST(ISORT)                            !!! over l1
      LOG1=.FALSE.
      IF(LTPAN(L1,IATOM,IKAP,IPAN))LOG1=.TRUE.
      DO M1=-L1,L1                                   !!! over m1
      L1M1=L1*(L1+1)+M1+1
      DO L=0,ILST(ISORT)                             !!! over l
      LOG=.FALSE.
      IF(LTPAN(L,IATOM,JKAP,IPAN))LOG=.TRUE.
      DO M=-L,L                                      !!! over m
      LM=L*(L+1)+M+1
      IF(LOG1.AND.LOG)ATOSHH(L1M1,LM,IATOM)=ATOSHH(L1M1,LM,IATOM)+
     &CONJG(APH(L1M1,IATOM,IKAP,ISPIN1))*APH(LM,IATOM,JKAP,ISPIN)*WHT
      IF(LOG1)ATOSHJ(L1M1,LM,IATOM)=ATOSHJ(L1M1,LM,IATOM)+
     &CONJG(APH(L1M1,IATOM,IKAP,ISPIN1))*APJ(LM,IATOM,JKAP,ISPIN)*WHT
      IF(LOG)ATOSJH(L1M1,LM,IATOM)=ATOSJH(L1M1,LM,IATOM)+
     &CONJG(APJ(L1M1,IATOM,IKAP,ISPIN1))*APH(LM,IATOM,JKAP,ISPIN)*WHT
      ATOSJJ(L1M1,LM,IATOM)=ATOSJJ(L1M1,LM,IATOM)+
     &CONJG(APJ(L1M1,IATOM,IKAP,ISPIN1))*APJ(LM,IATOM,JKAP,ISPIN)*WHT
      ENDDO                                          !!! over m
      ENDDO                                          !!! over l
      ENDDO                                          !!! over m1
      ENDDO                                          !!! over l1
      ENDDO                                          !!! over atoms in cell
      ENDDO                                          !!! over valence bands
      ENDDO                                          !!! over spin subbands
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
	IREC=IKAP+NKAP(IPAN)*(JKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)+
     &NSHIFT
      WRITE(IUTOS,REC=IREC)
     &((ATOSHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((ATOSJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
      ENDDO
      ENDDO                                          !!! over energies
      ENDDO                                          !!! over energies
 1000 CONTINUE                                       !!! over iupdn
 2000 CONTINUE                                       !!! over iorbs
C CALCULATE PARTIAL NUMBER OF STATES
      DO IORBS=1,NORBS                               !!! over spinor components
      DO IBNDS=1,NSPIN                               !!! over spin subbands
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
      DO IBNDT=1,NBNDF(IPAN)                         !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
C SET WEIGHT
      IF(IC.EQ.0.AND.IBNDT.GE.NBNDE(IPAN))CYCLE
      IF(IC.EQ.1.AND.IBNDT.LT.NBNDE(IPAN))CYCLE
      IF(IC.EQ.0)WHT=WGT(IPNT,IPAN)/DBLE(NSPIN)
      IF(IC.EQ.1)WHT=WEIGH(IBAND,IPNT)
      IF(IC.EQ.0)WDT=0.D0
      IF(IC.EQ.1)WDT=WEIGD(IBAND,IPNT)
      CALL SUMSUB(ASUM,IBNDT,IBNDS,IORBS,IPNT,IPAN,IC)
      DO IKAP1=1,NKAP(IPAN)                          !!! over energies
      DO IKAP=1,NKAP(IPAN)                           !!! over energies
      DO ISORT=1,NSORT                               !!! over isort
      DO L=0,ILST(ISORT)                             !!! over l
      ADOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN)=
     &ADOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN)+
     &ASUM(L,ISORT,IKAP1,IKAP)*WDT
      DO IMOM=0,5                                    !!! over moments
      ATOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN,IMOM)=
     &ATOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN,IMOM)+
     &ASUM(L,ISORT,IKAP1,IKAP)*
     &EARR(IBAND,IPNT,IPAN)**IMOM*WHT
      ENDDO                                          !!! over moments
      ENDDO                                          !!! over l
      ENDDO                                          !!! over isort
      ENDDO                                          !!! over energies
      ENDDO                                          !!! over energies
      ENDDO                                          !!! over bands
      ENDDO                                          !!! over spin subbands
      ENDDO                                          !!! over spinor components
C MEMORY DEALLOCATIONS
	DEALLOCATE(APH,APS,APJ,ASUM)
	END SUBROUTINE TOSPAR



	SUBROUTINE NULTOS(IPAN)
******************************************************
*  Allocates main control arrays.                    *
*  Sets initial tos-matrix to zero                   *
******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,NPFR              !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS          !!! from readini
     &                      ,IS,ILST,ILSB                     !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC          !!! from readini
      USE COM_SYMMLM  ,ONLY: SYM,LMSYM                        !!! from symlmm
	USE COM_HAMPAR  ,ONLY: ATOSHH=>HPARHH                   !!! from tospar
     &                      ,ATOSJH=>HPARJH
     &                      ,ATOSHJ=>HPARHJ
     &                      ,ATOSJJ=>HPARJJ 
      USE COM_DENDAT  ,ONLY: RHOPN                            !!! from rhofull
	USE COM_ENERGY  ,ONLY: EARR,EARW,WEIGH,WEIGD            !!! from nultos
	USE COM_PLWMESH ,ONLY: NPLW                             !!! from makeplw
      USE COM_FERMI   ,ONLY: ATOS,ADOS                        !!! from ttrints
	USE COM_PULAYF  ,ONLY: PFVAL                            !!! from forces
	USE COM_LMTOUT  ,ONLY: ICSCR,SCRFILE                    !!! from readini
	USE COM_CHANNELS,ONLY: IUTOS                            !!! from channels
	USE COM_MASHDEP ,ONLY: NVAL,LENREL,LENCMP               !!! from setup
C SET LOCAL VARIBLES
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
	LOGICAL LOG1,LOG,FIRST
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
C *******************************************************
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	IF(FIRST)THEN                                 !!! for first call
	FIRST=.FALSE.
	ALLOCATE(EARR(NDIMMEM*NSPINMEM,NPNTMEM,NPANMEM))
	ALLOCATE(EARW(NDIMMEM*NSPINMEM,NPNWMEM,NPANMEM))
	ALLOCATE(WEIGH(NDIMMEM*NSPINMEM,NPNTMEM))
	ALLOCATE(WEIGD(NDIMMEM*NSPINMEM,NPNTMEM))
      SIZE_EARR=DBLE(SIZE(EARR)*LENREL)/1024.D0**2
      SIZE_WEIGH=DBLE(SIZE(WEIGH)*LENREL)/1024.D0**2
      SIZE_WEIGD=DBLE(SIZE(WEIGD)*LENREL)/1024.D0**2
      CURMEM=CURMEM+SIZE_EARR+SIZE_WEIGH+SIZE_WEIGD
	ENDIF                                         !!! for first call
	IF(IPAN.EQ.1)THEN                             !!! for panel=1
C ESTIMATE RECORD LENGHT
      NRECL=0    !!! estimate record length
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      LMAXH=((ILSB(ISORT)+1)**2+(ILST(ISORT)+1)**2)**2
      NRECL=MAX(NRECL,NVAL*LMAXH)
      ENDDO
      OPEN(UNIT=IUTOS,FILE=SCRFILE(IUTOS),STATUS='NEW',
     &ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	ALLOCATE(ATOSHH(LIMBMEM,LIMBMEM,NATOMMEM))
	ALLOCATE(ATOSJH(LIMTMEM,LIMBMEM,NATOMMEM))
	ALLOCATE(ATOSHJ(LIMBMEM,LIMTMEM,NATOMMEM))
	ALLOCATE(ATOSJJ(LIMTMEM,LIMTMEM,NATOMMEM))
      SIZE_ATOSHH=DBLE(SIZE(ATOSHH)*LENCMP)/1024.D0**2
      SIZE_ATOSJH=DBLE(SIZE(ATOSJH)*LENCMP)/1024.D0**2
      SIZE_ATOSHJ=DBLE(SIZE(ATOSHJ)*LENCMP)/1024.D0**2
      SIZE_ATOSJJ=DBLE(SIZE(ATOSJJ)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_ATOSHH+SIZE_ATOSJH+SIZE_ATOSHJ+
     &SIZE_ATOSJJ
C NEW PSEUDODENSITY
	IF(NPLWMEM.NE.-1)THEN
	ALLOCATE(RHOPN(0:NPLWMEM,NSPINMEM,NORBSMEM))
      SIZE_RHOPN=DBLE(SIZE(RHOPN)*LENCMP)/1024.D0**2
      DO IORBS=1,NORBS                               !!! over iorbs
      DO IUPDN=1,NSPIN                               !!! over spins
      DO IPLW=0,NPLW                                 !!! over iplw
      RHOPN(IPLW,IUPDN,IORBS)=(0.D0,0.D0)
      ENDDO                                          !!! over iplw
      ENDDO                                          !!! over spins
      ENDDO                                          !!! over iorbs
      CURMEM=CURMEM+SIZE_RHOPN
	ENDIF
      IF(TOTMEM.LT.CURMEM)TXTMEM='<NULTOS> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C PARTIAL TOS and DOS NUMBERS
	ALLOCATE(ATOS(0:LMAXTMEM,NSORTMEM,NKAPMEM,NKAPMEM,NPANMEM,
     &NSPINMEM,0:5))
	ALLOCATE(ADOS(0:LMAXTMEM,NSORTMEM,NKAPMEM,NKAPMEM,NPANMEM,
     &NSPINMEM))
C PULAY FORCES
	ALLOCATE(PFVAL(-1:1,NATOMMEM,NPANMEM,NSPINMEM,2))
	ENDIF                                         !!! for panel=1
C ****************************************************************
C Initialization done.
	NSHIFT=0
	DO JPAN=1,NPAN
	IF(JPAN.LT.IPAN)
     &NSHIFT=NSHIFT+NKAP(JPAN)**2*NATOM*NSPIN*NORBS
      ENDDO
C SET TOS-MATRIX TO ZERO
      DO IORBS=1,NORBS                               !!! over iorbs
      DO IUPDN=1,NSPIN                               !!! over iupdn
	DO IKAP=1,NKAP(IPAN)                           !!! over energies
	DO JKAP=1,NKAP(IPAN)                           !!! over energies
	DO IATOM=1,NATOM                               !!! over iatom
	ISORT=IS(IATOM)
	DO L1=0,ILST(ISORT)                            !!! over l1
	LOG1=.FALSE.
	IF(L1.LE.ILSB(ISORT))LOG1=.TRUE.
	DO M1=-L1,L1                                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)                             !!! over l
	LOG=.FALSE.
	IF(L.LE.ILSB(ISORT))LOG=.TRUE.
	DO M=-L,L                                      !!! over m
	LM=L*(L+1)+M+1
	IF(LOG1.AND.LOG)ATOSHH(L1M1,LM,IATOM)=(0.D0,0.D0)
	IF(LOG1)        ATOSHJ(L1M1,LM,IATOM)=(0.D0,0.D0)
	IF(LOG )        ATOSJH(L1M1,LM,IATOM)=(0.D0,0.D0)
	                ATOSJJ(L1M1,LM,IATOM)=(0.D0,0.D0)
      ENDDO                                          !!! over m
      ENDDO                                          !!! over l
      ENDDO                                          !!! over m1
      ENDDO                                          !!! over l1
      ENDDO                                          !!! over atoms
	DO IATOM=1,NATOM                               !!! over atoms
	ISORT=IS(IATOM)
	IREC=IKAP+NKAP(IPAN)*(JKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)+
     &NSHIFT
	WRITE(IUTOS,REC=IREC)
     &((ATOSHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((ATOSJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
      ENDDO                                          !!! over atoms
      ENDDO                                          !!! over energies
      ENDDO                                          !!! over energies
      ENDDO                                          !!! over ispin
      ENDDO                                          !!! over iorbs
C SET PARTIAL NUMBERS OF STATES TO ZERO
      DO ISPIN=1,NSPIN                               !!! over spins
	DO IKAP1=1,NKAP(IPAN)                          !!! over ikap
	DO IKAP=1,NKAP(IPAN)                           !!! over ikap
	DO ISORT=1,NSORT                               !!! over isort
	DO L=0,ILST(ISORT)                             !!! over l
	DO IMOM=0,5                                    !!! over moments
	ATOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN,IMOM)=(0.D0,0.D0)
      ENDDO                                          !!! over moments
	ADOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN)=(0.D0,0.D0)
      ENDDO                                          !!! over l
      ENDDO                                          !!! over isort
      ENDDO                                          !!! over ikap
      ENDDO                                          !!! over ikap1
      ENDDO                                          !!! over spins
C SET PULAY FORCES TO ZERO
      DO ISPIN=1,NSPIN                               !!! over spins
	DO INUC=1,NATOM                                !!! over displacements
	DO MY=-1,1                                     !!! over polarizations
	PFVAL(MY,INUC,IPAN,ISPIN,1)=(0.D0,0.D0)
	PFVAL(MY,INUC,IPAN,ISPIN,2)=(0.D0,0.D0)
      ENDDO                                          !!! over polarizations
      ENDDO                                          !!! over displacements
      ENDDO                                          !!! over spins
	END SUBROUTINE NULTOS
