	SUBROUTINE FTBVEC(IPNT,ISGQ,IQPNT)
************************************************************
*  Find FTB-variational coefficients A(L,g*kj)             *
*  at the point g*k of the Brillouin Zone. Find also these *
*  eigenvectors for the point g*k+q=g'*k'.                 *
************************************************************
C  SET ARRAY-SIZE DATA
      USE DIM_LMTART
C  SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                           !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,NPFR,NOVR          !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB   !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC                   !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC           !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                          !!! from tetra
      USE COM_EIGVEC  ,ONLY: APHK,APHQ                         !!! from ftbvec
      USE COM_SUBGROUP,ONLY: NSGQ,NGEQ,ISG                     !!! from delmsh
      USE COM_SYMMESH ,ONLY: IG0IG1,IK0IK1                     !!! from delmsh
      USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS           !!! from readhop
      USE COM_GROUPS  ,ONLY: NGROUP,U,SJ,IP,RDC,SHIFT,INV,IKOV !!! from groups
      USE COM_CHANNELS,ONLY: IUPSI                             !!! from readini
      USE COM_MASHDEP ,ONLY: LENCMP,NVAL                       !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                       !!! from setup
C  SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: AK(:)
	COMPLEX*16, ALLOCATABLE :: AQ(:)
	COMPLEX*16, ALLOCATABLE :: AHK(:,:,:)
	COMPLEX*16, ALLOCATABLE :: AHQ(:,:,:)
	COMPLEX*16 PHSK,PHSQ
	DATA PI/3.141592653589793D0/
C  MEMORY ALLOCATIONS
	ALLOCATE(AK(NBNDT(1)*NSPINMEM))
	ALLOCATE(AQ(NBNDT(1)*NSPINMEM))
	ALLOCATE(AHK(LIMBMEM,NATOMMEM,NSPINMEM))
	ALLOCATE(AHQ(LIMBMEM,NATOMMEM,NSPINMEM))
	ALLOCATE(APHK(LIMBMEM,NATOMMEM,NORBSMEM,NBNDT(1)*NSPINMEM,1))
	ALLOCATE(APHQ(LIMBMEM,NATOMMEM,NORBSMEM,NBNDT(1)*NSPINMEM,1))
C  SET POINT-GROUP INFORMATION
	IRK=ISG(1,ISGQ)       !!!  element "g"  in the main G-list
	IGK=IKOV(IRK)         !!!  element "g"  after Kovalev
	IPNTK=IPNT            !!!  point   "k"
	IRQ=IG0IG1(IPNT,IRK)  !!!  element "g'" in the main G-list
	IGQ=IKOV(IRQ)         !!!  element "g'" after Kovalev
	IPNTQ=IK0IK1(IPNT,IRK)!!!  point   "k'" such that g*k+q=g'*k'
C  **** ROTATE EIGENVECTORS AFTER APPLYING POINT-GROUP OPERATIONS ****
	DO 2000 IBNDS=1,NSPIN                         !!! over spin subbands
      DO 1000 IBNDT=1,NBNDT(1)                      !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
C  READ EIGENVECTORS FOR THE POINT "K"
	DO IORBS=1,NORBS
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
      IREC=IBNDT+NBNDT(1)*(IBNDS-1)+NBNDT(1)*NSPIN*
     &(ISPIN-1)*(NORBS-1)+NBNDT(1)*NSPIN*NORBS*(IPNTK-1)
      READ(IUPSI,REC=IREC)
     &(AK(IDIM+NTBAS*(ISPIN-1)),IDIM=1,NTBAS)
C  READ EIGENVECTORS FOR THE POINT "K+Q"
      IREC=IBNDT+NBNDT(1)*(IBNDS-1)+NBNDT(1)*NSPIN*
     &(ISPIN-1)*(NORBS-1)+NBNDT(1)*NSPIN*NORBS*(IPNTQ-1)
      READ(IUPSI,REC=IREC)
     &(AQ(IDIM+NTBAS*(ISPIN-1)),IDIM=1,NTBAS)
	ENDDO
	DO IORBS=1,NORBS
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)
      DO M=-L,L
      LM=L*(L+1)+M+1
      IDIM=INBAS(LM,IATOM)
      AHK(LM,IATOM,ISPIN)=(0.D0,0.D0)
      AHQ(LM,IATOM,ISPIN)=(0.D0,0.D0)
      IF(.NOT.LTBAS(L,IATOM))CYCLE
      AHK(LM,IATOM,ISPIN)=AK(IDIM+NTBAS*(ISPIN-1))
      AHQ(LM,IATOM,ISPIN)=AQ(IDIM+NTBAS*(ISPIN-1))
      ENDDO
      ENDDO
      ENDDO
	ENDDO
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	SK=PNT(1,IPNTK,1)*RDC(1,IATOM,IRK)+
     &   PNT(2,IPNTK,1)*RDC(2,IATOM,IRK)+
     &   PNT(3,IPNTK,1)*RDC(3,IATOM,IRK)
	SQ=PNT(1,IPNTQ,1)*RDC(1,IATOM,IRQ)+
     &   PNT(2,IPNTQ,1)*RDC(2,IATOM,IRQ)+
     &   PNT(3,IPNTQ,1)*RDC(3,IATOM,IRQ)
	PHSK=EXP(2.D0*PI*SK*(0.D0,1.D0))
	PHSQ=EXP(2.D0*PI*SQ*(0.D0,1.D0))
	DO IORBS=1,NORBS
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
	DO L=0,ILSB(ISORT)                            !!! over l
	LL=L*(2*L-1)*(2*L+1)/3
	DO M=-L,L                                     !!! over m
	LM=L*(L+1)+M+1
      APHK(LM,IATOM,IORBS,IBAND,1)=(0.D0,0.D0)
      APHQ(LM,IATOM,IORBS,IBAND,1)=(0.D0,0.D0)
	IF(.NOT.LTBAS(L,IATOM))CYCLE
	DO IORBS1=1,NORBS
      IF(NORBS.EQ.1)ISPIN1=IBNDS
      IF(NORBS.EQ.2)ISPIN1=IORBS1
C  ROTATE EIGENVECTORS FROM THE POINT "K" TO THE POINT "G*K"
	DO M1=-L,L                                    !!! over m1
	LM1=L*(L+1)+M1+1
	IWIG01=LL+(2*L+1)*(L+M1)+L+M+1
      APHK(LM,IATOM,IORBS,IBAND,1)=
     &APHK(LM,IATOM,IORBS,IBAND,1)+
     &U(IWIG01,IGK)*SJ(ISPIN,ISPIN1,IRK)*
     &AHK(LM1,IP(IATOM,IRK),ISPIN1)*PHSK
      ENDDO                                         !!! over m1
C  ROTATE EIGENVECTORS FROM THE POINT "K'" TO THE POINT "G'*K'=G*K+Q"
	DO M1=-L,L                                    !!! over m1
	LM1=L*(L+1)+M1+1
	IWIG01=LL+(2*L+1)*(L+M1)+L+M+1
      APHQ(LM,IATOM,IORBS,IBAND,1)=
     &APHQ(LM,IATOM,IORBS,IBAND,1)+
     &U(IWIG01,IGQ)*SJ(ISPIN,ISPIN1,IRQ)*
     &AHQ(LM1,IP(IATOM,IRQ),ISPIN1)*PHSQ
      ENDDO                                         !!! over m1
      ENDDO                                         !!! over spins
      ENDDO                                         !!! over m
      ENDDO                                         !!! over l
      ENDDO                                         !!! over spins
      ENDDO                                         !!! over atoms
1000	CONTINUE                                      !!! over bands
2000	CONTINUE                                      !!! over spin subbands
C MEMORY DEALLOCATIONS
	DEALLOCATE(AK,AQ,AHK,AHQ)
	END
