	SUBROUTINE INTCHI(IPNT,ISGQ,IQPNT,IOMG)
***********************************************************
*  Calculate susceptibility                               *
***********************************************************
C SET ARRAY-SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                           !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,NPFR,NOVR          !!! from readini
	USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB   !!! from readini
	USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC                   !!! from readini
	USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS           !!! from readhop
	USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC,POLUS     !!! from readini
	USE COM_KMESH   ,ONLY: NPNT,PNT,WGT                      !!! from tetra
	USE COM_EIGVEC  ,ONLY: APHK,APHQ                         !!! from ftbvec
	USE COM_SUBGROUP,ONLY: NSGQ,NGEQ,ISG                     !!! from delmsh
	USE COM_SYMMESH ,ONLY: IG0IG1,IK0IK1                     !!! from delmsh
	USE COM_GROUPS  ,ONLY: NGROUP,U,IP,RDC,SHIFT,INV,IKOV    !!! from groups
	USE COM_CHIMAT  ,ONLY: NREP,NCHI,INCHI,CHI0              !!! from intchi
	USE COM_ENERGY  ,ONLY: EARR,WEIGH,WEIGD                  !!! from bands
	USE COM_QMESH   ,ONLY: NQPNT,QPNT                        !!! from tetra
	USE COM_FREQU   ,ONLY: NOMGCHI,OMGCHI                    !!! from tetra
	USE COM_MASHDEP ,ONLY: LENCMP,NVAL                       !!! from readini
	USE COM_CHANNELS,ONLY: IUCHI                             !!! from channels
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                   !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: WEIGK(:,:)
	REAL*8, ALLOCATABLE :: WEIGQ(:,:,:)
	REAL*8, ALLOCATABLE :: WGTOM(:,:,:)
	COMPLEX*16, ALLOCATABLE :: APH(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: SPH(:,:,:,:,:)
	COMPLEX*16 WTR1,WTR2,WTI1,WTI2
	DATA PI/3.141592653589793D0/
C MEMORY ALLOCATIONS
	ALLOCATE(WEIGK(NBNDC(1)*NSPINMEM,4))
	ALLOCATE(WEIGQ(NBNDC(1)*NSPINMEM,NBNDC(1)*NSPINMEM,6))
	ALLOCATE(WGTOM(NBNDC(1)*NSPINMEM,NBNDC(1)*NSPINMEM,4))
	ALLOCATE(APH(LIMBMEM,NATOMMEM,NORBSMEM,NBNDT(1)*NSPIN,2))
	ALLOCATE(SPH(LIMBMEM,NATOMMEM,NORBSMEM,NBNDT(1)*NSPIN,2))
C  SET POINT-GROUP INFORMATION
	IRK=ISG(1,ISGQ)       !!!  element "g"  in the main G-list
	IGK=IKOV(IRK)         !!!  element "g"  after Kovalev
	IPNTK=IPNT            !!!  point   "k"
	IRQ=IG0IG1(IPNT,IRK)  !!!  element "g'" in the main G-list
	IGQ=IKOV(IRQ)         !!!  element "g'" after Kovalev
	IPNTQ=IK0IK1(IPNT,IRK)!!!  point   "k'" such that g*k+q=g'*k'
C  READ 1/E TETRAHEDRON WEIGHTS FOR BRILLOUIN ZONE INTEGRATION
	IREC=1+IPNTK+NPNT(1)*(ISGQ-1)
	READ(40,REC=IREC)WGTQ1,(((WEIGQ(IBANC,IBANC1,IC),
     &  IBANC=1,NBNDC(1)*NSPIN),IBANC1=1,NBNDC(1)*NSPIN),
     &  IC=1,6),((WEIGK(IBANC,IC),IBANC=1,NBNDC(1)*NSPIN),
     &  IC=1,4),(((WGTOM(IBANC,IBANC1,IC),IBANC=1,
     &  NBNDC(1)*NSPIN),IBANC1=1,NBNDC(1)*NSPIN),IC=1,4)
C ***** DO GLOBALLY OVER SPINORS ********
	DO 5000 IUPDN4=1,NSPIN                          !!! over spinors
	IF(NORBS.EQ.2)IORBS4=IUPDN4
	IF(NORBS.EQ.1)IORBS4=1
	DO 4000 IUPDN3=1,NSPIN                          !!! over spinors
	IF(NORBS.EQ.2)IORBS3=IUPDN3
	IF(NORBS.EQ.1)IORBS3=1
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
	    IF(IUPDN4.EQ.1.AND.IUPDN3.EQ.1)THEN
	ISPIN1=1
	ITRAN1=0
	SIGNF1=1.D0
	ELSEIF(IUPDN4.EQ.2.AND.IUPDN3.EQ.2)THEN
	ISPIN1=2
	ITRAN1=0
	SIGNF1=1.D0
	ELSEIF(IUPDN4.EQ.1.AND.IUPDN3.EQ.2)THEN
	ISPIN1=0
	ITRAN1=1
	SIGNF1=+SQRT(2.D0)
	ELSEIF(IUPDN4.EQ.2.AND.IUPDN3.EQ.1)THEN
	ISPIN1=0
	ITRAN1=2
	SIGNF1=-SQRT(2.D0)
	ENDIF
	DO 3000 IUPDN2=1,NSPIN                          !!! over spinors
	IF(NORBS.EQ.2)IORBS2=IUPDN2
	IF(NORBS.EQ.1)IORBS2=1
	DO 2000 IUPDN1=1,NSPIN                          !!! over spinors
	IF(NORBS.EQ.2)IORBS1=IUPDN1
	IF(NORBS.EQ.1)IORBS1=1
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
	    IF(IUPDN2.EQ.1.AND.IUPDN1.EQ.1)THEN
	IF(NORBS.EQ.1.AND.ITRAN1.NE.0)GOTO2000
	ISPIN=1
	ITRAN=0
	SIGNF=1.D0
	ELSEIF(IUPDN2.EQ.2.AND.IUPDN1.EQ.2)THEN
	IF(NORBS.EQ.1.AND.ITRAN1.NE.0)GOTO2000
	ISPIN=2
	ITRAN=0
	SIGNF=1.D0
	ELSEIF(IUPDN2.EQ.1.AND.IUPDN1.EQ.2)THEN
	IF(NORBS.EQ.1.AND.ITRAN1.NE.2)GOTO2000
	ISPIN=0
	ITRAN=1
	SIGNF=+SQRT(2.D0)
	ELSEIF(IUPDN2.EQ.2.AND.IUPDN1.EQ.1)THEN
	IF(NORBS.EQ.1.AND.ITRAN1.NE.1)GOTO2000
	ISPIN=0
	ITRAN=2
	SIGNF=-SQRT(2.D0)
	ENDIF
C READ SUSCEPTIBILITY
	CALL CHIFILES(ISPIN,ITRAN,ISPIN1,ITRAN1,IQPNT,IOMG,IUCHI,'R')
C COMPUTE CONTRIBUTION FROM THIS K-POINT
	DO 1700 IREP1=1,NREP                           !!! over irep1
	IF4=IREP1-2*(IREP1/3)
	IF3=IREP1-IREP1/2
	DO 1600 IREP =1,NREP                           !!! over irep
	IF2=IREP-2*(IREP/3)
	IF1=IREP-IREP/2
	DO 1500 IATOM1=1,NATOM                         !!! over iatom1
	ISORT1=IS(IATOM1)
	DO 1400 L4=0,ILSB(ISORT1)                      !!! over l4
	IF(.NOT.LTBAS(L4,IATOM1))CYCLE
	DO 1300 M4=-L4,L4                              !!! over m4
	L4M4=L4*(L4+1)+M4+1
	DO 1200 L3=0,ILSB(ISORT1)                      !!! over l3
	IF(.NOT.LTBAS(L3,IATOM1))CYCLE
	DO 1100 M3=-L3,L3                              !!! over m3
	L3M3=L3*(L3+1)+M3+1
C  **** FIND WEIHTS
	DO IBNDS=1,NSPIN                               !!! over spin subbands
	DO IBNDT=1,NBNDF(1)                            !!! over filled bands
	IBNDC=IBNDT-NBNDE(1)+1
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
C  CALCULATE CONVOLUTIONS OVER BANDS
	DO IATOM=1,NATOM                               !!! over atoms
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                             !!! over l
	DO M=-L,L                                      !!! over m
	LM=L*(L+1)+M+1
	APH(LM,IATOM,IORBS3,IBAND,1)=(0.D0,0.D0)
	SPH(LM,IATOM,IORBS4,IBAND,1)=(0.D0,0.D0)
	APH(LM,IATOM,IORBS3,IBAND,2)=(0.D0,0.D0)
	SPH(LM,IATOM,IORBS4,IBAND,2)=(0.D0,0.D0)
	IF(.NOT.LTBAS(L,IATOM))CYCLE
C  1) CALCULATE CONTRIBUTION FROM UNOCCUPIED STATES
	DO IBNDS1=1,NSPIN                              !!! over spin subbands
	DO IBNDT1=NBNDE(1),NBNDT(1)                    !!! over empty bands
	IBNDC1=IBNDT1-NBNDE(1)+1
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
C  FOR THE FERMI SURFACE BANDS
	IF(IBNDT.GE.NBNDE(1).AND.IBNDT1.LE.NBNDF(1))THEN
	DEK1=OMGCHI(IOMG)+EARR(IBAND,IPNTK,1)-EARR(IBAND1,IPNTQ,1)
	DEK2=OMGCHI(IOMG)+EARR(IBAND1,IPNTK,1)-EARR(IBAND,IPNTQ,1)
C  1/E TETRAHEDRON WEIGHTS
 	WQ1=    WEIGQ(IBANC,IBANC1,1) !!! f(kj)*[1-f(k+qj')]/[E(kj)-E(k+qj')]
 	WQ2=    WEIGQ(IBANC1,IBANC,2) !!! [1-f(kj')]*f(k+qj)/[E(kj')-E(k+qj)]
C  WEIGHTS FROM DENSITY-OF-STATES AT EF 
 	WQ1=WQ1+WEIGQ(IBANC,IBANC1,3) !!! +0.5*Delta[E(kj )-Ef]
 	WQ2=WQ2+WEIGQ(IBANC1,IBANC,4) !!! -0.5*Delta[E(kj')-Ef]
C  WEIGHTS FROM LORENTZIAN SMEARING
	WQ1=WQ1+WEIGK(IBANC,1)*DEK1/(DEK1**2+POLUS**2) !!! f(kj)
	WQ2=WQ2+WEIGK(IBANC,2)*DEK2/(DEK2**2+POLUS**2) !!! f(k+qj')
 	WQ1=WQ1-WEIGQ(IBANC,IBANC1,5) !!! f(kj)*[1-f(k+qj')]/[E(kj)-E(k+qj')]
 	WQ2=WQ2-WEIGQ(IBANC1,IBANC,6) !!! [1-f(kj')]*f(k+qj)/[E(kj')-E(k+qj)]
C  WEIGHTS FROM THE IMAGINARY PART
	WI1=-PI*WGTOM(IBANC,IBANC1,1) !!! (f(kj)-f(k+qj')*d(E(kj)-E(k+qj')+Omega)
	WI2=0.D0                      !!! (f(kj')-f(k+qj)*d(E(kj')-E(k+qj)+Omega)
C  OTHERWISE, USUAL TETRAHEDRON WEIGHTS
	ELSEIF(IBNDT.GE.NBNDE(1).AND.IBNDT1.GT.NBNDF(1))THEN
	DEK1=OMGCHI(IOMG)+EARR(IBAND,IPNTK,1)-EARR(IBAND1,IPNTQ,1)
	DEK2=OMGCHI(IOMG)+EARR(IBAND1,IPNTK,1)-EARR(IBAND,IPNTQ,1)
		IF(ABS(DEK1).LE.1.D-10)THEN
		IF(ABS(WEIGK(IBANC,1)).GE.1.D-10)
     &  	WRITE(IUT,*)'<INTCHI> :: ERROR IN WEIGHTS'
		WEIGK(IBANC,1)=0.D0
		DEK1=1.D0
		ENDIF
		IF(ABS(DEK2).LE.1.D-10)THEN
		IF(ABS(WEIGK(IBANC,2)).GE.1.D-10)
     &  	WRITE(IUT,*)'<INTCHI> :: ERROR IN WEIGHTS'
		WEIGK(IBANC,2)=0.D0
		DEK2=1.D0
		ENDIF
	WQ1=WEIGK(IBANC,1)/DEK1     !!! f(kj)  /[E(kj)-E(k+qj')]
	WQ2=WEIGK(IBANC,2)/DEK2     !!! f(k+qj)/[E(kj')-E(k+qj)]
	WI1=0.D0
	WI2=0.D0
	ELSEIF(IBNDT.LT.NBNDE(1).AND.IBNDT1.LE.NBNDF(1))THEN
	DEK1=OMGCHI(IOMG)+EARR(IBAND,IPNTK,1)-EARR(IBAND1,IPNTQ,1)
	DEK2=OMGCHI(IOMG)+EARR(IBAND1,IPNTK,1)-EARR(IBAND,IPNTQ,1)
		IF(ABS(DEK1).LE.1.D-10)THEN
		IF(ABS(WGTQ1-WEIGK(IBANC1,2)).GE.1.D-10)
     &  	WRITE(IUT,*)'<INTCHI> :: ERROR IN WEIGHTS'
		WEIGK(IBANC1,2)=WGTQ1
		DEK1=1.D0
		ENDIF
		IF(ABS(DEK2).LE.1.D-10)THEN
		IF(ABS(WGTQ1-WEIGK(IBANC1,1)).GE.1.D-10)
     &  	WRITE(IUT,*)'<INTCHI> :: ERROR IN WEIGHTS'
		WEIGK(IBANC1,1)=WGTQ1
		DEK1=1.D0
		ENDIF
	WQ1=(WGTQ1-WEIGK(IBANC1,2))/DEK1 !!! [1-f(k+qj')]/[E(kj)-E(k+qj')]
	WQ2=(WGTQ1-WEIGK(IBANC1,1))/DEK2 !!! [1-f(kj')  ]/[E(kj')-E(k+qj)]
	WI1=0.D0
	WI2=0.D0
	ELSEIF(IBNDT.LT.NBNDE(1).AND.IBNDT1.GT.NBNDF(1))THEN
	DEK1=OMGCHI(IOMG)+EARR(IBAND,IPNTK,1)-EARR(IBAND1,IPNTQ,1)
	DEK2=OMGCHI(IOMG)+EARR(IBAND1,IPNTK,1)-EARR(IBAND,IPNTQ,1)
	WQ1=WGTQ1/DEK1              !!! 1/[E(kj)-E(k+qj')]
	WQ2=WGTQ1/DEK2              !!! 1/[E(kj')-E(k+qj)]
	WI1=0.D0
	WI2=0.D0
	ENDIF
C  SET TOTAL COMPLEX WEIGHT
	WTR1=DCMPLX(WQ1,0.D0)
	WTR2=DCMPLX(WQ2,0.D0)
C  COMPUTE IMAGINARY PART ONLY
 	WTI1=DCMPLX(WI1,0.D0)
 	WTI2=DCMPLX(WI2,0.D0)
C  SET UP CONTRIBUTION
        IF((IUPDN1.EQ.IBNDS1.AND.IUPDN4.EQ.IBNDS1.AND.
     &      IUPDN3.EQ.IBNDS.AND.NORBS.EQ.1).OR.NORBS.EQ.2)THEN
        APH(LM,IATOM,IORBS3,IBAND,1)=APH(LM,IATOM,IORBS3,IBAND,1)+
     &  APHQ(LM,IATOM,IORBS1,IBAND1,IF1)*
     &  CONJG(APHQ(L4M4,IATOM1,IORBS4,IBAND1,IF4))*
     &  APHK(L3M3,IATOM1,IORBS3,IBAND,IF3)*SIGNF1*SIGNF*WTR1
        APH(LM,IATOM,IORBS3,IBAND,2)=APH(LM,IATOM,IORBS3,IBAND,2)+
     &  APHQ(LM,IATOM,IORBS1,IBAND1,IF1)*
     &  CONJG(APHQ(L4M4,IATOM1,IORBS4,IBAND1,IF4))*
     &  APHK(L3M3,IATOM1,IORBS3,IBAND,IF3)*SIGNF1*SIGNF*WTI1
	ENDIF
        IF((IUPDN2.EQ.IBNDS1.AND.IUPDN4.EQ.IBNDS.AND.
     &      IUPDN3.EQ.IBNDS1.AND.NORBS.EQ.1).OR.NORBS.EQ.2)THEN
       	SPH(LM,IATOM,IORBS4,IBAND,1)=SPH(LM,IATOM,IORBS4,IBAND,1)+
     &  CONJG(APHK(LM,IATOM,IORBS2,IBAND1,IF2))*
     &  CONJG(APHQ(L4M4,IATOM1,IORBS4,IBAND,IF4))*
     &  APHK(L3M3,IATOM1,IORBS3,IBAND1,IF3)*SIGNF1*SIGNF*WTR2
       	SPH(LM,IATOM,IORBS4,IBAND,2)=SPH(LM,IATOM,IORBS4,IBAND,2)+
     &  CONJG(APHK(LM,IATOM,IORBS2,IBAND1,IF2))*
     &  CONJG(APHQ(L4M4,IATOM1,IORBS4,IBAND,IF4))*
     &  APHK(L3M3,IATOM1,IORBS3,IBAND1,IF3)*SIGNF1*SIGNF*WTI2
	ENDIF
	ENDDO                                          !!! over all bands
	ENDDO                                          !!! over spin subbands
	ENDDO                                          !!! over m
	ENDDO                                          !!! over l
	ENDDO                                          !!! over iatom
	ENDDO                                          !!! over filled bands
	ENDDO                                          !!! over spin subbands
C  CALCULATE CONTRIBUTION FROM THIS K-POINT TO SUSCEPTIBILITY
	DO IBNDS=1,NSPIN                               !!! over spin subbands
	DO IBNDT=1,NBNDF(1)                            !!! over filled bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IATOM=1,NATOM                               !!! over iatom
	ISORT=IS(IATOM)
	DO L2=0,ILSB(ISORT)                            !!! over l2
	IF(.NOT.LTBAS(L2,IATOM))CYCLE
	DO M2=-L2,L2                                   !!! over m2
	L2M2=L2*(L2+1)+M2+1
	DO L1=0,ILSB(ISORT)                            !!! over l1
	IF(.NOT.LTBAS(L1,IATOM))CYCLE
	DO M1=-L1,L1                                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
        ICHI21=INCHI(L2M2,L1M1,IATOM)
        ICHI43=INCHI(L4M4,L3M3,IATOM1)
        IF((IUPDN2.EQ.IBNDS.AND.IUPDN3.EQ.IBNDS.AND.NORBS.EQ.1).OR.
     &  NORBS.EQ.2)THEN
        CHI0(ICHI21,ICHI43,IREP,IREP1,1)=
     &  CHI0(ICHI21,ICHI43,IREP,IREP1,1)+
     &  CONJG(APHK(L2M2,IATOM,IORBS2,IBAND,IF2))*
     &  APH(L1M1,IATOM,IORBS3,IBAND,1)
        CHI0(ICHI21,ICHI43,IREP,IREP1,2)=
     &  CHI0(ICHI21,ICHI43,IREP,IREP1,2)+
     &  CONJG(APHK(L2M2,IATOM,IORBS2,IBAND,IF2))*
     &  APH(L1M1,IATOM,IORBS3,IBAND,2)
	ENDIF
        IF((IUPDN1.EQ.IBNDS.AND.IUPDN4.EQ.IBNDS.AND.NORBS.EQ.1).OR.
     &  NORBS.EQ.2)THEN
        CHI0(ICHI21,ICHI43,IREP,IREP1,1)=
     &  CHI0(ICHI21,ICHI43,IREP,IREP1,1)-
     &  SPH(L2M2,IATOM,IORBS4,IBAND,1)*
     &  APHQ(L1M1,IATOM,IORBS1,IBAND,IF1)
        CHI0(ICHI21,ICHI43,IREP,IREP1,2)=
     &  CHI0(ICHI21,ICHI43,IREP,IREP1,2)-
     &  SPH(L2M2,IATOM,IORBS4,IBAND,2)*
     &  APHQ(L1M1,IATOM,IORBS1,IBAND,IF1)
	ENDIF
	ENDDO                                          !!! over m1
	ENDDO                                          !!! over l1
	ENDDO                                          !!! over m2
	ENDDO                                          !!! over l2
	ENDDO                                          !!! over iatom
	ENDDO                                          !!! over filled bands
	ENDDO                                          !!! over spin subbands
1100	CONTINUE                                       !!! over m3
1200	CONTINUE                                       !!! over l3
1300	CONTINUE                                       !!! over m4
1400	CONTINUE                                       !!! over l4
1500	CONTINUE                                       !!! over iatom1
1600	CONTINUE                                       !!! over irep
1700	CONTINUE                                       !!! over irep1
	CALL CHIFILES(ISPIN,ITRAN,ISPIN1,ITRAN1,IQPNT,IOMG,IUCHI,'W')
2000	CONTINUE                                       !!! over spinors
3000	CONTINUE                                       !!! over spinors
4000	CONTINUE                                       !!! over spinors
5000	CONTINUE                                       !!! over spinors
        SIZE_APHK=DBLE(SIZE(APHK)*LENCMP)/1024.D0**2
        CURMEM=CURMEM-2.D0*SIZE_APHK
	DEALLOCATE(WEIGK,WEIGQ,WGTOM,APH,SPH)
	DEALLOCATE(APHK,APHQ)
	RETURN
	END




	SUBROUTINE CHIFILES(ISPIN,ITRAN,ISPIN1,ITRAN1,
     &           IQPNT,IOMG,ICHN,TOPER)
***********************************************************
*  Reads/writes susceptibility matrices.                  *
***********************************************************
C SET ARRAY-SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                        !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO                      !!! from readini
	USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB!!! from readini
	USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS        !!! from readhop
	USE COM_CHIMAT  ,ONLY: NREP,NCHI,CHI0                 !!! from intchi
	USE COM_QMESH   ,ONLY: NQPNT,QPNT                     !!! from tetra
	USE COM_FREQU   ,ONLY: NOMGCHI                        !!! from tetra
	USE COM_LMTOUT  ,ONLY: SCRFILE                        !!! from readini
	USE COM_MASHDEP ,ONLY: LENCMP,NVAL                    !!! from readini
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL EXIST
	CHARACTER TOPER*1,STATUS*3,NFILE*130
	DATA PI/3.141592653589793D0/
C SCRATCH FILE FOR STORING SUSCEPTIBILITY
	NRECL=NVAL*NCHI*NCHI*NREP*NREP*2
	NFILE=SCRFILE(ICHN)
	INQUIRE(FILE=NFILE,EXIST=EXIST)
	IF(.NOT.EXIST)STATUS='NEW'
	IF(     EXIST)STATUS='OLD'
C DELETE FILE
	IF(TOPER.EQ.'D')THEN
	NRECL=4
	OPEN(UNIT=ICHN,FILE=NFILE,STATUS=STATUS,FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL)
	CLOSE(UNIT=ICHN,STATUS='DELETE')
	RETURN
	ENDIF
	OPEN(UNIT=ICHN,FILE=NFILE,STATUS=STATUS,ACCESS='DIRECT',
     &  FORM='UNFORMATTED',RECL=NRECL)
C READ/WRITE ACCORDING TO <<TOPER>>
	IF(ISPIN1.NE.0.AND.ITRAN1.EQ.0)IND1=ISPIN1
	IF(ISPIN1.EQ.0.AND.ITRAN1.NE.0)IND1=ITRAN1+NSPIN
	IF(ISPIN .NE.0.AND.ITRAN .EQ.0)IND =ISPIN
	IF(ISPIN .EQ.0.AND.ITRAN .NE.0)IND =ITRAN +NSPIN
	IREC=IND+NSPIN**2*(IND1-1)+NSPIN**4*(IOMG-0)+
     &         NSPIN**4*(NOMGCHI+1)*(IQPNT-1)
	IF(TOPER.EQ.'R')
     &  READ(ICHN,REC=IREC)(((((CHI0(ICHI,ICHI1,IREP,IREP1,I),
     &  ICHI=1,NCHI),ICHI1=1,NCHI),IREP=1,NREP),IREP1=1,NREP),I=1,2)
	IF(TOPER.EQ.'W')
     &  WRITE(ICHN,REC=IREC)(((((CHI0(ICHI,ICHI1,IREP,IREP1,I),
     &  ICHI=1,NCHI),ICHI1=1,NCHI),IREP=1,NREP),IREP1=1,NREP),I=1,2)
	CLOSE(ICHN)
        RETURN
	END


 
	SUBROUTINE NULCHI(IQPNT,IOMG)
***********************************************************
*  Initialize susceptibility                              *
***********************************************************
C  SET ARRAY-SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                        !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO                      !!! from readini
	USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB!!! from readini
	USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS        !!! from readhop
	USE COM_CHIMAT  ,ONLY: NREP,NCHI,INCHI,CHI0           !!! from intchi
	USE COM_CHANNELS,ONLY: IUCHI                          !!! from channels
        USE COM_MASHDEP ,ONLY: NVAL,LENCMP                    !!! from setup
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	DATA PI/3.141592653589793D0/
C MEMORY ALLOCATIONS
	IF(.NOT.ALLOCATED(INCHI))
     &  ALLOCATE(INCHI(LIMBMEM,LIMBMEM,NATOMMEM))
	ICHI=0
	DO IATOM=1,NATOM                                  !!! over atoms
	ISORT=IS(IATOM)
	DO L2=0,ILSB(ISORT)                               !!! over l2
	IF(.NOT.LTBAS(L2,IATOM))CYCLE
	DO M2=-L2,L2                                      !!! over m2
	L2M2=L2*(L2+1)+M2+1
	DO L1=0,ILSB(ISORT)                               !!! over l1
	IF(.NOT.LTBAS(L1,IATOM))CYCLE
	DO M1=-L1,L1                                      !!! over m1
	L1M1=L1*(L1+1)+M1+1
	ICHI=ICHI+1
	INCHI(L2M2,L1M1,IATOM)=ICHI
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over l1
	ENDDO                                             !!! over m2
	ENDDO                                             !!! over l2
	ENDDO                                             !!! over atoms
C MEMORY ALLOCATION FOR SUSCEPTIBILITY
	NCHI=ICHI
	NCHIMEM=NCHI
	IF(.NOT.ALLOCATED(CHI0))
     &  ALLOCATE(CHI0(NCHIMEM,NCHIMEM,NREP,NREP,2))
        SIZE_CHI0=DBLE(SIZE(CHI0)*LENCMP)/1024.D0**2
        CURMEM=CURMEM+SIZE_CHI0
        IF(TOTMEM.LT.CURMEM)TXTMEM='<INTCHI> Subroutine'
        IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C ZEROISE SUSCEPTIBILITY
	DO 4000 IUPDN4=1,NSPIN                          !!! over spinors
	IF(NORBS.EQ.2)IORBS4=IUPDN4
	IF(NORBS.EQ.1)IORBS4=1
	DO 3000 IUPDN3=1,NSPIN                          !!! over spinors
	IF(NORBS.EQ.2)IORBS3=IUPDN3
	IF(NORBS.EQ.1)IORBS3=1
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
	    IF(IUPDN4.EQ.1.AND.IUPDN3.EQ.1)THEN
	ISPIN1=1
	ITRAN1=0
	SIGNF1=1.D0
	ELSEIF(IUPDN4.EQ.2.AND.IUPDN3.EQ.2)THEN
	ISPIN1=2
	ITRAN1=0
	SIGNF1=1.D0
	ELSEIF(IUPDN4.EQ.1.AND.IUPDN3.EQ.2)THEN
	ISPIN1=0
	ITRAN1=1
	SIGNF1=+SQRT(2.D0)
	ELSEIF(IUPDN4.EQ.2.AND.IUPDN3.EQ.1)THEN
	ISPIN1=0
	ITRAN1=2
	SIGNF1=-SQRT(2.D0)
	ENDIF
	DO 2000 IUPDN2=1,NSPIN                          !!! over spinors
	IF(NORBS.EQ.2)IORBS2=IUPDN2
	IF(NORBS.EQ.1)IORBS2=1
	DO 1000 IUPDN1=1,NSPIN                          !!! over spinors
	IF(NORBS.EQ.2)IORBS1=IUPDN1
	IF(NORBS.EQ.1)IORBS1=1
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
	    IF(IUPDN2.EQ.1.AND.IUPDN1.EQ.1)THEN
	ISPIN=1
	ITRAN=0
	SIGNF=1.D0
	ELSEIF(IUPDN2.EQ.2.AND.IUPDN1.EQ.2)THEN
	ISPIN=2
	ITRAN=0
	SIGNF=1.D0
	ELSEIF(IUPDN2.EQ.1.AND.IUPDN1.EQ.2)THEN
	ISPIN=0
	ITRAN=1
	SIGNF=+SQRT(2.D0)
	ELSEIF(IUPDN2.EQ.2.AND.IUPDN1.EQ.1)THEN
	ISPIN=0
	ITRAN=2
	SIGNF=-SQRT(2.D0)
	ENDIF
C SET CHI(q,w)=0
	DO 200 IREP1=1,NREP                               !!! over reps
	DO 100 IREP =1,NREP                               !!! over reps
	DO IATOM1=1,NATOM                                 !!! over atoms
	ISORT1=IS(IATOM1)
	DO L4=0,ILSB(ISORT1)                              !!! over l4
	IF(.NOT.LTBAS(L4,IATOM1))CYCLE
	DO M4=-L4,L4                                      !!! over m4
	L4M4=L4*(L4+1)+M4+1
	DO L3=0,ILSB(ISORT1)                              !!! over l3
	IF(.NOT.LTBAS(L3,IATOM1))CYCLE
	DO M3=-L3,L3                                      !!! over m3
	L3M3=L3*(L3+1)+M3+1
	DO IATOM=1,NATOM                                  !!! over atoms
	ISORT=IS(IATOM)
	DO L2=0,ILSB(ISORT)                               !!! over l2
	IF(.NOT.LTBAS(L2,IATOM))CYCLE
	DO M2=-L2,L2                                      !!! over m2
	L2M2=L2*(L2+1)+M2+1
	DO L1=0,ILSB(ISORT)                               !!! over l1
	IF(.NOT.LTBAS(L1,IATOM))CYCLE
	DO M1=-L1,L1                                      !!! over m1
	L1M1=L1*(L1+1)+M1+1
	ICHI21=INCHI(L2M2,L1M1,IATOM)
	ICHI43=INCHI(L4M4,L3M3,IATOM1)
	CHI0(ICHI21,ICHI43,IREP,IREP1,1)=(0.D0,0.D0)
	CHI0(ICHI21,ICHI43,IREP,IREP1,2)=(0.D0,0.D0)
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over l1
	ENDDO                                             !!! over m2
	ENDDO                                             !!! over l2
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over m3
	ENDDO                                             !!! over l3
	ENDDO                                             !!! over m4
	ENDDO                                             !!! over l4
	ENDDO                                             !!! over atoms
 100	CONTINUE                                          !!! over reps
 200	CONTINUE                                          !!! over reps
C  WRITE ZEROES
	CALL CHIFILES(ISPIN,ITRAN,ISPIN1,ITRAN1,IQPNT,IOMG,IUCHI,'W')
1000	CONTINUE                                          !!! over spinors
2000	CONTINUE                                          !!! over spinors
3000	CONTINUE                                          !!! over spinors
4000	CONTINUE                                          !!! over spinors
	END
