	SUBROUTINE LMTCHI
************************************************************
*   The calculation of susceptibility                      *
************************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                        !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO                      !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,NHSORT !!! from readini
	USE COM_KAPPAR  ,ONLY: NPAN,NKAP                      !!! from readini
	USE COM_QMESH   ,ONLY: NQPNT,QPNT                     !!! from tetra
	USE COM_KMESH   ,ONLY: NPNT,PNT                       !!! from tetra
	USE COM_FREQU   ,ONLY: NOMGCHI                        !!! from tetra
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC        !!! from readini
	USE COM_SUBGROUP,ONLY: NSGQ,NGEQ,KSYMPN,MSYMPN        !!! from delmsh
      USE COM_SPHERE  ,ONLY: ZNUC,ZCOR,ZSEM,ZVAL            !!! from readini
      USE COM_CHIMAT  ,ONLY: NREP                           !!! from ftbchi
      USE COM_FERMI   ,ONLY: EF                             !!! from ttrints
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
	USE COM_LMTOUT  ,ONLY: ICCHI                          !!! from readini
	USE COM_CHANNELS,ONLY: IUTTW                          !!! from channels
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
C *****************************
	IF(ICCHI.EQ.0)RETURN
C LMTO REPRESENTATION
	NREP=4
C FIND FERMI LEVEL
      ZVALTOT=0.D0
      DO ISORT=1,NSORT                         !!! define total valence charge
      ZVALTOT=ZVALTOT+(ZNUC(ISORT)-ZCOR(ISORT))*NHSORT(ISORT)
      ENDDO
      ZSEMTOT=0.D0
      DO IPAN=2,NPAN                           !!! define semicore charge
      ZSEMTOT=ZSEMTOT+2.D0*NBNDT(IPAN)
      ENDDO
      CALL BANDS_INSL(EF,ZVALTOT-ZSEMTOT)      !!! recognize insulating case
      CALL EFSEARCH(EF,ZVALTOT-ZSEMTOT,EF,100,1.D-09,0.8D0)! search for Fermi energy
      CALL BANDS_CHI(EF,MBNDF,MBNDE,MBNDC)     !!! bands crossing Ef +/- window
C Redefine number of filled and empty bands
      NF=NBNDF(1)
      NE=NBNDE(1)
      NC=NBNDC(1)
	NBNDF(1)=MBNDF
	NBNDE(1)=MBNDE
	NBNDC(1)=MBNDC
C START LOOPING OVER LIST OF Q-POINTS
	DO 2000 IQPNT=1,NQPNT                !!! over q's
C Compute BZ-integrals
	CALL DELMSH(IQPNT)                   !!! analisys of k-mesh in IBZ
	CALL DELMSW(IQPNT)                   !!! set fine k-mesh in IBZ
C START LOOPOING OVER FREQUENCIES
	DO 1000 IOMG=0,NOMGCHI               !!! over frequencies
	CALL CHITET(IQPNT,IOMG)              !!! k-point tetrahedron weights
	CALL PRINTQ(IQPNT,IOMG)              !!! k-point tetrahedron weights
C INTEGRATE OVER BRILLOUINE ZONE
	CALL NULCHI(IQPNT,IOMG)              !!! set chi(q,w)=0
	DO ISGQ=1,NSGQ                       !!! DO over star of the q-vector
	DO IPNT=1,NPNT(1)                    !!! DO over k-points
	IF(KSYMPN(ISGQ,IPNT).LT.0)CYCLE
	CALL LMTVEC(IPNT,ISGQ,IQPNT)         !!! rotate variational coef
 	CALL INTCHI(IPNT,ISGQ,IQPNT,IOMG)    !!! integrate susceptibility
 	ENDDO                                !!! ENDDO over k-points
	ENDDO                                !!! ENDDO over star of q-vector
	CALL SYMCHI(IQPNT,IOMG)              !!! symmetrize susceptibility
	CALL TYPCHI(IQPNT,IOMG)              !!! print calculation
	CLOSE(UNIT=IUTTW,STATUS='DELETE')
1000	CONTINUE                             !!! over frequencies
2000	CONTINUE                             !!! over q's
C Redefine number of filled and empty bands
      NBNDF(1)=NF
      NBNDE(1)=NE
      NBNDC(1)=NC
	END
