	SUBROUTINE LMTVEC(IPNT,ISGQ,IQPNT)
************************************************************
*  Find LMT-variational coefficients A(L,g*kj)             *
*  at the point g*k of the Brillouin Zone. Find also these *
*  eigenvectors for the point g*k+q=g'*k'.                 *
************************************************************
C  SET ARRAY-SIZE DATA
      USE DIM_LMTART
C  SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                           !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,NPFR,NOVR          !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB,ILST! from readini
      USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC                   !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC           !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                          !!! from tetra
      USE COM_EIGVEC  ,ONLY: APHK,APHQ                         !!! from ftbvec
      USE COM_SUBGROUP,ONLY: NSGQ,NGEQ,ISG                     !!! from delmsh
      USE COM_SYMMESH ,ONLY: IG0IG1,IK0IK1                     !!! from delmsh
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                    !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                       !!! from readini
      USE COM_LMTPAR  ,ONLY: GAM,AAH,BBH,AAJ,BBJ               !!! from potpar
      USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS           !!! from readhop
      USE COM_GROUPS  ,ONLY: NGROUP,U,SJ,IP,RDC,SHIFT,INV,IKOV !!! from groups
      USE COM_MASHDEP ,ONLY: LENCMP,NVAL                       !!! from readini
      USE COM_CHANNELS,ONLY: IUPSI                             !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                       !!! from setup
C  SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16, ALLOCATABLE :: APK(:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: APQ(:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: AHK(:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: ASK(:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: AJK(:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: AHQ(:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: ASQ(:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: AJQ(:,:,:,:)
	COMPLEX*16 PHSK,PHSQ
	DATA PI/3.141592653589793D0/
C  MEMORY ALLOCATIONS
	ALLOCATE(APK(LIMBMEM,NATOMMEM,2,NSPINMEM))
	ALLOCATE(APQ(LIMBMEM,NATOMMEM,2,NSPINMEM))
      ALLOCATE(AHK(LIMBMEM,NATOMMEM,NKAPMEM,NSPINMEM))
      ALLOCATE(ASK(LIMBMEM,NATOMMEM,NKAPMEM,NSPINMEM))
      ALLOCATE(AJK(LIMTMEM,NATOMMEM,NKAPMEM,NSPINMEM))
      ALLOCATE(AHQ(LIMBMEM,NATOMMEM,NKAPMEM,NSPINMEM))
      ALLOCATE(ASQ(LIMBMEM,NATOMMEM,NKAPMEM,NSPINMEM))
      ALLOCATE(AJQ(LIMTMEM,NATOMMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(APHK(LIMBMEM,NATOMMEM,NORBSMEM,NBNDT(1)*NSPINMEM,2))
	ALLOCATE(APHQ(LIMBMEM,NATOMMEM,NORBSMEM,NBNDT(1)*NSPINMEM,2))
      SIZE_APHK=DBLE(SIZE(APHK)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+2.D0*SIZE_APHK
      IF(TOTMEM.LT.CURMEM)TXTMEM='<LMTVEC> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C  SET POINT-GROUP INFORMATION
	IRK=ISG(1,ISGQ)       !!!  element "g"  in the main G-list
	IGK=IKOV(IRK)         !!!  element "g"  after Kovalev
	IPNTK=IPNT            !!!  point   "k"
	IRQ=IG0IG1(IPNT,IRK)  !!!  element "g'" in the main G-list
	IGQ=IKOV(IRQ)         !!!  element "g'" after Kovalev
	IPNTQ=IK0IK1(IPNT,IRK)!!!  point   "k'" such that g*k+q=g'*k'
C  **** ROTATE EIGENVECTORS AFTER APPLYING POINT-GROUP OPERATIONS ****
	DO 2000 IBNDS=1,NSPIN                         !!! over spin subbands
      DO 1000 IBNDT=1,NBNDT(1)                      !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
C  READ EIGENVECTORS FOR THE POINT "K"
	DO IORBS=1,NORBS                              !!! over spinors
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
	DO IKAP=1,NKAP(1)
      IREC=IKAP+NKAP(1)*(IBNDT-1)+
     &NKAP(1)*NBNDT(1)*(IBNDS-1)+
     &NKAP(1)*NBNDT(1)*NSPIN*(ISPIN-1)*(NORBS-1)+
     &NKAP(1)*NBNDT(1)*NSPIN*NORBS*(IPNTK-1)
      READ(IUPSI,REC=IREC)
     &((AHK(LM,IATOM,IKAP,ISPIN),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((ASK(LM,IATOM,IKAP,ISPIN),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((AJK(LM,IATOM,IKAP,ISPIN),LM=1,(ILST(IS(IATOM))+1)**2),
     &IATOM=1,NATOM)
	ENDDO
C  READ EIGENVECTORS FOR THE POINT "K+Q"
	DO IKAP=1,NKAP(1)
      IREC=IKAP+NKAP(1)*(IBNDT-1)+
     &NKAP(1)*NBNDT(1)*(IBNDS-1)+
     &NKAP(1)*NBNDT(1)*NSPIN*(ISPIN-1)*(NORBS-1)+
     &NKAP(1)*NBNDT(1)*NSPIN*NORBS*(IPNTQ-1)
      READ(IUPSI,REC=IREC)
     &((AHQ(LM,IATOM,IKAP,ISPIN),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((ASQ(LM,IATOM,IKAP,ISPIN),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM),
     &((AJQ(LM,IATOM,IKAP,ISPIN),LM=1,(ILST(IS(IATOM))+1)**2),
     &IATOM=1,NATOM)
	ENDDO
	ENDDO
C SUM OVER KAPPA's
	DO IORBS=1,NORBS                              !!! over spinors
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
      DO IATOM=1,NATOM                              !!! over atoms
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)                            !!! over l
      DO M=-L,L                                     !!! over m
      LM=L*(L+1)+M+1
      APK(LM,IATOM,1,ISPIN)=(0.D0,0.D0)
      APQ(LM,IATOM,1,ISPIN)=(0.D0,0.D0)
      APK(LM,IATOM,2,ISPIN)=(0.D0,0.D0)
      APQ(LM,IATOM,2,ISPIN)=(0.D0,0.D0)
      IF(.NOT.LTBAS(L,IATOM))CYCLE
      DO IKAP=1,NKAP(1)                             !!! over ikap
	IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	APK(LM,IATOM,1,ISPIN)=APK(LM,IATOM,1,ISPIN)+
     &AHK(LM,IATOM,IKAP,ISPIN)*AAH(L,ISORT,IKAP,1,ISPIN)-
     &AJK(LM,IATOM,IKAP,ISPIN)*AAJ(L,ISORT,IKAP,1,ISPIN)*GAM(L,ISORT)
	APK(LM,IATOM,2,ISPIN)=APK(LM,IATOM,2,ISPIN)+
     &AHK(LM,IATOM,IKAP,ISPIN)*BBH(L,ISORT,IKAP,1,ISPIN)-
     &AJK(LM,IATOM,IKAP,ISPIN)*BBJ(L,ISORT,IKAP,1,ISPIN)*GAM(L,ISORT)
	APQ(LM,IATOM,1,ISPIN)=APQ(LM,IATOM,1,ISPIN)+
     &AHQ(LM,IATOM,IKAP,ISPIN)*AAH(L,ISORT,IKAP,1,ISPIN)-
     &AJQ(LM,IATOM,IKAP,ISPIN)*AAJ(L,ISORT,IKAP,1,ISPIN)*GAM(L,ISORT)
	APQ(LM,IATOM,2,ISPIN)=APQ(LM,IATOM,2,ISPIN)+
     &AHQ(LM,IATOM,IKAP,ISPIN)*BBH(L,ISORT,IKAP,1,ISPIN)-
     &AJQ(LM,IATOM,IKAP,ISPIN)*BBJ(L,ISORT,IKAP,1,ISPIN)*GAM(L,ISORT)
      ENDDO                                         !!! over ikap
      ENDDO                                         !!! over m
      ENDDO                                         !!! over l
      ENDDO                                         !!! over atoms
	ENDDO                                         !!! over spinors
C  
	DO IORBS=1,NORBS                              !!! over spinors
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
	DO IATOM=1,NATOM                              !!! over atoms
	ISORT=IS(IATOM)
	SK=PNT(1,IPNTK,1)*RDC(1,IATOM,IRK)+
     &   PNT(2,IPNTK,1)*RDC(2,IATOM,IRK)+
     &   PNT(3,IPNTK,1)*RDC(3,IATOM,IRK)
	SQ=PNT(1,IPNTQ,1)*RDC(1,IATOM,IRQ)+
     &   PNT(2,IPNTQ,1)*RDC(2,IATOM,IRQ)+
     &   PNT(3,IPNTQ,1)*RDC(3,IATOM,IRQ)
	PHSK=EXP(2.D0*PI*SK*(0.D0,1.D0))
	PHSQ=EXP(2.D0*PI*SQ*(0.D0,1.D0))
	DO L=0,ILSB(ISORT)                            !!! over l
	LL=L*(2*L-1)*(2*L+1)/3
	DO M=-L,L                                     !!! over m
	LM=L*(L+1)+M+1
      APHK(LM,IATOM,IORBS,IBAND,1)=(0.D0,0.D0)
      APHQ(LM,IATOM,IORBS,IBAND,1)=(0.D0,0.D0)
      APHK(LM,IATOM,IORBS,IBAND,2)=(0.D0,0.D0)
      APHQ(LM,IATOM,IORBS,IBAND,2)=(0.D0,0.D0)
	IF(.NOT.LTBAS(L,IATOM))CYCLE
	DO IORBS1=1,NORBS                              !!! over spinors
      IF(NORBS.EQ.1)ISPIN1=IBNDS
      IF(NORBS.EQ.2)ISPIN1=IORBS1
C  ROTATE EIGENVECTORS FROM THE POINT "K" TO THE POINT "G*K"
	DO M1=-L,L                                    !!! over m1
	LM1=L*(L+1)+M1+1
	IWIG01=LL+(2*L+1)*(L+M1)+L+M+1
      APHK(LM,IATOM,IORBS,IBAND,1)=
     &APHK(LM,IATOM,IORBS,IBAND,1)+
     &U(IWIG01,IGK)*SJ(ISPIN,ISPIN1,IRK)*
     &APK(LM1,IP(IATOM,IRK),1,ISPIN1)*PHSK
      APHK(LM,IATOM,IORBS,IBAND,2)=
     &APHK(LM,IATOM,IORBS,IBAND,2)+
     &U(IWIG01,IGK)*SJ(ISPIN,ISPIN1,IRK)*
     &APK(LM1,IP(IATOM,IRK),2,ISPIN1)*PHSK
      ENDDO                                         !!! over m1
C  ROTATE EIGENVECTORS FROM THE POINT "K'" TO THE POINT "G'*K'=G*K+Q"
	DO M1=-L,L                                    !!! over m1
	LM1=L*(L+1)+M1+1
	IWIG01=LL+(2*L+1)*(L+M1)+L+M+1
      APHQ(LM,IATOM,IORBS,IBAND,1)=
     &APHQ(LM,IATOM,IORBS,IBAND,1)+
     &U(IWIG01,IGQ)*SJ(ISPIN,ISPIN1,IRQ)*
     &APQ(LM1,IP(IATOM,IRQ),1,ISPIN1)*PHSQ
      APHQ(LM,IATOM,IORBS,IBAND,2)=
     &APHQ(LM,IATOM,IORBS,IBAND,2)+
     &U(IWIG01,IGQ)*SJ(ISPIN,ISPIN1,IRQ)*
     &APQ(LM1,IP(IATOM,IRQ),2,ISPIN1)*PHSQ
      ENDDO                                         !!! over m1
      ENDDO                                         !!! over spinors
      ENDDO                                         !!! over m
      ENDDO                                         !!! over l
      ENDDO                                         !!! over atoms
	ENDDO                                         !!! over spinors
1000	CONTINUE                                      !!! over bands
2000	CONTINUE                                      !!! over spin subbands
C MEMORY DEALLOCATIONS
	DEALLOCATE(APK,APQ,AHK,ASK,AJK,AHQ,ASQ,AJQ)
	END
