	SUBROUTINE SETCHI
******************************************************
*   Output module of the LMTO package                *
******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,LRWF,NPFR,IEXC    !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS       !!! from readini
     &                      ,ILST,ILSB,ILSV,LRTV,NHSORT
      USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC                  !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS            !!! from readini
      USE COM_INPPAR  ,ONLY: ENY,DNY,TNY,NODES,MNY            !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SWZ                          !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC          !!! from readini
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,NDIW                   !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                         !!! from tetra
      USE COM_FERMI   ,ONLY: EF                               !!! from ttrints
      USE COM_FREQU   ,ONLY: NOMGCHI,OMGCHI                   !!! from ttrints
      USE COM_CHIMAT  ,ONLY: NREP,NCHI,INCHI,CHI0             !!! from intchi
      USE COM_QMESH   ,ONLY: NQPNT,QPNT                       !!! from tetra
      USE COM_GROUPS  ,ONLY: NGROUP,INV,KELTAB,IKOV,IP        !!! from groups
     &                      ,RDC,SHIFT,SOPHS,U,UJ
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                  !!! from setup
      USE COM_CHANNELS,ONLY: IUAIN,IUDOS,IUCHI                !!! from channels
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                      !!! from setup
      USE COM_LMTOUT                                          !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: ILMTBAS(:,:)
	INTEGER, ALLOCATABLE :: INODBAS(:,:)
      COMPLEX*16, ALLOCATABLE :: CHIM(:,:,:)
      COMPLEX*16 TC(-3:3,7,0:3),TS(7,-3:3,0:3),PCHI(2)
	CHARACTER HELP*40
      INTEGER MTR(2)
	LOGICAL EXIST,OPEN
      DATA MTR/-1,1/
	CALL TRANSS(TS)                  !!! built transformation matrices
      CALL TRANSC(TC)                  !!! built transformation matrices
      IF(ICCHI.LE.0)RETURN
	INQUIRE(FILE=CHIFILE,EXIST=EXIST)
	IF(EXIST)THEN
      OPEN(UNIT=IUAIN,FILE=CHIFILE,STATUS='OLD',FORM='FORMATTED')
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
	OPEN(UNIT=IUAIN,FILE=CHIFILE,STATUS='NEW',FORM='FORMATTED')
C STORE HEADER INFO.
	WRITE(IUAIN,10010)
	WRITE(IUAIN,10020)
10010	FORMAT(1X,'<FILE=CHIFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUAIN,10030)
10030 FORMAT(1X,'<SECTION=CTRL>              ! CONTROL PARAMETERS:')
      HELP='! Frequency mesh for susceptibility  '
	WRITE(IUAIN,10040)NOMGCHI,HELP
10040 FORMAT(1X,'nOmgCHI=',I5,16X,A40)
      HELP='! Min.Frequency (Ry)  for chi(q,w)   '
	WRITE(IUAIN,10050)OMGCHI(0),HELP
10050 FORMAT(1X,'WminOPT=',G14.7,7X,A40)
      HELP='! Max.Frequency (Ry)  for chi(q,w)   '
	WRITE(IUAIN,10060)OMGCHI(NOMGCHI),HELP
10060 FORMAT(1X,'WmaxCHI=',G14.7,7X,A40)
	HELP='! Tetrahedron mesh                     '
	WRITE(IUAIN,10070)NDIV,HELP
10070 FORMAT(1X,'nDiv(:)=',I2,1X,I2,1X,I2,1X,12X,A40)
	HELP='! Tetrahedron mesh for weights         '
	WRITE(IUAIN,10080)NDIW,HELP
10080 FORMAT(1X,'nDiw(:)=',I2,1X,I2,1X,I2,1X,12X,A40)
C STORE SUSCEPTIBILITY DATA
	WRITE(IUAIN,10110)
10110 FORMAT(1X,'<SECTION=DATA>              ! CHI DATA:')
      WRITE(IUAIN,*)NATOM,NSORT,NSPIN,NORBS,
     &(IS(IATOM),IATOM=1,NATOM),(ILSB(ISORT),ISORT=1,NSORT),
     &(NHSORT(ISORT),ISORT=1,NSORT),OMGCHI(0),OMGCHI(NOMGCHI),
     &NOMGCHI,NQPNT,NREP
      WRITE(IUAIN,FMT='(5A10)')(TXTAT(ISORT),ISORT=1,NSORT)
C Store basis set
      ALLOCATE(ILMTBAS(0:LMAXBMEM,NATOMMEM))
      ALLOCATE(INODBAS(0:LMAXBMEM,NATOMMEM))
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(IS(IATOM))
      ILMTBAS(L,IATOM)=0
      INODBAS(L,IATOM)=0
      DO IKAP=1,NKAP(1)
      IF(LTPAN(L,IATOM,IKAP,1))ILMTBAS(L,IATOM)=1
      IF(LTPAN(L,IATOM,IKAP,1))INODBAS(L,IATOM)=
     &NODES(L,ISORT,IKAP,1)+L+1
      ENDDO
      ENDDO
      ENDDO
	WRITE(IUAIN,*)((ILMTBAS(L,IATOM),L=0,ILSB(IS(IATOM))),
     &IATOM=1,NATOM)
      WRITE(IUAIN,*)((INODBAS(L,IATOM),L=0,ILSB(IS(IATOM))),
     &IATOM=1,NATOM)
C Store susceptibility
      ALLOCATE(CHIM(NCHI,NCHI,2))
      DO IQPNT=1,NQPNT             !!! over q-points
      DO IOMG=0,NOMGCHI            !!! over frequencies
C Do over polarizations
      DO MY1=-1,2                  !!! over polarizations
      DO MY =-1,2                  !!! over polarizations
      WRITE(IUAIN,*)MY1,MY,OMGCHI(IOMG),(QPNT(I,IQPNT),I=1,3)
C Set it to zero
      PCHI(1)=(0.D0,0.D0)
      PCHI(2)=(0.D0,0.D0)
      DO IATOM1=1,NATOM            !!! over atoms
      ISORT1=IS(IATOM1)
      DO L4=0,ILSB(ISORT1)         !!! over l4
      IF(ILMTBAS(L4,IATOM1).EQ.0)CYCLE
      DO M4=-L4,L4                 !!! over m4
      L4M4=L4*(L4+1)+M4+1
      DO L3=0,ILSB(ISORT1)         !!! over l3
      IF(ILMTBAS(L3,IATOM1).EQ.0)CYCLE
      DO M3=-L3,L3                 !!! over m3
      L3M3=L3*(L3+1)+M3+1
      DO IATOM=1,NATOM             !!! over atoms
      ISORT=IS(IATOM)
      DO L2=0,ILSB(ISORT)          !!! over l2
      IF(ILMTBAS(L2,IATOM).EQ.0)CYCLE
      DO M2=-L2,L2                 !!! over m2
      L2M2=L2*(L2+1)+M2+1
      DO L1=0,ILSB(ISORT)          !!! over l1
      IF(ILMTBAS(L1,IATOM).EQ.0)CYCLE
      DO M1=-L1,L1                 !!! over m1
      L1M1=L1*(L1+1)+M1+1
      CHIM(INCHI(L2M2,L1M1,IATOM),INCHI(L4M4,L3M3,IATOM1),1)=
     &(0.D0,0.D0)
      CHIM(INCHI(L2M2,L1M1,IATOM),INCHI(L4M4,L3M3,IATOM1),2)=
     &(0.D0,0.D0)
      ENDDO                        !!! over m1
      ENDDO                        !!! over l1
      ENDDO                        !!! over m2
      ENDDO                        !!! over l2
      ENDDO                        !!! over atoms
      ENDDO                        !!! over m3
      ENDDO                        !!! over l3
      ENDDO                        !!! over m4
      ENDDO                        !!! over l4
      ENDDO                        !!! over atoms
C Sum over spinors
      DO IUPDN4=1,NSPIN            !!! over spinors
      IF(NORBS.EQ.2)IORBS4=IUPDN4
      IF(NORBS.EQ.1)IORBS4=1
      DO IUPDN3=1,NSPIN            !!! over spinors
      IF(NORBS.EQ.2)IORBS3=IUPDN3
      IF(NORBS.EQ.1)IORBS3=1
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
      IF(IUPDN4.EQ.1.AND.IUPDN3.EQ.1)THEN
      ISPIN1=1
      ITRAN1=0
      SIGNF1=1.D0
      ELSEIF(IUPDN4.EQ.2.AND.IUPDN3.EQ.2)THEN
      ISPIN1=2
      ITRAN1=0
      SIGNF1=1.D0
      ELSEIF(IUPDN4.EQ.1.AND.IUPDN3.EQ.2)THEN
      ISPIN1=0
      ITRAN1=1
      SIGNF1=+SQRT(2.D0)
      ELSEIF(IUPDN4.EQ.2.AND.IUPDN3.EQ.1)THEN
      ISPIN1=0
      ITRAN1=2
      SIGNF1=-SQRT(2.D0)
      ENDIF
      DO IUPDN2=1,NSPIN            !!! over spinors
      IF(NORBS.EQ.2)IORBS2=IUPDN2
      IF(NORBS.EQ.1)IORBS2=1
      DO IUPDN1=1,NSPIN            !!! over spinors
      IF(NORBS.EQ.2)IORBS1=IUPDN1
      IF(NORBS.EQ.1)IORBS1=1
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
      IF(IUPDN2.EQ.1.AND.IUPDN1.EQ.1)THEN
      IF(NORBS.EQ.1.AND.ITRAN1.NE.0)CYCLE
      ISPIN=1
      ITRAN=0
      SIGNF=1.D0
      ELSEIF(IUPDN2.EQ.2.AND.IUPDN1.EQ.2)THEN
      IF(NORBS.EQ.1.AND.ITRAN1.NE.0)CYCLE
      ISPIN=2
      ITRAN=0
      SIGNF=1.D0
      ELSEIF(IUPDN2.EQ.1.AND.IUPDN1.EQ.2)THEN
      IF(NORBS.EQ.1.AND.ITRAN1.NE.2)CYCLE
      ISPIN=0
      ITRAN=1
      SIGNF=+SQRT(2.D0)
      ELSEIF(IUPDN2.EQ.2.AND.IUPDN1.EQ.1)THEN
      IF(NORBS.EQ.1.AND.ITRAN1.NE.1)CYCLE
      ISPIN=0
      ITRAN=2
      SIGNF=-SQRT(2.D0)
      ENDIF
C
      IF(ITRAN1.NE.0.AND.ITRAN.NE.0)THEN
      IF(MTR(ITRAN1).NE.MY1)CYCLE
      IF(MTR(ITRAN ).NE.MY) CYCLE
      PFAC=1.D0
      ELSEIF(ISPIN1.NE.0.AND.ITRAN.NE.0)THEN
      IF(MTR(ITRAN ).NE.MY)CYCLE
      IF(MY1.NE.0.AND.MY1.NE.2)CYCLE
      IF(MY1.EQ.0)PFAC=(-1)**(ISPIN1+1)
      IF(MY1.EQ.2)PFAC=1.D0
      ELSEIF(ITRAN1.NE.0.AND.ISPIN.NE.0)THEN
      IF(MTR(ITRAN1).NE.MY1)CYCLE
      IF(MY.NE.0.AND.MY.NE.2)CYCLE
      IF(MY.EQ.0)PFAC=(-1)**(ISPIN+1)
      IF(MY.EQ.2)PFAC=1.D0
      ELSEIF(ISPIN1.NE.0.AND.ISPIN.NE.0)THEN
      IF(MY1.NE.0.AND.MY1.NE.2)CYCLE
      IF(MY.NE.0.AND.MY.NE.2)CYCLE
      IF(NSPIN.EQ.2)THEN
      IF(MY1.EQ.0.AND.MY.EQ.0)PFAC=(-1)**(ISPIN1+ISPIN)
      IF(MY1.EQ.0.AND.MY.EQ.2)PFAC=(-1)**(ISPIN1+1)
      IF(MY1.EQ.2.AND.MY.EQ.0)PFAC=(-1)**(ISPIN +1)
      ENDIF
      IF(MY1.EQ.2.AND.MY.EQ.2)PFAC=1.D0
      ENDIF
C  Read data
      CALL CHIFILES(ISPIN,ITRAN,ISPIN1,ITRAN1,IQPNT,IOMG,IUCHI,'R')
C  Matrix elements contributions
      DO IATOM1=1,NATOM            !!! over atoms
      ISORT1=IS(IATOM1)
      DO L4=0,ILSB(ISORT1)         !!! over l4
      IF(ILMTBAS(L4,IATOM1).EQ.0)CYCLE
      DO M4=-L4,L4                 !!! over m4
      L4M4=L4*(L4+1)+M4+1
      DO L3=0,ILSB(ISORT1)         !!! over l3
      IF(ILMTBAS(L3,IATOM1).EQ.0)CYCLE
      DO M3=-L3,L3                 !!! over m3
      L3M3=L3*(L3+1)+M3+1
      DO IATOM=1,NATOM             !!! over atoms
      ISORT=IS(IATOM)
      DO L2=0,ILSB(ISORT)          !!! over l2
      IF(ILMTBAS(L2,IATOM).EQ.0)CYCLE
      DO M2=-L2,L2                 !!! over m2
      L2M2=L2*(L2+1)+M2+1
      DO L1=0,ILSB(ISORT)          !!! over l1
      IF(ILMTBAS(L1,IATOM).EQ.0)CYCLE
      DO M1=-L1,L1                 !!! over m1
      L1M1=L1*(L1+1)+M1+1
      CHIM(INCHI(L2M2,L1M1,IATOM),INCHI(L4M4,L3M3,IATOM1),1)=
     &CHIM(INCHI(L2M2,L1M1,IATOM),INCHI(L4M4,L3M3,IATOM1),1)+
     &CHI0(INCHI(L2M2,L1M1,IATOM),INCHI(L4M4,L3M3,IATOM1),1,1,1)*
     &PFAC
      CHIM(INCHI(L2M2,L1M1,IATOM),INCHI(L4M4,L3M3,IATOM1),2)=
     &CHIM(INCHI(L2M2,L1M1,IATOM),INCHI(L4M4,L3M3,IATOM1),2)+
     &CHI0(INCHI(L2M2,L1M1,IATOM),INCHI(L4M4,L3M3,IATOM1),1,1,2)*
     &PFAC
      ENDDO                        !!! over m1
      ENDDO                        !!! over l1
      ENDDO                        !!! over m2
      ENDDO                        !!! over l2
      ENDDO                        !!! over atoms
      ENDDO                        !!! over m3
      ENDDO                        !!! over l3
      ENDDO                        !!! over m4
      ENDDO                        !!! over l4
      ENDDO                        !!! over atoms
C  Total contribution
      DO IATOM1=1,NATOM            !!! over atoms
      ISORT1=IS(IATOM1)
      DO L3=0,ILSB(ISORT1)         !!! over l3
      IF(ILMTBAS(L3,IATOM1).EQ.0)CYCLE
      DO M3=-L3,L3                 !!! over m3
      L3M3=L3*(L3+1)+M3+1
      DO IATOM=1,NATOM             !!! over atoms
      ISORT=IS(IATOM)
      DO L1=0,ILSB(ISORT)          !!! over l1
      IF(ILMTBAS(L1,IATOM).EQ.0)CYCLE
      DO M1=-L1,L1                 !!! over m1
      L1M1=L1*(L1+1)+M1+1
      PCHI(1)=PCHI(1)+PFAC*
     &CHI0(INCHI(L1M1,L1M1,IATOM),INCHI(L3M3,L3M3,IATOM1),1,1,1)
      PCHI(2)=PCHI(2)+PFAC*
     &CHI0(INCHI(L1M1,L1M1,IATOM),INCHI(L3M3,L3M3,IATOM1),1,1,2)
      ENDDO                        !!! over m1
      ENDDO                        !!! over l1
      ENDDO                        !!! over atoms
      ENDDO                        !!! over m3
      ENDDO                        !!! over l3
      ENDDO                        !!! over atoms
C
      ENDDO                        !!! over spinors
      ENDDO                        !!! over spinors
      ENDDO                        !!! over spinors
      ENDDO                        !!! over spinors
      WRITE(IUAIN,*)(PCHI(I),I=1,2),(((CHIM(ICHI,ICHI1,I),
     &ICHI=1,NCHI),ICHI1=1,NCHI),I=1,2)
      ENDDO                        !!! over polarizations
      ENDDO                        !!! over polarizations
      ENDDO                        !!! over frequencies
      ENDDO                        !!! over q-points
      DEALLOCATE(CHIM)
      DEALLOCATE(ILMTBAS,INODBAS)
      CLOSE(IUAIN)
	END SUBROUTINE SETCHI
