	SUBROUTINE SYMCHI(IQPNT,IOMG)
***********************************************************
*  Calculate susceptibility                               *
***********************************************************
C SET ARRAY-SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                           !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,NPFR,NOVR          !!! from readini
	USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB   !!! from readini
	USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC                   !!! from readini
	USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS           !!! from readhop
	USE COM_SUBGROUP,ONLY: NSGQ,NGEQ,ISG                     !!! from delmsh
	USE COM_GROUPS  ,ONLY: NGROUP,U,IP,RDC,SHIFT,INV,IKOV    !!! from groups
	USE COM_CHIMAT  ,ONLY: NREP,NCHI,INCHI,CHI0              !!! from intchi
	USE COM_QMESH   ,ONLY: NQPNT,QPNT                        !!! from tetra
	USE COM_FREQU   ,ONLY: NOMGCHI,OMGCHI                    !!! from tetra
	USE COM_MASHDEP ,ONLY: LENCMP,NVAL                       !!! from readini
	USE COM_CHANNELS,ONLY: IUCHI                             !!! from channels
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                   !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: TCHI(:,:)
	COMPLEX*16, ALLOCATABLE :: CH(:,:,:,:,:)
	COMPLEX*16 PHSQ1,PHSQ
	DATA PI/3.141592653589793D0/
C MEMORY ALLOCATIONS
	ALLOCATE(TCHI(NCHI,NCHI))
	ALLOCATE(CH(-LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM,
     &            -LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM,3))
	DO 5000 IUPDN4=1,NSPIN                          !!! over spinors
	IF(NORBS.EQ.2)IORBS4=IUPDN4
	IF(NORBS.EQ.1)IORBS4=1
	DO 4000 IUPDN3=1,NSPIN                          !!! over spinors
	IF(NORBS.EQ.2)IORBS3=IUPDN3
	IF(NORBS.EQ.1)IORBS3=1
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
	    IF(IUPDN4.EQ.1.AND.IUPDN3.EQ.1)THEN
	ISPIN1=1
	ITRAN1=0
	SIGNF1=1.D0
	ELSEIF(IUPDN4.EQ.2.AND.IUPDN3.EQ.2)THEN
	ISPIN1=2
	ITRAN1=0
	SIGNF1=1.D0
	ELSEIF(IUPDN4.EQ.1.AND.IUPDN3.EQ.2)THEN
	ISPIN1=0
	ITRAN1=1
	SIGNF1=+SQRT(2.D0)
	ELSEIF(IUPDN4.EQ.2.AND.IUPDN3.EQ.1)THEN
	ISPIN1=0
	ITRAN1=2
	SIGNF1=-SQRT(2.D0)
	ENDIF
	DO 3000 IUPDN2=1,NSPIN                          !!! over spinors
	IF(NORBS.EQ.2)IORBS2=IUPDN2
	IF(NORBS.EQ.1)IORBS2=1
	DO 2000 IUPDN1=1,NSPIN                          !!! over spinors
	IF(NORBS.EQ.2)IORBS1=IUPDN1
	IF(NORBS.EQ.1)IORBS1=1
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
	    IF(IUPDN2.EQ.1.AND.IUPDN1.EQ.1)THEN
	IF(NORBS.EQ.1.AND.ITRAN1.NE.0)GOTO2000
	ISPIN=1
	ITRAN=0
	SIGNF=1.D0
	ELSEIF(IUPDN2.EQ.2.AND.IUPDN1.EQ.2)THEN
	IF(NORBS.EQ.1.AND.ITRAN1.NE.0)GOTO2000
	ISPIN=2
	ITRAN=0
	SIGNF=1.D0
	ELSEIF(IUPDN2.EQ.1.AND.IUPDN1.EQ.2)THEN
	IF(NORBS.EQ.1.AND.ITRAN1.NE.2)GOTO2000
	ISPIN=0
	ITRAN=1
	SIGNF=+SQRT(2.D0)
	ELSEIF(IUPDN2.EQ.2.AND.IUPDN1.EQ.1)THEN
	IF(NORBS.EQ.1.AND.ITRAN1.NE.1)GOTO2000
	ISPIN=0
	ITRAN=2
	SIGNF=-SQRT(2.D0)
	ENDIF
	CALL CHIFILES(ISPIN,ITRAN,ISPIN1,ITRAN1,IQPNT,IOMG,IUCHI,'R')
C CHI(q,w)=0
	DO 1000 IREIM=1,2                                 !!! over re/im parts
	DO 200 IREP1=1,NREP                               !!! over irep1
	DO 100 IREP =1,NREP                               !!! over irep
	DO IATOM1=1,NATOM                                 !!! over atoms
	ISORT1=IS(IATOM1)
	DO L4=0,ILSB(ISORT1)                              !!! over l4
	IF(.NOT.LTBAS(L4,IATOM1))CYCLE
	DO M4=-L4,L4                                      !!! over m4
	L4M4=L4*(L4+1)+M4+1
	DO L3=0,ILSB(ISORT1)                              !!! over l3
	IF(.NOT.LTBAS(L3,IATOM1))CYCLE
	DO M3=-L3,L3                                      !!! over m3
	L3M3=L3*(L3+1)+M3+1
	DO IATOM=1,NATOM                                  !!! over atoms
	ISORT=IS(IATOM)
	DO L2=0,ILSB(ISORT)                               !!! over l2
	IF(.NOT.LTBAS(L2,IATOM))CYCLE
	DO M2=-L2,L2                                      !!! over m2
	L2M2=L2*(L2+1)+M2+1
	DO L1=0,ILSB(ISORT)                               !!! over l1
	IF(.NOT.LTBAS(L1,IATOM))CYCLE
	DO M1=-L1,L1                                      !!! over m1
	L1M1=L1*(L1+1)+M1+1
	TCHI(INCHI(L2M2,L1M1,IATOM),INCHI(L4M4,L3M3,IATOM1))=(0.D0,0.D0)
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over l1
	ENDDO                                             !!! over m2
	ENDDO                                             !!! over l2
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over m3
	ENDDO                                             !!! over l3
	ENDDO                                             !!! over m4
	ENDDO                                             !!! over l4
	ENDDO                                             !!! over atoms
C  DO OVER GROUP OF WAVE VECTOR Q
	DO 10 IGEQ=1,NGEQ                                 !!! over group of q-vector
	IR=ISG(IGEQ,1)                                    !!! element "g" in the main G-list
	IG=IKOV(IR)                                       !!! element "g" after Kovalev
	DO IATOM1=1,NATOM                                 !!! over atoms
	ISORT1=IS(IATOM1)
        IATOM1G=IP(IATOM1,IR)
	SQ=QPNT(1,IQPNT)*(RDC(1,IATOM1,IR)+SHIFT(1,IR))+
     &     QPNT(2,IQPNT)*(RDC(2,IATOM1,IR)+SHIFT(2,IR))+
     &     QPNT(3,IQPNT)*(RDC(3,IATOM1,IR)+SHIFT(3,IR))
	PHSQ1=EXP(-2.D0*PI*SQ*(0.D0,1.D0))
	DO L4=0,ILSB(ISORT1)                              !!! over l4
	IF(.NOT.LTBAS(L4,IATOM1))CYCLE
	DO L3=0,ILSB(ISORT1)                              !!! over l3
	IF(.NOT.LTBAS(L3,IATOM1))CYCLE
	DO IATOM=1,NATOM                                  !!! over atoms
	ISORT=IS(IATOM)
        IATOMG=IP(IATOM,IR)
	SQ=QPNT(1,IQPNT)*(RDC(1,IATOM,IR)+SHIFT(1,IR))+
     &   QPNT(2,IQPNT)*(RDC(2,IATOM,IR)+SHIFT(2,IR))+
     &   QPNT(3,IQPNT)*(RDC(3,IATOM,IR)+SHIFT(3,IR))
	PHSQ=EXP(+2.D0*PI*SQ*(0.D0,1.D0))
	DO L2=0,ILSB(ISORT)                               !!! over l2
	IF(.NOT.LTBAS(L2,IATOM))CYCLE
	DO L1=0,ILSB(ISORT)                               !!! over l1
	IF(.NOT.LTBAS(L1,IATOM))CYCLE
C
	DO M4=-L4,L4                                      !!! over m4
	DO M3=-L3,L3                                      !!! over m3
	DO M2=-L2,L2                                      !!! over m2
	DO M1=-L1,L1                                      !!! over m1
	CH(M2,M1,M4,M3,1)=(0.D0,0.D0)
	CH(M2,M1,M4,M3,2)=(0.D0,0.D0)
	CH(M2,M1,M4,M3,3)=(0.D0,0.D0)
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over m2
	ENDDO                                             !!! over m3
	ENDDO                                             !!! over m4
C
	DO M4=-L4,L4                                      !!! over m4
	L4M4=L4*(L4+1)+M4+1
	DO M3=-L3,L3                                      !!! over m3
	L3M3=L3*(L3+1)+M3+1
	DO M2=-L2,L2                                      !!! over m2
	L2M2=L2*(L2+1)+M2+1
	DO M1=-L1,L1                                      !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO K1=-L1,L1                                      !!! over k1
	L1K1=L1*(L1+1)+K1+1
      IK1M1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+M1)+L1+K1+1  !  (l1,k1 m1) packed
	ICHI21=INCHI(L2M2,L1K1,IATOMG)
	ICHI43=INCHI(L4M4,L3M3,IATOM1G)
      CH(M2,M1,M4,M3,1)=CH(M2,M1,M4,M3,1)+U(IK1M1,IG)*
     &CHI0(ICHI21,ICHI43,IREP,IREP1,IREIM)*PHSQ*PHSQ1
	ENDDO                                             !!! over k1
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over m2
	ENDDO                                             !!! over m3
	ENDDO                                             !!! over m4

	DO M4=-L4,L4                                      !!! over m4
	DO M3=-L3,L3                                      !!! over m3
	DO M2=-L2,L2                                      !!! over m2
	DO M1=-L1,L1                                      !!! over m1
	DO K2=-L2,L2                                      !!! over k2
      IK2M2=L2*(2*L2-1)*(2*L2+1)/3+(2*L2+1)*(L2+M2)+L2+K2+1  !  (l2,k2 m2) packed
	CH(M2,M1,M4,M3,2)=CH(M2,M1,M4,M3,2)+
     &  CONJG(U(IK2M2,IG))*CH(K2,M1,M4,M3,1)
	ENDDO                                             !!! over k2
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over m2
	ENDDO                                             !!! over m3
	ENDDO                                             !!! over m4

	DO M4=-L4,L4                                      !!! over m4
	DO M3=-L3,L3                                      !!! over m3
	DO M2=-L2,L2                                      !!! over m2
	DO M1=-L1,L1                                      !!! over m1
	DO K4=-L4,L4                                      !!! over k4
      IK4M4=L4*(2*L4-1)*(2*L4+1)/3+(2*L4+1)*(L4+M4)+L4+K4+1  !  (l4,k4 m4) packed
	CH(M2,M1,M4,M3,3)=CH(M2,M1,M4,M3,3)+
     &CH(M2,M1,K4,M3,2)*CONJG(U(IK4M4,IG))
	ENDDO                                             !!! over k4
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over m2
	ENDDO                                             !!! over m3
	ENDDO                                             !!! over m4

	DO M4=-L4,L4                                      !!! over m4
	L4M4=L4*(L4+1)+M4+1
	DO M3=-L3,L3                                      !!! over m3
	L3M3=L3*(L3+1)+M3+1
	DO M2=-L2,L2                                      !!! over m2
	L2M2=L2*(L2+1)+M2+1
	DO M1=-L1,L1                                      !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO K3=-L3,L3                                      !!! over k3
      IK3M3=L3*(2*L3-1)*(2*L3+1)/3+(2*L3+1)*(L3+M3)+L3+K3+1  !  (l3,k3 m3) packed
	TCHI(INCHI(L2M2,L1M1,IATOM),INCHI(L4M4,L3M3,IATOM1))=
     &TCHI(INCHI(L2M2,L1M1,IATOM),INCHI(L4M4,L3M3,IATOM1))+
     &CH(M2,M1,M4,K3,3)*U(IK3M3,IG)
	ENDDO                                             !!! over k3
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over m2
	ENDDO                                             !!! over m3
	ENDDO                                             !!! over m4
C
	ENDDO                                             !!! over l1
	ENDDO                                             !!! over l2
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over l3
	ENDDO                                             !!! over l4
	ENDDO                                             !!! over atoms
  10	CONTINUE                                          !!! over group
C NORMALIZE
	DO IATOM1=1,NATOM                                 !!! over atoms
	ISORT1=IS(IATOM1)
	DO L4=0,ILSB(ISORT1)                              !!! over l4
	IF(.NOT.LTBAS(L4,IATOM1))CYCLE
	DO M4=-L4,L4                                      !!! over m4
	L4M4=L4*(L4+1)+M4+1
	DO L3=0,ILSB(ISORT1)                              !!! over l3
	IF(.NOT.LTBAS(L3,IATOM1))CYCLE
	DO M3=-L3,L3                                      !!! over m3
	L3M3=L3*(L3+1)+M3+1
	DO IATOM=1,NATOM                                  !!! over atoms
	ISORT=IS(IATOM)
	DO L2=0,ILSB(ISORT)                               !!! over l2
	IF(.NOT.LTBAS(L2,IATOM))CYCLE
	DO M2=-L2,L2                                      !!! over m2
	L2M2=L2*(L2+1)+M2+1
	DO L1=0,ILSB(ISORT)                               !!! over l1
	IF(.NOT.LTBAS(L1,IATOM))CYCLE
	DO M1=-L1,L1                                      !!! over m1
	L1M1=L1*(L1+1)+M1+1
	ICHI21=INCHI(L2M2,L1M1,IATOM)
	ICHI43=INCHI(L4M4,L3M3,IATOM1)
	CHI0(ICHI21,ICHI43,IREP,IREP1,IREIM)=
     &TCHI(ICHI21,ICHI43)/DBLE(NGEQ)
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over l1
	ENDDO                                             !!! over m2
	ENDDO                                             !!! over l2
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over m3
	ENDDO                                             !!! over l3
	ENDDO                                             !!! over m4
	ENDDO                                             !!! over l4
	ENDDO                                             !!! over atoms
 100	CONTINUE                                          !!! over irep
 200	CONTINUE                                          !!! over irep1
1000	CONTINUE                                          !!! re/im parts
	CALL CHIFILES(ISPIN,ITRAN,ISPIN1,ITRAN1,IQPNT,IOMG,IUCHI,'W')
2000	CONTINUE                                          !!! over spinors
3000	CONTINUE                                          !!! over spinors
4000	CONTINUE                                          !!! over spinors
5000	CONTINUE                                          !!! over spinors
	DEALLOCATE(TCHI,CH)
	END
