	SUBROUTINE TYPCHI(IQPNT,IOMG)
***********************************************************
*  Calculate susceptibility                               *
***********************************************************
C SET ARRAY-SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                           !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,NPFR,NOVR          !!! from readini
	USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB   !!! from readini
	USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC                   !!! from readini
	USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS           !!! from readhop
      USE COM_TBBSYS  ,ONLY: RINPAXE,RINPANG,ROUTAXE,ROUTANG   !!! from readhop
     &                      ,RINPINV,ROUTINV
      USE COM_INPPAR  ,ONLY: ENY,DNY,NODES                     !!! from readini
	USE COM_SUBGROUP,ONLY: NSGQ,NGEQ,ISG                     !!! from delmsh
	USE COM_GROUPS  ,ONLY: NGROUP,U,IP,RDC,SHIFT,INV,IKOV    !!! from groups
	USE COM_CHIMAT  ,ONLY: NREP,NCHI,INCHI,CHI0              !!! from intchi
	USE COM_QMESH   ,ONLY: NQPNT,QPNT                        !!! from tetra
	USE COM_FREQU   ,ONLY: NOMGCHI,OMGCHI                    !!! from tetra
	USE COM_MASHDEP ,ONLY: LENCMP,NVAL                       !!! from readini
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                !!! from readini
	USE COM_CHANNELS,ONLY: IUCHI                             !!! from channels
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                   !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER MTR(2)
      COMPLEX*16, ALLOCATABLE :: UTR(:,:)
      COMPLEX*16, ALLOCATABLE :: TCHI(:,:)
      COMPLEX*16, ALLOCATABLE :: CH(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: CHIM(:,:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: ODD(:,:)
	COMPLEX*16 CHTM(-1:2,-1:2,2),CHX(0:3,0:3,2)
     &     ,CHM(-1:2,-1:2,2),TR(-1:1,3),PCHI,TC(-3:3,7,0:3)
	CHARACTER TCPS*19,PT*19,POLS(-1:2)*1,POLC(0:3)*1
     &     ,TXTH*30
	DATA PI/3.141592653589793D0/,MTR/-1,+1/,ICUBC/1/
      DATA TR/(+0.70710678118655D0, 0.00000000000000D0)
     &       ,( 0.00000000000000D0, 0.00000000000000D0)
     &       ,(-0.70710678118655D0, 0.00000000000000D0)
     &       ,( 0.00000000000000D0,+0.70710678118655D0)
     &       ,( 0.00000000000000D0, 0.00000000000000D0)
     &       ,( 0.00000000000000D0,+0.70710678118655D0)
     &       ,( 0.00000000000000D0, 0.00000000000000D0)
     &       ,( 1.00000000000000D0, 0.00000000000000D0)
     &       ,( 0.00000000000000D0, 0.00000000000000D0)/
      DATA POLS/'m','z','p','v'/,POLC/'0','x','y','z'/
      SQPI4=2.D0*SQRT(PI)
C MEMORY ALLOCAIONS
      ALLOCATE(UTR(LIMB2MEM,NATOM))
      ALLOCATE(TCHI(NCHIMEM,NCHIMEM))
      ALLOCATE(CH(-LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM
     &           ,-LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM,3))
	ALLOCATE(CHIM(LIMBMEM,NATOMMEM,-1:2,-1:2,2))
      ALLOCATE(ODD(0:LMAXTMEM,NSORTMEM))
C FIND TRANSFORMATION MATRICES
      CALL TRANSC(TC)
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)
      CALL TRANSU(L,ROUTAXE(1,L,IATOM),ROUTANG(L,IATOM)
     &    ,ROUTINV(L,IATOM),UTR(1,IATOM),LIMB2MEM)
	ODD(L,ISORT)=(0.D0,0.D0)
      ENDDO
      ENDDO
      DO MY1=-1,2
      DO MY =-1,2
      CHTM(MY1,MY,1)=(0.D0,0.D0)
      CHTM(MY1,MY,2)=(0.D0,0.D0)
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
      CHIM(LM,IATOM,MY1,MY,1)=(0.D0,0.D0)
      CHIM(LM,IATOM,MY1,MY,2)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C DO GLOBALLY OVER PARTIAL CONTRIBUTIONS
	DO 5000 IUPDN4=1,NSPIN                          !!! over spinors
	IF(NORBS.EQ.2)IORBS4=IUPDN4
	IF(NORBS.EQ.1)IORBS4=1
	DO 4000 IUPDN3=1,NSPIN                          !!! over spinors
	IF(NORBS.EQ.2)IORBS3=IUPDN3
	IF(NORBS.EQ.1)IORBS3=1
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
	    IF(IUPDN4.EQ.1.AND.IUPDN3.EQ.1)THEN
	ISPIN1=1
	ITRAN1=0
	SIGNF1=1.D0
	ELSEIF(IUPDN4.EQ.2.AND.IUPDN3.EQ.2)THEN
	ISPIN1=2
	ITRAN1=0
	SIGNF1=1.D0
	ELSEIF(IUPDN4.EQ.1.AND.IUPDN3.EQ.2)THEN
	ISPIN1=0
	ITRAN1=1
	SIGNF1=+SQRT(2.D0)
	ELSEIF(IUPDN4.EQ.2.AND.IUPDN3.EQ.1)THEN
	ISPIN1=0
	ITRAN1=2
	SIGNF1=-SQRT(2.D0)
	ENDIF
	DO 3000 IUPDN2=1,NSPIN                          !!! over spinors
	IF(NORBS.EQ.2)IORBS2=IUPDN2
	IF(NORBS.EQ.1)IORBS2=1
	DO 2000 IUPDN1=1,NSPIN                          !!! over spinors
	IF(NORBS.EQ.2)IORBS1=IUPDN1
	IF(NORBS.EQ.1)IORBS1=1
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
	    IF(IUPDN2.EQ.1.AND.IUPDN1.EQ.1)THEN
	IF(NORBS.EQ.1.AND.ITRAN1.NE.0)GOTO2000
	ISPIN=1
	ITRAN=0
	SIGNF=1.D0
	ELSEIF(IUPDN2.EQ.2.AND.IUPDN1.EQ.2)THEN
	IF(NORBS.EQ.1.AND.ITRAN1.NE.0)GOTO2000
	ISPIN=2
	ITRAN=0
	SIGNF=1.D0
	ELSEIF(IUPDN2.EQ.1.AND.IUPDN1.EQ.2)THEN
	IF(NORBS.EQ.1.AND.ITRAN1.NE.2)GOTO2000
	ISPIN=0
	ITRAN=1
	SIGNF=+SQRT(2.D0)
	ELSEIF(IUPDN2.EQ.2.AND.IUPDN1.EQ.1)THEN
	IF(NORBS.EQ.1.AND.ITRAN1.NE.1)GOTO2000
	ISPIN=0
	ITRAN=2
	SIGNF=-SQRT(2.D0)
	ENDIF
C  READ SUSCEPTIBILITY
	CALL CHIFILES(ISPIN,ITRAN,ISPIN1,ITRAN1,IQPNT,IOMG,IUCHI,'R')
	DO 1000 IREIM=1,2                                 !!! over re/im parts
C  TRANSFORM SUSCEPTIBILITY TO LOCAL COORDINATES
	DO 200 IREP1=1,NREP                               !!! over irep1
	DO 100 IREP =1,NREP                               !!! over irep
	DO ICHI=1,NCHI
	DO ICHI1=1,NCHI
	TCHI(ICHI,ICHI1)=(0.D0,0.D0)
	ENDDO
	ENDDO
	DO IATOM1=1,NATOM                                 !!! over atoms
	ISORT1=IS(IATOM1)
	DO L4=0,ILSB(ISORT1)                              !!! over l4
	IF(.NOT.LTBAS(L4,IATOM1))CYCLE
	DO L3=0,ILSB(ISORT1)                              !!! over l3
	IF(.NOT.LTBAS(L3,IATOM1))CYCLE
	DO IATOM=1,NATOM                                  !!! over atoms
	ISORT=IS(IATOM)
	DO L2=0,ILSB(ISORT)                               !!! over l2
	IF(.NOT.LTBAS(L2,IATOM))CYCLE
	DO L1=0,ILSB(ISORT)                               !!! over l1
	IF(.NOT.LTBAS(L1,IATOM))CYCLE
C
	DO M4=-L4,L4                                      !!! over m4
	DO M3=-L3,L3                                      !!! over m3
	DO M2=-L2,L2                                      !!! over m2
	DO M1=-L1,L1                                      !!! over m1
	CH(M2,M1,M4,M3,1)=(0.D0,0.D0)
	CH(M2,M1,M4,M3,2)=(0.D0,0.D0)
	CH(M2,M1,M4,M3,3)=(0.D0,0.D0)
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over m2
	ENDDO                                             !!! over m3
	ENDDO                                             !!! over m4
C
	DO M4=-L4,L4                                      !!! over m4
	L4M4=L4*(L4+1)+M4+1
	DO M3=-L3,L3                                      !!! over m3
	L3M3=L3*(L3+1)+M3+1
	DO M2=-L2,L2                                      !!! over m2
	L2M2=L2*(L2+1)+M2+1
	DO M1=-L1,L1                                      !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO K1=-L1,L1                                      !!! over k1
	L1K1=L1*(L1+1)+K1+1
      IK1M1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+M1)+L1+K1+1  !  (l1,k1 m1) packed
	ICHI21=INCHI(L2M2,L1K1,IATOM)
	ICHI43=INCHI(L4M4,L3M3,IATOM1)
	CH(M2,M1,M4,M3,1)=CH(M2,M1,M4,M3,1)+U(IK1M1,IATOM)*
     &CHI0(ICHI21,ICHI43,IREP,IREP1,IREIM)
	ENDDO                                             !!! over k1
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over m2
	ENDDO                                             !!! over m3
	ENDDO                                             !!! over m4

	DO M4=-L4,L4                                      !!! over m4
	DO M3=-L3,L3                                      !!! over m3
	DO M2=-L2,L2                                      !!! over m2
	DO M1=-L1,L1                                      !!! over m1
	DO K2=-L2,L2                                      !!! over k2
      IK2M2=L2*(2*L2-1)*(2*L2+1)/3+(2*L2+1)*(L2+M2)+L2+K2+1  !  (l2,k2 m2) packed
	CH(M2,M1,M4,M3,2)=CH(M2,M1,M4,M3,2)+
     &CONJG(U(IK2M2,IATOM))*CH(K2,M1,M4,M3,1)
	ENDDO                                             !!! over k2
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over m2
	ENDDO                                             !!! over m3
	ENDDO                                             !!! over m4

	DO M4=-L4,L4                                      !!! over m4
	DO M3=-L3,L3                                      !!! over m3
	DO M2=-L2,L2                                      !!! over m2
	DO M1=-L1,L1                                      !!! over m1
	DO K4=-L4,L4                                      !!! over k4
      IK4M4=L4*(2*L4-1)*(2*L4+1)/3+(2*L4+1)*(L4+M4)+L4+K4+1  !  (l4,k4 m4) packed
	CH(M2,M1,M4,M3,3)=CH(M2,M1,M4,M3,3)+
     &CH(M2,M1,K4,M3,2)*CONJG(U(IK4M4,IATOM1))
	ENDDO                                             !!! over k4
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over m2
	ENDDO                                             !!! over m3
	ENDDO                                             !!! over m4

	DO M4=-L4,L4                                      !!! over m4
	L4M4=L4*(L4+1)+M4+1
	DO M3=-L3,L3                                      !!! over m3
	L3M3=L3*(L3+1)+M3+1
	DO M2=-L2,L2                                      !!! over m2
	L2M2=L2*(L2+1)+M2+1
	DO M1=-L1,L1                                      !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO K3=-L3,L3                                      !!! over k3
      IK3M3=L3*(2*L3-1)*(2*L3+1)/3+(2*L3+1)*(L3+M3)+L3+K3+1  !  (l3,k3 m3) packed
	ICHI21=INCHI(L2M2,L1M1,IATOM)
	ICHI43=INCHI(L4M4,L3M3,IATOM1)
	TCHI(INCHI(L2M2,L1M1,IATOM),INCHI(L4M4,L3M3,IATOM1))=
     &TCHI(INCHI(L2M2,L1M1,IATOM),INCHI(L4M4,L3M3,IATOM1))+
     &CH(M2,M1,M4,K3,3)*U(IK3M3,IATOM1)
	ENDDO                                             !!! over k3
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over m2
	ENDDO                                             !!! over m3
	ENDDO                                             !!! over m4
C
	ENDDO                                             !!! over l1
	ENDDO                                             !!! over l2
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over l3
	ENDDO                                             !!! over l4
	ENDDO                                             !!! over atoms
C Transform to cubic harmonics
	DO ICHI=1,NCHI
	DO ICHI1=1,NCHI
	CHI0(ICHI,ICHI1,IREP,IREP1,IREIM)=(0.D0,0.D0)
	ENDDO
	ENDDO
	IF(ICUBC.EQ.1)THEN
	DO IATOM1=1,NATOM                                 !!! over atoms
	ISORT1=IS(IATOM1)
	DO L4=0,ILSB(ISORT1)                              !!! over l4
	IF(.NOT.LTBAS(L4,IATOM1))CYCLE
	DO L3=0,ILSB(ISORT1)                              !!! over l3
	IF(.NOT.LTBAS(L3,IATOM1))CYCLE
	DO IATOM=1,NATOM                                  !!! over atoms
	ISORT=IS(IATOM)
	DO L2=0,ILSB(ISORT)                               !!! over l2
	IF(.NOT.LTBAS(L2,IATOM))CYCLE
	DO L1=0,ILSB(ISORT)                               !!! over l1
	IF(.NOT.LTBAS(L1,IATOM))CYCLE
C
	DO M4=-L4,L4                                      !!! over m4
	DO M3=-L3,L3                                      !!! over m3
	DO M2=-L2,L2                                      !!! over m2
	DO M1=-L1,L1                                      !!! over m1
	CH(M2,M1,M4,M3,1)=(0.D0,0.D0)
	CH(M2,M1,M4,M3,2)=(0.D0,0.D0)
	CH(M2,M1,M4,M3,3)=(0.D0,0.D0)
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over m2
	ENDDO                                             !!! over m3
	ENDDO                                             !!! over m4
C
	DO M4=-L4,L4                                      !!! over m4
	L4M4=L4*(L4+1)+M4+1
	DO M3=-L3,L3                                      !!! over m3
	L3M3=L3*(L3+1)+M3+1
	DO M2=-L2,L2                                      !!! over m2
	L2M2=L2*(L2+1)+M2+1
	DO M1=-L1,L1                                      !!! over m1
	L1M1=L1*(L1+1)+M1+1
	I1=M1+L1+1
	DO K1=-L1,L1                                      !!! over k1
	L1K1=L1*(L1+1)+K1+1
	CH(M2,M1,M4,M3,1)=CH(M2,M1,M4,M3,1)+TC(K1,I1,L1)*
     &TCHI(INCHI(L2M2,L1K1,IATOM),INCHI(L4M4,L3M3,IATOM1))
	ENDDO                                             !!! over k1
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over m2
	ENDDO                                             !!! over m3
	ENDDO                                             !!! over m4

	DO M4=-L4,L4                                      !!! over m4
	DO M3=-L3,L3                                      !!! over m3
	DO M2=-L2,L2                                      !!! over m2
	I2=M2+L2+1
	DO M1=-L1,L1                                      !!! over m1
	DO K2=-L2,L2                                      !!! over k2
	CH(M2,M1,M4,M3,2)=CH(M2,M1,M4,M3,2)+
     &CONJG(TC(K2,I2,L2))*CH(K2,M1,M4,M3,1)
	ENDDO                                             !!! over k2
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over m2
	ENDDO                                             !!! over m3
	ENDDO                                             !!! over m4

	DO M4=-L4,L4                                      !!! over m4
	I4=M4+L4+1
	DO M3=-L3,L3                                      !!! over m3
	DO M2=-L2,L2                                      !!! over m2
	DO M1=-L1,L1                                      !!! over m1
	DO K4=-L4,L4                                      !!! over k4
	CH(M2,M1,M4,M3,3)=CH(M2,M1,M4,M3,3)+
     &CH(M2,M1,K4,M3,2)*CONJG(TC(K4,I4,L4))
	ENDDO                                             !!! over k4
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over m2
	ENDDO                                             !!! over m3
	ENDDO                                             !!! over m4

	DO M4=-L4,L4                                      !!! over m4
	L4M4=L4*(L4+1)+M4+1
	DO M3=-L3,L3                                      !!! over m3
	L3M3=L3*(L3+1)+M3+1
	I3=M3+L3+1
	DO M2=-L2,L2                                      !!! over m2
	L2M2=L2*(L2+1)+M2+1
	DO M1=-L1,L1                                      !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO K3=-L3,L3                                      !!! over k3
	ICHI21=INCHI(L2M2,L1M1,IATOM)
	ICHI43=INCHI(L4M4,L3M3,IATOM1)
	CHI0(ICHI21,ICHI43,IREP,IREP1,IREIM)=
     &CHI0(ICHI21,ICHI43,IREP,IREP1,IREIM)+
     &CH(M2,M1,M4,K3,3)*TC(K3,I3,L3)
	ENDDO                                             !!! over k3
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over m2
	ENDDO                                             !!! over m3
	ENDDO                                             !!! over m4
C
	ENDDO                                             !!! over l1
	ENDDO                                             !!! over l2
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over l3
	ENDDO                                             !!! over l4
	ENDDO                                             !!! over atoms
	ELSEIF(ICUBC.EQ.2)THEN
	DO ICHI=1,NCHI
	DO ICHI1=1,NCHI
	CHI0(ICHI,ICHI1,IREP,IREP1,IREIM)=TCHI(ICHI,ICHI1)
	ENDDO
	ENDDO
	ENDIF
  100	CONTINUE                                          !!! over irep
  200	CONTINUE                                          !!! over irep1
C FIND TOTAL
	PCHI=(0.D0,0.D0)
	DO IATOM1=1,NATOM                                 !!! over atoms
	ISORT1=IS(IATOM1)
	DO L3=0,ILSB(ISORT1)                              !!! over l3
	IF(.NOT.LTBAS(L3,IATOM1))CYCLE
	DO M3=-L3,L3                                      !!! over m3
	L3M3=L3*(L3+1)+M3+1
	DO IATOM=1,NATOM                                  !!! over atoms
	ISORT=IS(IATOM)
	DO L1=0,ILSB(ISORT)                               !!! over l1
	IF(.NOT.LTBAS(L1,IATOM))CYCLE
	DO M1=-L1,L1                                      !!! over m1
	L1M1=L1*(L1+1)+M1+1
	PCHI=PCHI+
     &CHI0(INCHI(L1M1,L1M1,IATOM),INCHI(L3M3,L3M3,IATOM1),1,1,IREIM)
	IF(NREP.GT.1)
     &PCHI=PCHI+
     &CHI0(INCHI(L1M1,L1M1,IATOM),INCHI(L3M3,L3M3,IATOM1),1,4,IREIM)*
     &ODD(L3,ISORT)+
     &CHI0(INCHI(L1M1,L1M1,IATOM),INCHI(L3M3,L3M3,IATOM1),4,1,IREIM)*
     &ODD(L1,ISORT)+
     &CHI0(INCHI(L1M1,L1M1,IATOM),INCHI(L3M3,L3M3,IATOM1),4,4,IREIM)*
     &ODD(L1,ISORT)*ODD(L3,ISORT)
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over l1
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over m3
	ENDDO                                             !!! over l3
	ENDDO                                             !!! over atoms
	IF(ITRAN1.NE.0.AND.ITRAN.NE.0)THEN
	MY1=MTR(ITRAN1)
	MY =MTR(ITRAN )
	CHTM(MY1,MY,IREIM)=CHTM(MY1,MY,IREIM)+PCHI
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)
	IF(.NOT.LTBAS(L,IATOM))CYCLE
	DO M=-L,L
	LM=L*(L+1)+M+1
	CHIM(LM,IATOM,MY1,MY,IREIM)=CHIM(LM,IATOM,MY1,MY,IREIM)+
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),1,1,IREIM)
	IF(NREP.GT.1)
     &CHIM(LM,IATOM,MY1,MY,IREIM)=CHIM(LM,IATOM,MY1,MY,IREIM)+
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),1,4,IREIM)*
     &ODD(L,ISORT)+
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),4,1,IREIM)*
     &ODD(L,ISORT)+
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),4,4,IREIM)*
     &ODD(L,ISORT)*ODD(L,ISORT)
	ENDDO
	ENDDO
	ENDDO
	ELSEIF(ISPIN1.NE.0.AND.ITRAN.NE.0)THEN
	MY =MTR(ITRAN )
	CHTM(0,MY,IREIM)=CHTM(0,MY,IREIM)+(-1)**(ISPIN1+1)*PCHI
	CHTM(2,MY,IREIM)=CHTM(2,MY,IREIM)+PCHI
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)
	IF(.NOT.LTBAS(L,IATOM))CYCLE
      DO M=-L,L
      LM=L*(L+1)+M+1
      CHIM(LM,IATOM,0,MY,IREIM)=CHIM(LM,IATOM,0,MY,IREIM)+
     &(-1)**(ISPIN1+1)*
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),1,1,IREIM)
      CHIM(LM,IATOM,2,MY,IREIM)=CHIM(LM,IATOM,2,MY,IREIM)+
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),1,1,IREIM)
      IF(NREP.GT.1)
     &CHIM(LM,IATOM,0,MY,IREIM)=CHIM(LM,IATOM,0,MY,IREIM)+
     &(-1)**(ISPIN1+1)*
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),1,4,IREIM)*
     &ODD(L,ISORT)+(-1)**(ISPIN1+1)*
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),4,1,IREIM)*
     &ODD(L,ISORT)+(-1)**(ISPIN1+1)*
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),4,4,IREIM)*
     &ODD(L,ISORT)*ODD(L,ISORT)
      IF(NREP.GT.1)
     &CHIM(LM,IATOM,2,MY,IREIM)=CHIM(LM,IATOM,2,MY,IREIM)+
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),1,4,IREIM)*
     &ODD(L,ISORT)+
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),4,1,IREIM)*
     &ODD(L,ISORT)+
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),4,4,IREIM)*
     &ODD(L,ISORT)*ODD(L,ISORT)
      ENDDO
      ENDDO
      ENDDO
	ELSEIF(ITRAN1.NE.0.AND.ISPIN.NE.0)THEN
	MY1=MTR(ITRAN1) 
	CHTM(MY1,0,IREIM)=CHTM(MY1,0,IREIM)+(-1)**(ISPIN+1)*PCHI
	CHTM(MY1,2,IREIM)=CHTM(MY1,2,IREIM)+PCHI
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)
	IF(.NOT.LTBAS(L,IATOM))CYCLE
      DO M=-L,L
      LM=L*(L+1)+M+1
      CHIM(LM,IATOM,MY1,0,IREIM)=CHIM(LM,IATOM,MY1,0,IREIM)+
     &(-1)**(ISPIN+1)*
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),1,1,IREIM)
      CHIM(LM,IATOM,MY1,2,IREIM)=CHIM(LM,IATOM,MY1,2,IREIM)+
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),1,1,IREIM)
      IF(NREP.GT.1)
     &CHIM(LM,IATOM,MY1,0,IREIM)=CHIM(LM,IATOM,MY1,0,IREIM)+
     &(-1)**(ISPIN+1)*
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),1,4,IREIM)*
     &ODD(L,ISORT)+(-1)**(ISPIN+1)*
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),4,1,IREIM)*
     &ODD(L,ISORT)+(-1)**(ISPIN+1)*
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),4,4,IREIM)*
     &ODD(L,ISORT)*ODD(L,ISORT)
      IF(NREP.GT.1)
     &CHIM(LM,IATOM,MY1,2,IREIM)=CHIM(LM,IATOM,MY1,2,IREIM)+
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),1,4,IREIM)*
     &ODD(L,ISORT)+
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),4,1,IREIM)*
     &ODD(L,ISORT)+
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),4,4,IREIM)*
     &ODD(L,ISORT)*ODD(L,ISORT)
      ENDDO
      ENDDO
      ENDDO
	ELSEIF(ISPIN1.NE.0.AND.ISPIN.NE.0)THEN
	IF(NSPIN.EQ.2)THEN
	CHTM(0,0,IREIM)=CHTM(0,0,IREIM)+(-1)**(ISPIN1+ISPIN)*PCHI
	CHTM(0,2,IREIM)=CHTM(0,2,IREIM)+(-1)**(ISPIN1+1)*PCHI
	CHTM(2,0,IREIM)=CHTM(2,0,IREIM)+(-1)**(ISPIN +1)*PCHI
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)
	IF(.NOT.LTBAS(L,IATOM))CYCLE
      DO M=-L,L
      LM=L*(L+1)+M+1
      CHIM(LM,IATOM,0,0,IREIM)=CHIM(LM,IATOM,0,0,IREIM)+
     &(-1)**(ISPIN1+ISPIN)*
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),1,1,IREIM)
      CHIM(LM,IATOM,0,2,IREIM)=CHIM(LM,IATOM,0,2,IREIM)+
     &(-1)**ISPIN1*
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),1,1,IREIM)
      CHIM(LM,IATOM,2,0,IREIM)=CHIM(LM,IATOM,2,0,IREIM)+
     &(-1)**ISPIN*
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),1,1,IREIM)
      IF(NREP.GT.1)
     &CHIM(LM,IATOM,0,0,IREIM)=CHIM(LM,IATOM,0,0,IREIM)+
     &(-1)**(ISPIN1+ISPIN)*
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),1,4,IREIM)*
     &ODD(L,ISORT)+(-1)**(ISPIN1+ISPIN)*
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),4,1,IREIM)*
     &ODD(L,ISORT)+(-1)**(ISPIN1+ISPIN)*
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),4,4,IREIM)*
     &ODD(L,ISORT)*ODD(L,ISORT)
      IF(NREP.GT.1)
     &CHIM(LM,IATOM,0,2,IREIM)=CHIM(LM,IATOM,0,2,IREIM)+
     &(-1)**ISPIN1*
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),1,4,IREIM)*
     &ODD(L,ISORT)+(-1)**ISPIN1*
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),4,1,IREIM)*
     &ODD(L,ISORT)+(-1)**ISPIN1*
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),4,4,IREIM)*
     &ODD(L,ISORT)*ODD(L,ISORT)
      IF(NREP.GT.1)
     &CHIM(LM,IATOM,2,0,IREIM)=CHIM(LM,IATOM,2,0,IREIM)+
     &(-1)**ISPIN*
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),1,4,IREIM)*
     &ODD(L,ISORT)+(-1)**ISPIN*
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),4,1,IREIM)*
     &ODD(L,ISORT)+(-1)**ISPIN*
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),4,4,IREIM)*
     &ODD(L,ISORT)*ODD(L,ISORT)
      ENDDO
      ENDDO
      ENDDO
	ENDIF
	CHTM(2,2,IREIM)=CHTM(2,2,IREIM)+PCHI
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)
	IF(.NOT.LTBAS(L,IATOM))CYCLE
      DO M=-L,L
      LM=L*(L+1)+M+1
      CHIM(LM,IATOM,2,2,IREIM)=CHIM(LM,IATOM,2,2,IREIM)+
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),1,1,IREIM)
      IF(NREP.GT.1)
     &CHIM(LM,IATOM,2,2,IREIM)=CHIM(LM,IATOM,2,2,IREIM)+
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),1,4,IREIM)*
     &ODD(L,ISORT)+
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),4,1,IREIM)*
     &ODD(L,ISORT)+
     &CHI0(INCHI(LM,LM,IATOM),INCHI(LM,LM,IATOM),4,4,IREIM)*
     &ODD(L,ISORT)*ODD(L,ISORT)
      ENDDO
      ENDDO
      ENDDO
	ENDIF
1000	CONTINUE                                          !!! over re/im parts
2000	CONTINUE                                          !!! over spinors
3000	CONTINUE                                          !!! over spinors
4000	CONTINUE                                          !!! over spinors
5000	CONTINUE                                          !!! over spinors
      WRITE(IUN,1010)
1010  FORMAT(1X,'** COMPLEX SUSCEPTIBILITY Chi(q,omega) **')
      WRITE(IUN,1020)(QPNT(I,IQPNT),I=1,3)
      WRITE(IUN,1030)OMGCHI(IOMG),OMGCHI(IOMG)*13605.8D0
1020  FORMAT(1X,'Q-VECTOR: (',G11.4,',',G11.4,',',G11.4,')')
1030  FORMAT(1X,'FREQUENCY =',G14.7,' Ry ; ',G14.7,' meV.')
C TRANSFORM TO CARTESIAN SYSTEM
	DO KPAR=1,2                        !!! over kpar
	DO IATOM=1,NATOM                   !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                 !!! over l
	IF(.NOT.LTBAS(L,IATOM).AND.KPAR.EQ.2)CYCLE
	DO M=-L,L                          !!! over m
	LM=L*(L+1)+M+1
      NM=NODES(L,ISORT,1,1)+L+1
	IF(KPAR.EQ.1.AND.(IATOM.GT.1.OR.LM.GT.1))CYCLE
	DO MY1=-1,2
	DO MY=-1,2
	IF(KPAR.EQ.1)THEN
	CHM(MY1,MY,1)=CHTM(MY1,MY,1)
	CHM(MY1,MY,2)=CHTM(MY1,MY,2)
	ELSEIF(KPAR.EQ.2)THEN
	CHM(MY1,MY,1)=CHIM(LM,IATOM,MY1,MY,1)
	CHM(MY1,MY,2)=CHIM(LM,IATOM,MY1,MY,2)
	ENDIF
	ENDDO
	ENDDO
	DO IREIM=1,2
C FIELD-FIELD
      DO IX1=1,3                         !!! over x,y,z
      DO IX=1,3                          !!! over x,y,z
      CHX(IX1,IX,IREIM)=(0.0,0.0)
      DO MY1=-1,1                        !!! over -1,0,1
      DO MY=-1,1                         !!! over -1,0,1
      CHX(IX1,IX,IREIM)=CHX(IX1,IX,IREIM)+
     &CHM(MY1,MY,IREIM)*TR(MY1,IX1)*TR(MY,IX)
      ENDDO                              !!! over -1,0,1
      ENDDO                              !!! over -1,0,1
      ENDDO                              !!! over x,y,z
      ENDDO                              !!! over x,y,z
C FIELD-SCALAR
      DO IX1=1,3                         !!! over x,y,z
      DO IX=0,0                          !!! over x,y,z
      CHX(IX1,IX,IREIM)=(0.0,0.0)
      DO MY1=-1,1                        !!! over -1,0,1
      DO MY=2,2                          !!! over -1,0,1
      CHX(IX1,IX,IREIM)=CHX(IX1,IX,IREIM)+
     &CHM(MY1,MY,IREIM)*TR(MY1,IX1)
      ENDDO                              !!! over -1,0,1
      ENDDO                              !!! over -1,0,1
      ENDDO                              !!! over x,y,z
      ENDDO                              !!! over x,y,z
C SCALAR-FIELD
      DO IX1=0,0                         !!! over x,y,z
      DO IX=1,3                          !!! over x,y,z
      CHX(IX1,IX,IREIM)=(0.0,0.0)
      DO MY1=2,2                         !!! over -1,0,1
      DO MY=-1,1                         !!! over -1,0,1
      CHX(IX1,IX,IREIM)=CHX(IX1,IX,IREIM)+
     &CHM(MY1,MY,IREIM)*TR(MY,IX)
      ENDDO                              !!! over -1,0,1
      ENDDO                              !!! over -1,0,1
      ENDDO                              !!! over x,y,z
      ENDDO                              !!! over x,y,z
C SCALAR-SCALAR
      DO IX1=0,0                         !!! over x,y,z
      DO IX=0,0                          !!! over x,y,z
      CHX(IX1,IX,IREIM)=(0.0,0.0)
      DO MY1=2,2                         !!! over -1,0,1
      DO MY =2,2                         !!! over -1,0,1
      CHX(IX1,IX,IREIM)=CHX(IX1,IX,IREIM)+
     &CHM(MY1,MY,IREIM)
      ENDDO                              !!! over -1,0,1
      ENDDO                              !!! over -1,0,1
      ENDDO                              !!! over x,y,z
      ENDDO                              !!! over x,y,z
	ENDDO                              !!! over re/im
C PRINT SUSCEPTIBILITY
	IF(KPAR.EQ.1)THEN
 	WRITE(IUN,1040)
1040	FORMAT(1X,'TOTAL PART:')
	ELSEIF(KPAR.EQ.2)THEN
	CALL SET_STATE(TXTH,30,TXTAT(ISORT),IATOM,0,NM,L,M,ICUBC)
      CALL FIND_LBLANK(TXTH,30,NBL)
 	WRITE(IUN,1050)TXTH(1:NBL)
1050	FORMAT(1X,'Partial contribution from ',A30)
	ENDIF
      WRITE(IUN,1060)(POLS(MY),MY=-1,2),' REAL'
      DO MY1=-1,2
      WRITE(IUN,1070)POLS(MY1),(CHM(MY1,MY,1),MY=-1,2)
      ENDDO
      WRITE(IUN,1060)(POLS(MY),MY=-1,2),' IMAG'
      DO MY1=-1,2
      WRITE(IUN,1070)POLS(MY1),(CHM(MY1,MY,2),MY=-1,2)
      ENDDO
      WRITE(IUN,1060)(POLC(IX),IX=0,3),' REAL'
      DO IX1=0,3
      WRITE(IUN,1070)POLC(IX1),(CHX(IX1,IX,1),IX=0,3)
      ENDDO
      WRITE(IUN,1060)(POLC(IX),IX=0,3),' IMAG'
      DO IX1=0,3
      WRITE(IUN,1070)POLC(IX1),(CHX(IX1,IX,2),IX=0,3)
      ENDDO
1060  FORMAT(4X,11X,A1,11X,11X,A1,11X,11X,A1,11X,11X,A1,A5)
1070  FORMAT(1X,A1,1X,2G11.4,'|',2G11.4,'|',2G11.4,'|',2G11.4)
	ENDDO                               !!! over m
	ENDDO                               !!! over l
	ENDDO                               !!! over iatom
	ENDDO                               !!! over kpar
C MEMORY DEALLOCATIONS
	DEALLOCATE(UTR,TCHI,CH,CHIM,ODD)
      END
