	SUBROUTINE LMTVAR(IPNT,IPAN,IENW)
*****************************************************
*  Contribution to the Pulay force going from the   *
*  change in the hamiltonian and overlap matrix     *
*  connected with the change in the structure con-  *
*  stants.                                          *
*****************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LMTO,IASA,NPFR,NOVR              !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS       !!! from readini
     &                      ,ILST,ILSB
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SWZ                          !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC          !!! from readini
      USE COM_OVRPAR  ,ONLY: OPARHH,OPARJH,OPARHJ,OPARJJ      !!! from ovrpar
      USE COM_ORBPAR  ,ONLY: SPARHH,SPARJH,SPARHJ,SPARJJ      !!! from orbpar
      USE COM_KMESH   ,ONLY: NPNT,PNT                         !!! from tetra
      USE COM_ENERGY  ,ONLY: EARR                             !!! from bands
      USE COM_STRCON  ,ONLY: SSCON,SDCON                      !!! from strgnt
      USE COM_GAUNT   ,ONLY: C                                !!! from makegnt
      USE COM_PULAYF  ,ONLY: PILF                             !!! from lmtvar
	USE COM_CHANNELS,ONLY: IUWFK,IUPSI                      !!! from readini
	USE COM_MASHDEP ,ONLY: LENCMP                           !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, INTRINSIC :: SIZE
	REAL*8, ALLOCATABLE :: SLM(:,:,:)
	COMPLEX*16, ALLOCATABLE :: BHHF(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: BOOF(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: CGNT(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: AKL(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: SKL(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DSKL(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DSKLDOT(:,:,:)
	COMPLEX*16 DSDOTNUC(-1:1),DSKLDNUC(-1:1),CHDOT,CODOT
     &  ,CCHJH,CCHHJ,CCHJJ1,CCHJJ2,CCOJH,CCOHJ,CCOJJ1,CCOJJ2
     &  ,CONVHHM,CONVOOM,CONVOOP,CONVHHP,SKLDOT
C HAMILTONIAN PARAMETERS WITH NEW INDEXATION NECESSARY
	COMPLEX*16, ALLOCATABLE :: HPARHH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: HPARJH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: HPARHJ(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: HPARJJ(:,:,:,:)
	LOGICAL LOG
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
	SQPI43=SQRT(4.D0*PI/3.D0)
C RETURN KEYS
	IF(NPFR.EQ.0.OR.IENW.EQ.1)GOTO 5000
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
	ALLOCATE(SLM(LIMTMEM,2,2))
	ALLOCATE(BHHF(-1:1,NATOMMEM,NSPINMEM,NDIMMEM))
	ALLOCATE(BOOF(-1:1,NATOMMEM,NSPINMEM,NDIMMEM))
	ALLOCATE(AKL(LIMBMEM,NATOMMEM,NKAPMEM,NSPINMEM,NDIMMEM))
	ALLOCATE(SKL(LIMT1MEM,NKAPMEM,NSPINMEM))
	ALLOCATE(DSKL(LIMT1MEM,NKAPMEM,NATOMMEM))
	ALLOCATE(DSKLDOT(LIMB1MEM,NKAPMEM,NATOMMEM))
	ALLOCATE(CGNT(LIMTMEM,NATOMMEM,-1:1,2))
      SIZE_BHHF=DBLE(SIZE(BHHF)*LENCMP)/1024.D0**2
      SIZE_BOOF=DBLE(SIZE(BOOF)*LENCMP)/1024.D0**2
      SIZE_AKL=DBLE(SIZE(AKL)*LENCMP)/1024.D0**2
	CURMEM=CURMEM+SIZE_BHHF+SIZE_BOOF+SIZE_AKL
	ALLOCATE(HPARHH(LIMBMEM,LIMBMEM,NKAPMEM,NKAPMEM))
	ALLOCATE(HPARJH(LIMTMEM,LIMBMEM,NKAPMEM,NKAPMEM))
	ALLOCATE(HPARHJ(LIMBMEM,LIMTMEM,NKAPMEM,NKAPMEM))
	ALLOCATE(HPARJJ(LIMTMEM,LIMTMEM,NKAPMEM,NKAPMEM))
      SIZE_HPARHH=DBLE(SIZE(HPARHH)*LENCMP)/1024.D0**2
      SIZE_HPARJH=DBLE(SIZE(HPARJH)*LENCMP)/1024.D0**2
      SIZE_HPARHJ=DBLE(SIZE(HPARHJ)*LENCMP)/1024.D0**2
      SIZE_HPARJJ=DBLE(SIZE(HPARJJ)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_HPARHH+SIZE_HPARJH+SIZE_HPARHJ+
     &SIZE_HPARJJ
      IF(TOTMEM.LT.CURMEM)TXTMEM='<LMTVAR> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C CALCULATE GAUNT-COEFFICIENT-COMBINATION ARRAY
	DO IATOM=1,NATOM                               !!! over atoms
	ISORT=IS(IATOM) 
	DO MY=-1,1                                     !!! over my
	DO L=0,ILST(ISORT)                             !!! over l
	DO M=-L,L                                      !!! over m
	LM=L*(L+1)+M+1
	LM1MY=(L-1)*L+M-MY+1
	LP1MY=(L+1)*(L+2)+M-MY+1
	CG1=0.D0
	IF(L.NE.0.AND.ABS(M-MY).LE.L-1)
     &CG1=C(0,LM,LM1MY)*SQPI43/(2.D0*L-1.D0)*SMT(ISORT)
	CG2=C(0,LM,LP1MY)*SQPI43*(2.D0*L+1.D0)/SMT(ISORT)
	CGNT(LM,IATOM,MY,1)=(0.D0,1.D0)*CG1
	CGNT(LM,IATOM,MY,2)=(0.D0,1.D0)*CG2
      ENDDO                                          !!! over m
      ENDDO                                          !!! over l
      ENDDO                                          !!! over my
      ENDDO                                          !!! over atoms
C SET <Ylm|s*l|Ylm>/2 MATRIX ELEMENT
      DO L=0,LMAXTMEM
      DO M=-L,L
      LM=L*(L+1)+M+1
      SLM(LM,1,1)=0.5D0*DBLE(+M)
      SLM(LM,2,1)=0.5D0*SQRT(DBLE((L-M)*(L+M+1)))
      SLM(LM,1,2)=0.5D0*SQRT(DBLE((L+M)*(L-M+1)))
      SLM(LM,2,2)=0.5D0*DBLE(-M)
      ENDDO
      ENDDO
C *** DO GLOBALLY OVER SPIN SUBBANDS ***
      DO 4000 IBNDS=1,NSPIN                          !!! over spin subbands
C READ EXPANSION COEFFICIENTS FOR OCCUPIED BANDS
      DO IORBS=1,NORBS                               !!! over spinor components
	DO IBNDT=1,NBNDF(IPAN)                         !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IKAP=1,NKAP(IPAN)                           !!! over energies
      IREC=IKAP+NKAP(IPAN)*(IBNDT-1)+
     &NKAP(IPAN)*NBNDF(IPAN)*(IBNDS-1)+
     &NKAP(IPAN)*NBNDF(IPAN)*NSPIN*(ISPIN-1)*(NORBS-1)
	READ(UNIT=IUWFK,REC=IREC)((AKL(LM,IATOM,IKAP,IORBS,IBNDT),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM)
	ENDDO                                          !!! over energies
	ENDDO                                          !!! over bands
	ENDDO                                          !!! over spinor components
C SET CONTRIBUTION FROM H- AND MATRICES TO ZERO
      DO IORBS=1,NORBS                               !!! over spinor components
	DO IBNDT=1,NBNDF(IPAN)                         !!! over bands
	DO INUC=1,NATOM                                !!! over displacements
	DO MY=-1,1                                     !!! over polarizations
	BHHF(MY,INUC,IORBS,IBNDT)=(0.D0,0.D0)
	BOOF(MY,INUC,IORBS,IBNDT)=(0.D0,0.D0)
      ENDDO                                          !!! over polarizations
      ENDDO                                          !!! over displacements
      ENDDO                                          !!! over bands
	ENDDO                                          !!! over spinor components
C DO GLOBALLY OVER SPINOR COMPONENTS AND ATOMS
	DO 3000 IORBS=1,NORBS                          !!! over spinor components
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
	DO 2000 IATOM=1,NATOM                          !!! over atoms
	ISORT=IS(IATOM)
C READ POTENTIAL PARAMETERS    
	DO IKAP1=1,NKAP(IPAN)                          !!! over energies
	DO IKAP =1,NKAP(IPAN)                          !!! over energies
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(ISPIN-1)
	READ(13,REC=IREC)((HPARHH(L1M1,LM,IKAP1,IKAP),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((HPARJH(L1M1,LM,IKAP1,IKAP),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((HPARHJ(L1M1,LM,IKAP1,IKAP),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((HPARJJ(L1M1,LM,IKAP1,IKAP),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
      ENDDO                                          !!! over energies
      ENDDO                                          !!! over energies
C **** DO GLOBALLY OVER VALENCE BANDS ****
	DO 1000 IBNDT=1,NBNDF(IPAN)                    !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
C CALCULATE CHANGE IN THE STRUCTURE CONSTANTS
	DO IKAP=1,NKAP(IPAN)                           !!! over energies
	DO L=0,ILST(ISORT)+1                           !!! over l
	LOG=.FALSE.
	IF(L.LE.ILSB(ISORT)+1)LOG=.TRUE.
	DO M=-L,L                                      !!! over m
	LM=L*(L+1)+M+1
	DO IORBS1=1,NORBS
	SKL(LM,IKAP,IORBS1)=(0.D0,0.D0) 
	ENDDO
	SKLDOT=(0.D0,0.D0)
	DO IATOM1=1,NATOM                              !!! over atoms
	ISORT1=IS(IATOM1)
	DSKL(LM,IKAP,IATOM1)=(0.D0,0.D0)
	IF(LOG)DSKLDOT(LM,IKAP,IATOM1)=(0.D0,0.D0)
	DO L1=0,ILSB(ISORT1)                           !!! over l1
	IF(LTPAN(L1,IATOM1,IKAP,IPAN))THEN
	DO M1=-L1,L1                                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO IORBS1=1,NORBS
	SKL(LM,IKAP,IORBS1)=SKL(LM,IKAP,IORBS1)+
     &SSCON(LM,IATOM,L1M1,IATOM1,IKAP)*
     &AKL(L1M1,IATOM1,IKAP,IORBS1,IBNDT)
	ENDDO
	DSKL(LM,IKAP,IATOM1)=DSKL(LM,IKAP,IATOM1)-
     &SSCON(LM,IATOM,L1M1,IATOM1,IKAP)*
     &AKL(L1M1,IATOM1,IKAP,IORBS,IBNDT)
	IF(LOG)DSKLDOT(LM,IKAP,IATOM1)=DSKLDOT(LM,IKAP,IATOM1)-
     &SDCON(LM,IATOM,L1M1,IATOM1,IKAP)*
     &AKL(L1M1,IATOM1,IKAP,IORBS,IBNDT)
      ENDDO                                          !!! over m1
	ENDIF
      ENDDO                                          !!! over l1
	IF(LOG)SKLDOT=SKLDOT-DSKLDOT(LM,IKAP,IATOM1)
      ENDDO                                          !!! over atoms
	DSKL(LM,IKAP,IATOM)=DSKL(LM,IKAP,IATOM)+SKL(LM,IKAP,IORBS)
	IF(LOG)DSKLDOT(LM,IKAP,IATOM)=DSKLDOT(LM,IKAP,IATOM)+SKLDOT
      ENDDO                                          !!! over m
      ENDDO                                          !!! over l
      ENDDO                                          !!! over energies
C **** DO GLOBALLY OVER LM,IKAP ****
	DO IKAP=1,NKAP(IPAN)                           !!! over energies
	DO L=0,ILST(ISORT)                             !!! over l
	LOG=.FALSE.
	IF(L.LE.ILSB(ISORT))LOG=.TRUE.
	DO M=-L,L                                      !!! over m
	LM=L*(L+1)+M+1
C CALCULATE CONVOLUTION WITH THE POTENTIAL PARAMETERS
	CCHJH =(0.D0,0.D0)
	CCHHJ =(0.D0,0.D0)
	CCHJJ1=(0.D0,0.D0)
	CCHJJ2=(0.D0,0.D0)
	CCOJH =(0.D0,0.D0)
	CCOHJ =(0.D0,0.D0)
	CCOJJ1=(0.D0,0.D0)
	CCOJJ2=(0.D0,0.D0)
	DO IKAP1=1,NKAP(IPAN)                          !!! over energies
C Hamiltonian parameters
	DO L1=0,ILST(ISORT)                            !!! over l1
	DO M1=-L1,L1                                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))
     &CCHJH=CCHJH+HPARJH(LM,L1M1,IKAP,IKAP1)*
     &AKL(L1M1,IATOM,IKAP1,IORBS,IBNDT)
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))
     &CCHHJ=CCHHJ+CONJG(HPARHJ(L1M1,LM,IKAP1,IKAP))*
     &AKL(L1M1,IATOM,IKAP1,IORBS,IBNDT)
	CCHJJ1=CCHJJ1+HPARJJ(LM,L1M1,IKAP,IKAP1)*
     &SKL(L1M1,IKAP1,IORBS)
      CCHJJ2=CCHJJ2+CONJG(HPARJJ(L1M1,LM,IKAP1,IKAP))*
     &SKL(L1M1,IKAP1,IORBS)
      ENDDO                                          !!! over m1
      ENDDO                                          !!! over l1
C Spin-orbit block (not debugged!!!)
      IF(NORBS.EQ.2)THEN
	DO IORBS1=1,NORBS
	IF(IORBS.EQ.1.AND.IORBS1.EQ.NORBS)ISIGN=+1
	IF(IORBS.EQ.NORBS.AND.IORBS1.EQ.1)ISIGN=-1
	IF(IORBS.EQ.IORBS1               )ISIGN= 0
	M1=M-ISIGN
      LM1=L*(L+1)+M1+1
      IF(LTPAN(L,IATOM,IKAP1,IPAN).AND.ABS(M1).LE.L)
     &CCHJH=CCHJH+SPARJH(IKAP,IKAP1,L,ISORT,IORBS,IORBS1)*
     &SLM(LM1,IORBS,IORBS1)*AKL(LM1,IATOM,IKAP1,IORBS1,IBNDT)
	M1=M+ISIGN
      LM1=L*(L+1)+M1+1
      IF(LTPAN(L,IATOM,IKAP1,IPAN).AND.ABS(M1).LE.L)
     &CCHHJ=CCHHJ+CONJG(SPARHJ(IKAP1,IKAP,L,ISORT,IORBS1,IORBS))*
     &SLM(LM,IORBS1,IORBS)*AKL(LM1,IATOM,IKAP1,IORBS1,IBNDT)
	M1=M-ISIGN
      LM1=L*(L+1)+M1+1
	IF(ABS(M1).LE.L)
     &CCHJJ1=CCHJJ1+SPARJJ(IKAP,IKAP1,L,ISORT,IORBS,IORBS1)*
     &SLM(LM1,IORBS,IORBS1)*SKL(LM1,IKAP1,IORBS1)
	M1=M+ISIGN
      LM1=L*(L+1)+M1+1
      IF(ABS(M1).LE.L)
     &CCHJJ2=CCHJJ2+CONJG(SPARJJ(IKAP1,IKAP,L,ISORT,IORBS1,IORBS))*
     &SLM(LM,IORBS1,IORBS)*SKL(LM1,IKAP1,IORBS1)
	ENDDO
      ENDIF
C Overlap parameters
	IF(LTPAN(L,IATOM,IKAP1,IPAN))
     &CCOJH=CCOJH+OPARJH(IKAP,IKAP1,L,ISORT,ISPIN)*
     &AKL(LM,IATOM,IKAP1,IORBS,IBNDT)
	IF(LTPAN(L,IATOM,IKAP1,IPAN))
     &CCOHJ=CCOHJ+CONJG(OPARHJ(IKAP1,IKAP,L,ISORT,ISPIN))*
     &AKL(LM,IATOM,IKAP1,IORBS,IBNDT)
	CCOJJ1=CCOJJ1+OPARJJ(IKAP,IKAP1,L,ISORT,ISPIN)*
     &SKL(LM,IKAP1,IORBS)
      CCOJJ2=CCOJJ2+CONJG(OPARJJ(IKAP1,IKAP,L,ISORT,ISPIN))*
     &SKL(LM,IKAP1,IORBS)
      ENDDO                                          !!! over energies
C S-dot parameters
	CHDOT=(0.D0,0.D0)
	CODOT=(0.D0,0.D0)
	IF(LTPAN(L,IATOM,IKAP,IPAN).AND.EKAP(IKAP,IPAN).EQ.
     &CONJG(EKAP(IKAP,IPAN)))THEN 
	CHDOT=-AKL(LM,IATOM,IKAP,IORBS,IBNDT)*EKAP(IKAP,IPAN)*PAR**3
	CODOT=-AKL(LM,IATOM,IKAP,IORBS,IBNDT)*PAR**3
	ENDIF
	CONVHHM=-CCHJH+CCHJJ1
	CONVOOM=-CCOJH+CCOJJ1
	CONVHHP=-CCHHJ+CCHJJ2
	CONVOOP=-CCOHJ+CCOJJ2
	DO INUC=1,NATOM                                !!! over displacements
	DO MY=-1,1                                     !!! over polarizations
	LM1MY=(L-1)*L+M-MY+1
	LP1MY=(L+1)*(L+2)+M-MY+1
	DSKLDNUC(MY)=CGNT(LM,IATOM,MY,2)*DSKL(LP1MY,IKAP,INUC)
	IF(L.NE.0.AND.ABS(M-MY).LE.L-1)DSKLDNUC(MY)=DSKLDNUC(MY)+
     &CGNT(LM,IATOM,MY,1)*DSKL(LM1MY,IKAP,INUC)*EKAP(IKAP,IPAN)
	DSDOTNUC(MY)=(0.D0,0.D0)
	IF(LOG)THEN
	DSDOTNUC(MY)=CGNT(LM,IATOM,MY,2)*DSKLDOT(LP1MY,IKAP,INUC)
	IF(L.NE.0.AND.ABS(M-MY).LE.L-1)DSDOTNUC(MY)=DSDOTNUC(MY)+
     &CGNT(LM,IATOM,MY,1)*DSKLDOT(LM1MY,IKAP,INUC)*EKAP(IKAP,IPAN)+
     &CGNT(LM,IATOM,MY,1)*DSKL(LM1MY,IKAP,INUC)/PAR**2
	ENDIF
      ENDDO                                          !!! over polarizations
	DO MY=-1,1                                     !!! over poalrizations
	BHHF(MY,INUC,IORBS,IBNDT)=BHHF(MY,INUC,IORBS,IBNDT)+
     &CONJG(CONVHHP)*DSKLDNUC(MY)+
     &CONVHHM*CONJG(DSKLDNUC(-MY))*(-1)**MY+
     &CHDOT*CONJG(DSDOTNUC(-MY))*(-1)**MY
	BOOF(MY,INUC,IORBS,IBNDT)=BOOF(MY,INUC,IORBS,IBNDT)+
     &CONJG(CONVOOP)*DSKLDNUC(MY)+
     &CONVOOM*CONJG(DSKLDNUC(-MY))*(-1)**MY+
     &CODOT*CONJG(DSDOTNUC(-MY))*(-1)**MY
      ENDDO                                          !!! over polarizations
      ENDDO                                          !!! over displacements
      ENDDO                                          !!! over m
      ENDDO                                          !!! over l
      ENDDO                                          !!! over energies
1000	CONTINUE                                       !!! over bands
2000	CONTINUE                                       !!! over atoms
3000	CONTINUE                                       !!! over spinor components
C SET PULAY FORCE
	DO IBNDT=1,NBNDF(IPAN)                         !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IORBS=1,NORBS                               !!! over spinor components
	DO INUC=1,NATOM                                !!! over displacements
	DO MY=-1,1                                     !!! over polarizations
	PILF(MY,INUC,IORBS,IBAND,1)=BHHF(MY,INUC,IORBS,IBNDT)-
     &EARR(IBAND,IPNT,IPAN)*BOOF(MY,INUC,IORBS,IBNDT)
      ENDDO                                          !!! over polarizations
      ENDDO                                          !!! over displacements
      ENDDO                                          !!! over spinor components
      ENDDO                                          !!! over bands
4000	CONTINUE                                       !!! over spin subbands
C MEMORY DEALLOCATIONS FOR SCRATCH ARRAYS
	DEALLOCATE(SLM,BHHF,BOOF,AKL,SKL,DSKL,DSKLDOT,CGNT)
      CURMEM=CURMEM-SIZE_BHHF-SIZE_BOOF-SIZE_AKL
	DEALLOCATE(HPARHH,HPARHJ,HPARJH,HPARJJ)
      CURMEM=CURMEM-SIZE_HPARHH-SIZE_HPARJH-SIZE_HPARHJ-SIZE_HPARJJ
C MEMORY DEALLOCATIONS FOR MAIN CONTROL ARRAYS
5000	CONTINUE
      SIZE_SSCON=DBLE(SIZE(SSCON)*LENCMP)/1024.D0**2
	DEALLOCATE(SSCON)
      SIZE_SDCON=DBLE(SIZE(SDCON)*LENCMP)/1024.D0**2
	DEALLOCATE(SDCON)
      CURMEM=CURMEM-SIZE_SSCON-SIZE_SDCON
	END
