	SUBROUTINE PULINT(IPNT,IPAN,IC)
***********************************************************
*  Calculates contribution to the Pulay force.            *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,NPFR              !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS          !!! from readini
     &                      ,IS,ILST,ILSB                     !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC          !!! from readini
      USE COM_LATTICE ,ONLY: TAU                              !!! from readini
      USE COM_DENDAT  ,ONLY: RHOPN                            !!! from rhofull
      USE COM_LMTIND  ,ONLY: LMTIND                           !!! from lmtpar
      USE COM_PLWMESH ,ONLY: NPLW,GPLW                        !!! from plwmesh
      USE COM_ETAPAR  ,ONLY: NBAS,LBAS                        !!! from setpar
      USE COM_TEILORG ,ONLY: MBAS,KEYT                        !!! from readini
      USE COM_RINPAR  ,ONLY: RINT0,RFUN                       !!! from tosint
      USE COM_KMESH   ,ONLY: NPNT,PNT,WGT                     !!! from tetra
      USE COM_INPTTR  ,ONLY: SH                               !!! from readini
      USE COM_ENERGY  ,ONLY: EARR,WEIGH,WEIGD                 !!! from bands
	USE COM_PULAYF  ,ONLY: PFVAL,PILF                       !!! from pulint
	USE COM_CHANNELS,ONLY: IUWFK,IUPSI                      !!! from readini
      USE COM_MASHDEP ,ONLY: LENCMP                           !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, INTRINSIC :: SIZE
      COMPLEX*16, ALLOCATABLE :: YLM(:,:)
      COMPLEX*16, ALLOCATABLE :: APH(:,:,:)
      COMPLEX*16, ALLOCATABLE :: CFTR(:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: DPSI(:)
      COMPLEX*16, ALLOCATABLE :: EXPK(:)
      COMPLEX*16, ALLOCATABLE :: PSIK(:)
	COMPLEX*16 CTMP,EXPK0,EXPS0
	DIMENSION PNTR(3),PNTK(3)
	DATA PI/3.141592653589793D0/
C RETURN KEYS
      CALL ABORTNOW()
	IF(LIFT.LE.2)RETURN
	IF(NPLWMEM.EQ.-1)RETURN
	IF(NPFR.EQ.0)RETURN
C MEMORY ALLOCATIONS
      ALLOCATE(YLM(LIMBMEM,0:NBASMEM))
      ALLOCATE(APH(LIMBMEM,NATOMMEM,NKAPMEM))
      ALLOCATE(CFTR(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM))
      ALLOCATE(DPSI(0:NBASMEM))
      ALLOCATE(EXPK(0:NBASMEM))
      ALLOCATE(PSIK(0:NBASMEM))
C INTEGRATE PULAY FORCE
      DO IORBS=1,NORBS                        !!! over spinor components
      DO IBNDS=1,NSPIN                        !!! over spin subbands
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
      DO IBNDT=1,NBNDF(IPAN)                  !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	IF(.NOT.(IC.EQ.0.AND.IBNDT.GE.NBNDE(IPAN)))THEN
	IF(.NOT.(IC.EQ.1.AND.IBNDT.LT.NBNDE(IPAN)))THEN
	IF(IC.EQ.0)WHT=WGT(IPNT,IPAN)/DBLE(NSPIN)
	IF(IC.EQ.1)WHT=WEIGH(IBAND,IPNT)
      IF(IC.EQ.1.AND.IBNDT.GE.NBNDE(IPAN))THEN  ! for fermi states
      IREC=IBNDT-NBNDE(1)+1+
     &(NBNDF(1)-NBNDE(1)+1)*(IBNDS-1)+
     &(NBNDF(1)-NBNDE(1)+1)*NSPIN*(IORBS-1)+
     &(NBNDF(1)-NBNDE(1)+1)*NSPIN*NORBS*(IPNT-1)
      READ(16,REC=IREC)(((PILF(MY,INUC,IORBS,IBAND,IMI),
     &MY=-1,1),INUC=1,NATOM),IMI=1,2)
      ENDIF
	DO INUC=1,NATOM                         !!! over displacements
	DO MY=-1,1                              !!! over polarizations
	PFVAL(MY,INUC,IPAN,ISPIN,1)=PFVAL(MY,INUC,IPAN,ISPIN,1)+
     &PILF(MY,INUC,IORBS,IBAND,1)*WHT
	PFVAL(MY,INUC,IPAN,ISPIN,2)=PFVAL(MY,INUC,IPAN,ISPIN,2)+
     &PILF(MY,INUC,IORBS,IBAND,2)*WHT
      ENDDO                                   !!! over polarizations
      ENDDO                                   !!! over displacements
	ENDIF
	ENDIF
      ENDDO                                   !!! over bands
      ENDDO                                   !!! over spin subbands
      ENDDO                                   !!! over spinor components
	IF(KEYT.LE.0)GOTO5000
C **** MAKE AUXILARY ARRAYS *****
C FIND K-POINT PNTR=K+G WHICH HAS A MINIMAL LENGTH
      XK=PNT(1,IPNT,IPAN)+SH(1,IPAN)
      YK=PNT(2,IPNT,IPAN)+SH(2,IPAN)
      ZK=PNT(3,IPNT,IPAN)+SH(3,IPAN)
      CALL REDUC2(XK,YK,ZK,NBAS,GPLW(1,0),PNTK(1),PNTK(2),PNTK(3),
     &GRX,GRY,GRZ)
C SET PSEUDOLMTOS FOR THE POINT IPNTK
      CALL FTRMAT(PNTK,0,IPAN,PNTR,YLM,CFTR)
C DO OVER POLARIZATIONS
	DO 4000 IXYZ=1,3                        !!! over polarizations
C DO GLOBALLY OVER BANDS, SPINS
      DO 3000 IORBS=1,NORBS                   !!! over spinor components
      DO 2000 IBNDS=1,NSPIN                   !!! over spin subbands
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
	IREC=ISPIN+NSPIN*(IXYZ-1)
      READ(20,REC=IREC)((RINT0(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((RFUN(IPAR1,IBAS),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
      DO 1000 IBNDT=1,NBNDF(IPAN)             !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	IF(IC.EQ.0.AND.IBNDT.GE.NBNDE(IPAN))GOTO1000
	IF(IC.EQ.1.AND.IBNDT.LT.NBNDE(IPAN))GOTO1000
	IF(IC.EQ.0)WHT=WGT(IPNT,IPAN)/DBLE(NSPIN)
	IF(IC.EQ.1)WHT=WEIGH(IBAND,IPNT)
	DO IBAS=0,NBAS
	PSIK(IBAS)=(0.D0,0.D0)
	ENDDO
	DO IKAP=1,NKAP(IPAN)                    !!! over energies
C READ VARIATIONAL COEFFICIENTS
      IF(IC.EQ.0)THEN !!! called from bands
      IREC=IKAP+NKAP(IPAN)*(IBNDT-1)+
     &NKAP(IPAN)*NBNDF(IPAN)*(IBNDS-1)+
     &NKAP(IPAN)*NBNDF(IPAN)*NSPIN*(ISPIN-1)*(NORBS-1)
      READ(UNIT=IUWFK,REC=IREC)
     &((APH(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM)
      ELSEIF(IC.EQ.1.AND.IBNDT.GE.NBNDE(IPAN))THEN !!! from ttrint
      IF(IPAN.GT.1)
     &CALL FULLSTOP('<LMTBND>: RECORD FOR IPAN.GT.1 NOT ALLOWED')
      IREC=IKAP+NKAP(1)*(IBNDT-NBNDE(1))+
     &NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*(IBNDS-1)+
     &NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*(ISPIN-1)*(NORBS-1)+
     &NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*NORBS*(IPNT-1)
      READ(UNIT=IUPSI,REC=IREC)
     &((APH(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM)
	ENDIF
	DO IATOM=1,NATOM                        !!! over iatom
	ISORT=IS(IATOM)
C CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,MIN(NBAS,MBAS)
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
	EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
C PSEUDOWAVEFUNCTION 
	DO L=0,ILSB(ISORT)                      !!! over l
	IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
	MINB=MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
	DO M=-L,L                               !!! over m
      LM=L*(L+1)+M+1
	DO IBAS=0,MINB
	PSIK(IBAS)=PSIK(IBAS)+APH(LM,IATOM,IKAP)*
     &CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS)
      ENDDO        
      ENDDO                                   !!! over m
	ENDIF
      ENDDO                                   !!! over l
      ENDDO                                   !!! over iatom
      ENDDO                                   !!! over ikap
	DO IBAS=0,MIN(NBAS,MBAS)                !!! over ibas
	DPSI(IBAS)=DCONJG(PSIK(IBAS))*WHT
      ENDDO                                   !!! over ibas
C AUXILARY ARRAYS: 
      DO IATOM1=1,NATOM                       !!! over iatom1
      ISORT1=IS(IATOM1)
      SCP=PNTK(1)*TAU(1,IATOM1)+
     &    PNTK(2)*TAU(2,IATOM1)+
     &    PNTK(3)*TAU(3,IATOM1)
      EXPS0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
      DO IKAP1=1,NKAP(IPAN)                   !!! over energy
      DO L1=0,ILSB(ISORT1)                    !!! over l1
      IF(LTPAN(L1,IATOM1,IKAP1,IPAN))THEN
      DO M1=-L1,L1                            !!! over m1
      L1M1=L1*(L1+1)+M1+1
      IPAR1=LMTIND(L1M1,IATOM1,IKAP1,1,IPAN)
C  1) TOS-MATRIX
      DO IATOM=1,NATOM                        !!! over iatom
      ISORT=IS(IATOM)
      SCP=PNTK(1)*TAU(1,IATOM)+
     &    PNTK(2)*TAU(2,IATOM)+
     &    PNTK(3)*TAU(3,IATOM)
      EXPK0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
      DO IKAP=1,NKAP(IPAN)                    !!! over energy
      DO L=0,ILSB(ISORT)                      !!! over l
      IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
      DO M=-L,L                               !!! over m
      LM=L*(L+1)+M+1
      IPAR=LMTIND(LM,IATOM,IKAP,1,IPAN)
      IF(IPAR1.GE.IPAR)
     &RINT0(IPAR1,IPAR)=RINT0(IPAR1,IPAR)+WHT*PNTR(IXYZ)*
     &DCONJG(APH(L1M1,IATOM1,IKAP1)*EXPS0)*APH(LM,IATOM,IKAP)*
     &EXPK0
      ENDDO                                   !!! over m
	ENDIF
      ENDDO                                   !!! over l
      ENDDO                                   !!! over energy
      ENDDO                                   !!! over iatom
C  2) RFUN-ARARY
	DO IBAS=0,MIN(NBAS,MBAS)                !!! over ibas
	RFUN(IPAR1,IBAS)=RFUN(IPAR1,IBAS)+WHT*PNTR(IXYZ)*
     &DCONJG(APH(L1M1,IATOM1,IKAP1)*EXPS0)*PSIK(IBAS)
      ENDDO                                   !!! over ibas
      ENDDO                                   !!! over m1
	ENDIF
      ENDDO                                   !!! over l1
      ENDDO                                   !!! over energy
      ENDDO                                   !!! over iatom1
1000  CONTINUE                                !!! over bands
	IREC=ISPIN+NSPIN*(IXYZ-1)
      WRITE(20,REC=IREC)((RINT0(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((RFUN(IPAR1,IBAS),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
2000  CONTINUE                                !!! over spin subbands
3000  CONTINUE                                !!! over spinor components
4000	CONTINUE                                !!! over polarizations
C MEMORY DEALLOCATIONS 
5000  DEALLOCATE(YLM,APH,CFTR,DPSI,EXPK,PSIK)
C ERROR HANDLINGS
C     none
	END SUBROUTINE PULINT





      SUBROUTINE NULPUL(IPAN)
************************************************
*  Zeroises Pulay force parameters             *
************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
	USE COM_CONTROL ,ONLY: LMTO,IASA,NPFR                   !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS          !!! from readini
     &                      ,IS,ILST,ILSB                     !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC          !!! from readini
      USE COM_ETAPAR  ,ONLY: NBAS                             !!! from readini
      USE COM_RINPAR  ,ONLY: RINT0,RFUN                       !!! from tosint
      USE COM_TEILORG ,ONLY: MBAS,KEYT                        !!! from readini
      USE COM_LMTOUT  ,ONLY: ICSCR,SCRFILE                    !!! from readini
      USE COM_PULAYF  ,ONLY: PILF                             !!! from nulpul
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                      !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
      LOGICAL EXIST
      DATA PI/3.141592653589793D0/
C OPEN SCRATCH FILE FOR STORING POTENTIAL PARAMETERS
      NRECL=NVAL*(NBNDT(IPAN)*(MIN(NBAS,MBAS)+1)+
     &NBNDT(IPAN)**2)
      OPEN(UNIT=20,FILE=SCRFILE(20),STATUS='NEW',
     &ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
      IF(NPFR.EQ.0)RETURN
      IF(NPLWMEM.EQ.-1)RETURN
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
      ALLOCATE(PILF(-1:1,NATOMMEM,NSPINMEM,NDIMMEM*NSPINMEM,2))
      SIZE_PILF=DBLE(SIZE(PILF)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_PILF
      IF(KEYT.LE.0)RETURN
C INITIALIZE DATA
      DO IXYZ=1,3                                    !!! over polarizations
      DO ISPIN=1,NSPIN                               !!! over spins
      DO IDIM=1,NBNDT(IPAN)                          !!! over idim
      DO JDIM=1,NBNDT(IPAN)                          !!! over jdim
      RINT0(JDIM,IDIM)=(0.D0,0.D0)
      ENDDO                                          !!! over jdim
      DO IBAS=0,MIN(NBAS,MBAS)                       !!! over ibas
      RFUN(IDIM,IBAS)=(0.D0,0.D0)
      ENDDO                                          !!! over ibas
      ENDDO                                          !!! over idim
	IREC=ISPIN+NSPIN*(IXYZ-1)
      WRITE(20,REC=IREC)((RINT0(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((RFUN(IPAR1,IBAS),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
      ENDDO                                          !!! over spins
      ENDDO                                          !!! over polarizations
      END SUBROUTINE NULPUL
