      SUBROUTINE FTENERGY(EXIT)
*************************************************************
*  Calculates total energy.                                 *
*************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_SCFLOOP ,ONLY: EPSTOT                       !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                  !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL EXIT
      SAVE ETOT0
      DATA ETOT0/0.D0/
      CALL ABORTNOW()
C STAR CODE
      CALL FTBDENER(EBND)
      CALL HUBRENER(EHUB)
	ETOT=EBND+EHUB
      WRITE(IUN,1000)
      WRITE(IUN,1010)EBND
      WRITE(IUN,1020)EHUB
      WRITE(IUN,1030)ETOT
      IF(IUN.LT.5)PRINT1030,ETOT
      WRITE(IUN,1000)
      IF(ABS(ETOT-ETOT0).LE.EPSTOT)EXIT=.TRUE.
      IF(ABS(ETOT-ETOT0).GT.EPSTOT)EXIT=.FALSE.
      ETOT0=ETOT
1000  FORMAT(1X,'***************************************************')
1010  FORMAT(1X,'*       BAND    ENERGY  =',G20.14,'     *')
1020  FORMAT(1X,'*       HUBBARD ENERGY  =',G20.14,'     *')
1030  FORMAT(1X,'*       TOTAL   ENERGY  =',G20.14,'     *')
	END



      SUBROUTINE FTBDENER(EBND)
*************************************************************
*  Calculates one-electron energy.                          *
*************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM  ,ONLY: NATOM,NSORT,NSPIN,NORBS
      USE COM_KAPPAR ,ONLY: NPAN,NKAP                         !!! from readini
      USE COM_NBANDS ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC           !!! from readini
      USE COM_INPTTR ,ONLY: NDIV,NDIC,SH                      !!! from readini
      USE COM_KMESH  ,ONLY: NPNT,PNT,WGT,IPQ,IGQ,KCUT         !!! from makettr
      USE COM_ENERGY ,ONLY: EARR,WEIGH,WEIGD                  !!! from bands
      USE COM_LABELS ,ONLY: TXTAT,TXTEL,TXTSP                 !!! from readini
      USE COM_FERMI  ,ONLY: EF                                !!! from ttrints
      USE COM_UNIT   ,ONLY: IUN,IUR,IUT                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8, ALLOCATABLE :: TOS(:,:,:)
C MEMORY ALLOCATIONS
      ALLOCATE(TOS(NPANMEM,0:1,NSPINMEM))
C START CODE
	DOS=0.D0
	DO IPAN=1,NPAN                            !!! over panels
	DO ISPIN=1,NSPIN                          !!! over spins
	TOS(IPAN,0,ISPIN)=0.D0
	TOS(IPAN,1,ISPIN)=0.D0
	DO IPNT=1,NPNT(IPAN)                      !!! over k-points
	DO IBNDT=1,NBNDF(IPAN)                    !!! over bands 
	IBAND=ISPIN+NSPIN*(IBNDT-1)
	IF(IBNDT.GE.NBNDE(IPAN))THEN
	TOS(IPAN,0,ISPIN)=TOS(IPAN,0,ISPIN)+WEIGH(IBAND,IPNT)
	TOS(IPAN,1,ISPIN)=TOS(IPAN,1,ISPIN)+WEIGH(IBAND,IPNT)*
     &  EARR(IBAND,IPNT,IPAN)
	DOS=DOS+WEIGD(IBAND,IPNT)
	ELSEIF(IBNDT.LT.NBNDE(IPAN))THEN
	TOS(IPAN,0,ISPIN)=TOS(IPAN,0,ISPIN)+WGT(IPNT,IPAN)/DBLE(NSPIN)
	TOS(IPAN,1,ISPIN)=TOS(IPAN,1,ISPIN)+WGT(IPNT,IPAN)/DBLE(NSPIN)*
     &EARR(IBAND,IPNT,IPAN)
	ENDIF
      ENDDO                                     !!! over valence bands
      ENDDO                                     !!! over k-points
      ENDDO                                     !!! over spins
C  AVERAGE IF SPIN-ORBIT COUPLING IS ON
	IF(NORBS.EQ.2)THEN
	DO I=0,1
	TBAR=(TOS(IPAN,I,1)+TOS(IPAN,I,NSPIN))/2.D0
	TOS(IPAN,I,1)=TBAR
	TOS(IPAN,I,NSPIN)=TBAR
	ENDDO
	ENDIF
      ENDDO                                     !!! over panels
      EBND=(TOS(1,1,1)+TOS(1,1,NSPIN))/2.D0*DBLE(NSPIN)
C MEMORY DEALLOCATIONS
      DEALLOCATE(TOS)
	END
