	SUBROUTINE FTBANDS
****************************************************************
*   Control module for package of programs solved generalized  *
*   eigenvalue problem for tight-binding method.               *
****************************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,IDMF,NPFR               !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN                      !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP                              !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                               !!! from tetra
      USE COM_WMESH   ,ONLY: NPNW,PNW                               !!! from tetra
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC                !!! from readini
      USE COM_SPHERE  ,ONLY: FILING                                 !!! from readhop
      USE COM_FERMI   ,ONLY: EF                                     !!! from ttrints
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                            !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION VEL(3),SPTOS(2),SPDOS(2),SPVEL(3,2)
     &    ,VELM(3,3),SPVELM(3,3,2)
	DATA PI/3.141592653589793D0/
C COMPUTE EIGENVALUES AND EIGENVECTORS
	CALL NULDEN                              !!! set density matrix to zero
	CALL FTBPAR                              !!! open scratch files
	CALL PRINTHM(IUN)                        !!! print hopping matrix
C PREPARE BANDS FOR WEIGHTS
      IF(NPNW(1).GT.NPNT(1))THEN
      DO IPNW=1,NPNW(1)                        !!! over k-points
      CALL FTBSTR(IPNW,1)                      !!! prepare Hamiltonian
      CALL FTBHUB(IPNW,1)                      !!! add Hubbard potential
      CALL FTBBND(IPNW,1)                      !!! solve eigenvalue problem
      ENDDO                                    !!! over k-points
      ENDIF
C COMPUTE BANDS AND WAVE FUNCTIONS
	DO IPNT=1,NPNT(1)                        !!! DO over k-points
	CALL FTBSTR(IPNT,0)                      !!! prepare Hamiltonian
	CALL FTBHUB(IPNT,0)                      !!! add Hubbard potential
	CALL FTBBND(IPNT,0)                      !!! solve eigenvalue problem
 	CALL FTBFAT(IPNT,0)                      !!! prepare fat bands
	CALL DENMAT(IPNT,0)                      !!! built density matrix
      ENDDO                                    !!! ENDDO over k-points
C Store Data
	CALL SETFAT                              !!! store fat bands
	CALL SETDOS                              !!! store density of states
	CALL SETFRS                              !!! store fermi surface
	IF(LIFT.LE.2)RETURN
	IF(IDMF.GT.1)RETURN
C COMPUTE FERMI LEVEL
      CALL BANDS_INSL(EF,FILING)               !!! recognize insulating case
      CALL EFSEARCH(EF,FILING,EF,100,1.D-09,0.8D0)! search for Fermi energy
      CALL TTRVEL(EF,DOS,VEL,SPTOS,SPDOS,SPVEL,VELM,SPVELM,0)
	CALL BANDS_CHI(EF,MBNDF,MBNDE,MBNDC)
C INTEGRATE DENSITY MATRIX FOR THE FERMI SURFACE STATES
	DO IPNT=1,NPNT(1)
	CALL DENMAT(IPNT,1)
	ENDDO
C SYMMETRIZE DENSITY MATRIX
      CALL SYMDEN                              !!! symmetrize density matrix
	END
