	SUBROUTINE GETCHI
******************************************************
*   Read susceptibility data                         *
******************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL   ,ONLY: MODE,LIFT,LMTO                !!! from readini
      USE COM_NBANDS    ,ONLY: NBNDF,NBNDE,NBNDC,NBNDT       !!! from readini
	USE COM_FREQU     ,ONLY: NOMGCHI,OMGCHI                !!! from getchi
	USE COM_INPTTR    ,ONLY: NDIV,NDIC,NDIW                !!! from readini
      USE COM_UNIT      ,ONLY: IUT,IUR,IUN                   !!! from setup
	USE COM_CHANNELS  ,ONLY: IUINP                         !!! from setup
      USE COM_LMTOUT    ,ONLY: ICCHI,CHIFILE                 !!! from readini
C SET LOCAL VARIBLES
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER DATA(100)*150,COPY(100)*150, HELP*40
	COMPLEX*16 CM
      LOGICAL EXIST,DEF,ASK,VAL,NTH
	DATA PI/3.141592653589793D0/
	IF(ICCHI.EQ.0)RETURN
	INQUIRE(FILE=CHIFILE,EXIST=EXIST)
	IF(EXIST)
     &OPEN(UNIT=IUINP,FILE=CHIFILE,STATUS='OLD',FORM='FORMATTED')
C TRY READING FIRST 99 LINES
	ILEN=0
	DO I=1,100
	ILEN=ILEN+1
	IF(EXIST)READ(IUINP,FMT='(A)',ERR=100,END=100)DATA(ILEN)
	ENDDO
  100 NLEN=ILEN-1
      IF(NLEN.EQ.0)NLEN=1
	IF(EXIST)CLOSE(IUINP)
      CALL READINI_SECT(DATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrl',13,'<section=',9,'ok',2)
C Allocate temporary file
      DO ILIN=1,MSEC
      COPY(ILIN)=DATA(ILIN+ISEC-1)
      ENDDO
C Process NOMGCHI
      NOMGCHI=10
      HELP='! Frequency mesh for chi(q,w)          '
      LHLP=40
      CALL READINI_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
     &'nomgchi',7,NOMGCHI,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.)
C Process WCHIMIN
      WCHIMIN=0.D0
      HELP='! Min.Frequency (Ry)  for chi(q,w)     '
      LHLP=40
      CALL READINI_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
     &'wminchi',7,IN,1,0,WCHIMIN,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.)
C Process WCHIMAX
      WCHIMAX=1.D0
      HELP='! Max.Frequency (Ry)  for chi(q,w)     '
      LHLP=40
      CALL READINI_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
     &'wmaxchi',7,IN,1,0,WCHIMAX,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.)
C Overwrite NDIV if needed
C	HELP='! Tetrahedron mesh                     '
C	LHLP=40
C	CALL READINI_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
C     &  'ndiv(:)',7,NDIV,3,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
C     &  DEF,ASK,VAL,NTH,.FALSE.)
C	IF(NDIC(1).EQ.0)THEN
	NDIC(1)=1
	NDIC(2)=1
	NDIC(3)=1
C	ENDIF
C Overwrite NDIW if needed
	HELP='! Tetrahedron mesh for weights         '
	LHLP=40
	CALL READINI_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
     &  'ndiw(:)',7,NDIW,3,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.FALSE.)
	IF(NDIW(1).EQ.0)THEN
	NDIW(1)=NDIV(1)
	NDIW(2)=NDIV(2)
	NDIW(3)=NDIV(3)
	ENDIF
C SET FREQUENCIES
	ALLOCATE(OMGCHI(0:NOMGCHI+1))
	IF(NOMGCHI.NE.0)WSTEP=(WCHIMAX-WCHIMIN)/DBLE(NOMGCHI)
	IF(NOMGCHI.EQ.0)WSTEP=0.D0
	DO IOMG=0,NOMGCHI
	OMGCHI(IOMG)=WCHIMIN+DBLE(IOMG)*WSTEP
	ENDDO
	END