	SUBROUTINE MAKEPLW
***********************************************************
*  Generates vectors in reciprocal space for using in     *
*  fourier transform.                                     *
***********************************************************
C SET ARRAY-SIZE DATA
        USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
        USE COM_LMTMEM                                          !!! from setup
	USE COM_CONTROL,  ONLY : IASA                           !!! from readini
        USE COM_LATPAR,   ONLY : PAR,STRAIN                     !!! from readini
        USE COM_LATTICE,  ONLY : GBAS,RBAS,ISTRAIN              !!! from readstr
        USE COM_PLWMESH,  ONLY : NPLW,GPLW,INDG,KVEC,KGMIN,KGMAX!!! from plwmesh
        USE COM_FFTMESH,  ONLY : NFFTG                          !!! from fftmesh
	USE COM_ACCURG,   ONLY : ECUTG                          !!! from makeplw
        USE COM_MASHDEP,  ONLY : LENINT,LENREL,LENCMP           !!! from readini
	USE COM_UNIT,     ONLY : IUN,IUR,IUT                    !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER SIZE
	DIMENSION GEQU(3,3),GL(3)
	DATA PI/3.141592653589793D0/
	IF(IASA.NE.2)NPLWMEM=-1
	IF(IASA.NE.2)NPLW=-1
	IF(IASA.NE.2)RETURN
	WRITE(IUN,1001)
1001    FORMAT(1X,'Start building plane waves:'/)
C SET RECIPROCAL LATTICE FOR THE CELL IN THE EQUILLIBRIUM
	IF(ISTRAIN.EQ.1)THEN
	DO IVEC=1,3
	DO I=1,3
	GEQU(I,IVEC)=0.D0
	DO J=1,3
	GEQU(I,IVEC)=GEQU(I,IVEC)+GBAS(J,IVEC)*STRAIN(J,I,1)
	ENDDO
	ENDDO
	ENDDO
	ELSEIF(ISTRAIN.NE.1)THEN
	DO IVEC=1,3
	GEQU(1,IVEC)=GBAS(1,IVEC)
	GEQU(2,IVEC)=GBAS(2,IVEC)
	GEQU(3,IVEC)=GBAS(3,IVEC)
	ENDDO
	ENDIF
C SET RECIPROCAL-LATTICE GRID
	KGMIN(1)=-NFFTG(1)/2
	KGMAX(1)=+NFFTG(1)/2
	KGMIN(2)=-NFFTG(2)/2
	KGMAX(2)=+NFFTG(2)/2
	KGMIN(3)=-NFFTG(3)/2
	KGMAX(3)=+NFFTG(3)/2
C DEFINE CUTOFF SPHERE IN RECIPROCAL SPACE
	SPHERE=1.D+14
	DO I=1,3
	IF(I.EQ.1)THEN
	NSTEP1=KGMAX(1)-KGMIN(1)-2
	NSTEP2=1
	NSTEP3=1
	ENDIF
	IF(I.EQ.2)THEN
	NSTEP1=1
	NSTEP2=KGMAX(2)-KGMIN(2)-2
	NSTEP3=1
	ENDIF
	IF(I.EQ.3)THEN
	NSTEP1=1
	NSTEP2=1
	NSTEP3=KGMAX(3)-KGMIN(3)-2
	ENDIF
	DO M3=KGMIN(3)+1,KGMAX(3)-1,NSTEP3
	DO M2=KGMIN(2)+1,KGMAX(2)-1,NSTEP2
	DO M1=KGMIN(1)+1,KGMAX(1)-1,NSTEP1
	GX=M1*GEQU(1,1)+M2*GEQU(1,2)+M3*GEQU(1,3)
	GY=M1*GEQU(2,1)+M2*GEQU(2,2)+M3*GEQU(2,3)
	GZ=M1*GEQU(3,1)+M2*GEQU(3,2)+M3*GEQU(3,3)
	ABSR=SQRT(GX**2+GY**2+GZ**2)
	SPHERE=MIN(SPHERE,ABSR)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	SPHERE=SPHERE+1.D-10
C FIND VECTORS BY LOOPING TWICE, FIRST DETERMINES NPLW
	DO 1000 ILOOP=1,2
	IPLW=-1
        M1MIN=KGMAX(1)
        M1MAX=KGMIN(1)
        M2MIN=KGMAX(2)
        M2MAX=KGMIN(2)
        M3MIN=KGMAX(3)
        M3MAX=KGMIN(3)
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	IF(ILOOP.EQ.2)THEN
	ALLOCATE(GPLW(3,0:NPLWMEM),STAT=IALLOC)
        IF(IALLOC.EQ.1)CALL MAKEPLW_MESG01('GPLW',3*(NPLWMEM+1),LENREL)
        SIZE_GPLW=DBLE(SIZE(GPLW)*LENREL)/1024.D0**2
        CURMEM=CURMEM+SIZE_GPLW
	ALLOCATE(KVEC(3,0:NPLWMEM),STAT=IALLOC)
        IF(IALLOC.EQ.1)CALL MAKEPLW_MESG01('KVEC',3*(NPLWMEM+1),LENINT)
        SIZE_KVEC=DBLE(SIZE(KVEC)*LENINT)/1024.D0**2
        CURMEM=CURMEM+SIZE_KVEC
	ENDIF
	DO M3=KGMIN(3),KGMAX(3)
	DO M2=KGMIN(2),KGMAX(2)
	DO M1=KGMIN(1),KGMAX(1)
	GX=M1*GEQU(1,1)+M2*GEQU(1,2)+M3*GEQU(1,3)
	GY=M1*GEQU(2,1)+M2*GEQU(2,2)+M3*GEQU(2,3)
	GZ=M1*GEQU(3,1)+M2*GEQU(3,2)+M3*GEQU(3,3)
	ABSR=SQRT(GX**2+GY**2+GZ**2)
	IF(ABSR.LE.SPHERE)THEN
	IPLW=IPLW+1
	IF(ILOOP.EQ.2)THEN      ! second loop only!
	GPLW(1,IPLW)=GX         !\
	GPLW(2,IPLW)=GY         ! > Cartesian coordinates
	GPLW(3,IPLW)=GZ         !/
	KVEC(1,IPLW)=M1         !\
	KVEC(2,IPLW)=M2         ! > Coordinates in basis "GEQU"
	KVEC(3,IPLW)=M3         !/
	ENDIF
        M1MIN=MIN(M1MIN,M1)
        M2MIN=MIN(M2MIN,M2)
        M3MIN=MIN(M3MIN,M3)
        M1MAX=MAX(M1MAX,M1)
        M2MAX=MAX(M2MAX,M2)
        M3MAX=MAX(M3MAX,M3)
	ENDIF
	ENDDO
	ENDDO
	ENDDO
	NPLW=IPLW
	NPLWMEM=NPLW
        M1MIN=M1MIN-1
        M2MIN=M2MIN-1
        M3MIN=M3MIN-1
        M1MAX=M1MAX+1
        M2MAX=M2MAX+1
        M3MAX=M3MAX+1
1000	CONTINUE
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	ALLOCATE(INDG(NFFTMEM),STAT=IALLOC)
        IF(IALLOC.EQ.1)CALL MAKEPLW_MESG01('INDG',NFFTMEM,LENINT)
        SIZE_INDG=DBLE(SIZE(INDG)*LENINT)/1024.D0**2
        CURMEM=CURMEM+SIZE_INDG
	DO IDIM=1,NFFTMEM
	INDG(IDIM)=-1
	ENDDO
        IF(TOTMEM.LT.CURMEM)TXTMEM='<MAKEPLW> Subroutine'
        IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C ORDER VECTORS BY INCREASING LENGHT
	DO IPLW=0,NPLW
	ABSI=SQRT(GPLW(1,IPLW)**2+GPLW(2,IPLW)**2+GPLW(3,IPLW)**2)
	DO JPLW=IPLW+1,NPLW
	ABSJ=SQRT(GPLW(1,JPLW)**2+GPLW(2,JPLW)**2+GPLW(3,JPLW)**2)
	IF(ABSJ.LT.ABSI)THEN
	GXJ=GPLW(1,JPLW)
	GYJ=GPLW(2,JPLW)
	GZJ=GPLW(3,JPLW)
	M1J=KVEC(1,JPLW)
	M2J=KVEC(2,JPLW)
	M3J=KVEC(3,JPLW)
	GPLW(1,JPLW)=GPLW(1,IPLW)
	GPLW(2,JPLW)=GPLW(2,IPLW)
	GPLW(3,JPLW)=GPLW(3,IPLW)
	KVEC(1,JPLW)=KVEC(1,IPLW)
	KVEC(2,JPLW)=KVEC(2,IPLW)
	KVEC(3,JPLW)=KVEC(3,IPLW)
	GPLW(1,IPLW)=GXJ
	GPLW(2,IPLW)=GYJ
	GPLW(3,IPLW)=GZJ
	KVEC(1,IPLW)=M1J
	KVEC(2,IPLW)=M2J
	KVEC(3,IPLW)=M3J
	ABSI=ABSJ
	ENDIF
	ENDDO
	M1I=KVEC(1,IPLW)
	M2I=KVEC(2,IPLW)
	M3I=KVEC(3,IPLW)
	IDIMI=1+M1I-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2I-KGMIN(2))+
     &  (KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3I-KGMIN(3))
	INDG(IDIMI)=IPLW
	ENDDO
C SET UP ENERGY LIMIT IN REAL UNITS
	GMAX=SQRT(GPLW(1,NPLW)**2+GPLW(2,NPLW)**2+GPLW(3,NPLW)**2)
	EMAX=GMAX**2*(2.D0*PI/PAR)**2
	PMAX=GMAX*2.D0*PI/PAR ! cutoff value
	ECUTG=EMAX
C PRINT VALUES
	WRITE(IUN,1010)NPLW
	WRITE(IUN,1020)EMAX
	WRITE(IUN,1030)GMAX
	WRITE(IUN,1040)NFFTG(1),NFFTG(2),NFFTG(3)
	ID1=NFFTG(1)-(M1MAX-M1MIN)-2
	IF(ID1.LT.2)ID1=0
	ID2=NFFTG(2)-(M2MAX-M2MIN)-2
	IF(ID2.LT.2)ID2=0
	ID3=NFFTG(3)-(M3MAX-M3MIN)-2
	IF(ID3.LT.2)ID3=0
	WRITE(IUN,1050)NFFTG(1)-ID1,NFFTG(2)-ID2,NFFTG(3)-ID3
1010    FORMAT(1X,'Number of plane waves to be used ',I7)
1020    FORMAT(1X,'Plane-wave energy cutoff will be ',G14.7,' Ry')
1030    FORMAT(1X,'Reciprocal lattice sphere radius ',G14.7,' 2pi/a')
1040    FORMAT(1X,'Fast fourier transform divisions ',3(I3,1X))
1050    FORMAT(1X,'Orthorombicity optimizator gives ',3(I3,1X)/)
C DISTORT PLANE WAVES ACCORDING TO STRAIN
	IF(ISTRAIN.EQ.1)THEN
        DO IPLW=0,NPLW
        DO I=1,3
        GL(I)=GPLW(I,IPLW)
	ENDDO
        DO I=1,3
        GPLW(I,IPLW)=0.D0
        DO J=1,3
        GPLW(I,IPLW)=GPLW(I,IPLW)+GL(J)*STRAIN(J,I,2)
	ENDDO
	ENDDO
	ENDDO
	ENDIF 
C ERROR HANDLINGS
	CONTAINS
	SUBROUTINE MAKEPLW_MESG01(TXT,NLEN,NSIZ)
	CHARACTER TXT*(*)
	WRITE(IUT,*)'Terminated in <MAKEPLW>:'
	WRITE(IUT,*)'Problem with allocating the array ',TXT
	WRITE(IUT,*)'has been detected by the system.'
	WRITE(IUT,*)'Array size (Mb) = ',DBLE(NLEN*NSIZ)/1024.D0**2
	CALL FULLSTOP(' ')
	END SUBROUTINE MAKEPLW_MESG01
	END SUBROUTINE MAKEPLW


	SUBROUTINE MAKEPLW_DPLW
***********************************************************
*  Generates plane waves for all differences G'-G .       *
***********************************************************
C SET ARRAY-SIZE DATA
        USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
        USE COM_LMTMEM                                          !!! from setup
        USE COM_PLWMESH,  ONLY : NPLW,GPLW,INDG,KVEC,KGMIN,KGMAX!!! from plwmesh
        USE COM_FFTMESH,  ONLY : NFFTG                          !!! from fftmesh
        USE COM_PLW2MSH,  ONLY : N2PLW,G2PLW,INDG2              !!! from plw2msh
        USE COM_MASHDEP,  ONLY : LENINT,LENREL,LENCMP           !!! from readini
        USE COM_UNIT,     ONLY : IUN,IUR,IUT                    !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION GL(3)
	DATA IONE/1/
	IF(NPLW.EQ.-1)RETURN
C MEMORY ALLOCATIONS
	N2FFT=(2*NFFTG(1)+1)*(2*NFFTG(2)+1)*(2*NFFTG(3)+1)
	ALLOCATE(INDG2(N2FFT),STAT=IALLOC)
        IF(IALLOC.EQ.1)CALL MAKEPLW_MESG01('INDG2',N2FFT,LENINT)
        SIZE_INDG2=DBLE(SIZE(INDG2)*LENINT)/1024.D0**2
        CURMEM=CURMEM+SIZE_INDG2
C LOOPING TWICE, FIRST DETERMINES # OF PLANE WAVES
	DO 1000 ILOOP=IONE,2
C SET POINT-INDICATOR ARRAY TO "-1"
	DO M3=2*KGMIN(3),2*KGMAX(3)
	DO M2=2*KGMIN(2),2*KGMAX(2)
	DO M1=2*KGMIN(1),2*KGMAX(1)
	IDIM=1+M1-2*KGMIN(1)+(2*KGMAX(1)-2*KGMIN(1)+1)*
     &  (M2-2*KGMIN(2))+(2*KGMAX(1)-2*KGMIN(1)+1)*
     &  (2*KGMAX(2)-2*KGMIN(2)+1)*(M3-2*KGMIN(3))
	INDG2(IDIM)=-1
	ENDDO
	ENDDO
	ENDDO
	IF(ILOOP.EQ.2)THEN
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	ALLOCATE(G2PLW(3,0:N2PLW),STAT=IALLOC)
        IF(IALLOC.EQ.1)CALL MAKEPLW_MESG01('G2PLW',3*(N2PLW+1),LENREL)
        SIZE_G2PLW=DBLE(SIZE(G2PLW)*LENREL)/1024.D0**2
        CURMEM=CURMEM+SIZE_G2PLW
	ENDIF
C DO OVER PLANE WAVES 
	I2PLW=-1
	DO IPLW=0,NPLW
	M1I=KVEC(1,IPLW)
	M2I=KVEC(2,IPLW)
	M3I=KVEC(3,IPLW)
	DO JPLW=0,NPLW
	M1J=KVEC(1,JPLW)
	M2J=KVEC(2,JPLW)
	M3J=KVEC(3,JPLW)
C SET UP DIFFERENCE
	M1=M1J-M1I
	M2=M2J-M2I
	M3=M3J-M3I
	IDIM=1+M1-2*KGMIN(1)+(2*KGMAX(1)-2*KGMIN(1)+1)*
     &  (M2-2*KGMIN(2))+(2*KGMAX(1)-2*KGMIN(1)+1)*
     &  (2*KGMAX(2)-2*KGMIN(2)+1)*(M3-2*KGMIN(3))
	IF(INDG2(IDIM).EQ.-1)THEN
	I2PLW=I2PLW+1
	INDG2(IDIM)=I2PLW
	IF(ILOOP.EQ.2)THEN
	G2PLW(1,I2PLW)=GPLW(1,JPLW)-GPLW(1,IPLW)
	G2PLW(2,I2PLW)=GPLW(2,JPLW)-GPLW(2,IPLW)
	G2PLW(3,I2PLW)=GPLW(3,JPLW)-GPLW(3,IPLW)
	ENDIF
	ENDIF
	ENDDO
	ENDDO
	N2PLW=I2PLW
1000	CONTINUE
	IONE=2 ! do not loop twice next time
        IF(TOTMEM.LT.CURMEM)TXTMEM='<PLW2MSH> Subroutine'
        IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C ERROR HANDLINGS
        CONTAINS
        SUBROUTINE MAKEPLW_MESG01(TXT,NLEN,NSIZ)
        CHARACTER TXT*(*)
        WRITE(IUT,*)'Terminated in <MAKEPLW>:'
        WRITE(IUT,*)'Problem with allocating the array ',TXT
        WRITE(IUT,*)'has been detected by the system.'
        WRITE(IUT,*)'Array size (Mb) = ',DBLE(NLEN*NSIZ)/1024.D0**2
        CALL FULLSTOP(' ')
        END SUBROUTINE MAKEPLW_MESG01
	END


	SUBROUTINE MAKEPLW_WINT
***********************************************************
*  Integrates plane waves over interstitial region.       *
***********************************************************
C SET EXTERNAL CONNECTIONS
        USE COM_LMTMEM                                          !!! from setup
        USE COM_PLW2MSH,  ONLY : N2PLW,G2PLW,GINT               !!! from makeplw
        USE COM_MASHDEP,  ONLY : LENINT,LENREL,LENCMP           !!! from readini
	USE COM_UNIT,     ONLY : IUN,IUR,IUT                    !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
C MEMORY ALLOCATIONS
	ALLOCATE(GINT(0:N2PLW),STAT=IALLOC)
        IF(IALLOC.EQ.1)CALL MAKEPLW_MESG01('GINT',N2PLW+1,LENCMP)
        SIZE_GINT=DBLE(SIZE(GINT)*LENCMP)/1024.D0**2
        CURMEM=CURMEM+SIZE_GINT
        IF(TOTMEM.LT.CURMEM)TXTMEM='<MAKEPLW_WINT> Subroutine'
        IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C SET INTEGRALS
	DO I2PLW=0,N2PLW
	CALL MAKEPLW_SINT(G2PLW(1,I2PLW),G2PLW(2,I2PLW),G2PLW(3,I2PLW),
     &  GINT(I2PLW))
	ENDDO
C ERROR HANDLINGS
        CONTAINS
        SUBROUTINE MAKEPLW_MESG01(TXT,NLEN,NSIZ)
        CHARACTER TXT*(*)
        WRITE(IUT,*)'Terminated in <MAKEPLW>:'
        WRITE(IUT,*)'Problem with allocating the array ',TXT
        WRITE(IUT,*)'has been detected by the system.'
        WRITE(IUT,*)'Array size (Mb) = ',DBLE(NLEN*NSIZ)/1024.D0**2
        CALL FULLSTOP(' ')
        END SUBROUTINE MAKEPLW_MESG01
	END




	SUBROUTINE MAKEPLW_SINT(GX,GY,GZ,GINT)
**************************************************************
*  Calculates integral over the interstitial region for a    *
*  single plane wave given by Gx,Gy,Gz which is the integral *
*  over all MT-spheres.                                      *
**************************************************************
C SET EXTERNAL CONNECTIONS
        USE COM_PARAM,   ONLY : NATOM,IS                         !!! from readini
        USE COM_LATPAR,  ONLY : OMEGAC,PAR                       !!! from readini
        USE COM_SPHERE,  ONLY : SMT                              !!! from readini
        USE COM_LATTICE, ONLY : TAU                              !!! from readstr
	USE COM_UNIT,    ONLY : IUN,IUR,IUT                      !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 GINT,EXPGT
	DATA PI/3.141592653589793D0/
C START CODE
	GG=SQRT(GX*GX+GY*GY+GZ*GZ)*2.D0*PI/PAR
	IF(GG.LE.1.D-10)THEN  ! just interstitial volume
	VINT=OMEGAC
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	VINT=VINT-4.D0*PI/3.D0*SMT(ISORT)**3
	ENDDO
	GINT=DCMPLX(VINT,0.D0)
	ELSE
	GINT=(0.D0,0.D0)
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	SCP=GX*TAU(1,IATOM)+GY*TAU(2,IATOM)+GZ*TAU(3,IATOM)
	EXPGT=EXP((0.D0,1.D0)*2.D0*PI*SCP)
	GS=GG*SMT(ISORT)
	GINT=GINT-4.D0*PI*EXPGT/GG**3*(SIN(GS)-GS*COS(GS))
	ENDDO
	ENDIF
	END



	SUBROUTINE MAKEPLW_DINT(GX,GY,GZ,GINT,IATOM0)
**************************************************************
*  Calculates change in the integral over the MT-region for  * 
*  a single plane wave given by Gx,Gy,Gz.                    * 
**************************************************************
C SET EXTERNAL CONNECTIONS
        USE COM_PARAM,   ONLY : NATOM,IS                        !!! from readini
        USE COM_LATPAR,  ONLY : PAR,OMEGAC                      !!! from readini
        USE COM_SPHERE,  ONLY : SMT                             !!! from readini
        USE COM_LATTICE, ONLY : TAU                             !!! from readini
	USE COM_UNIT,    ONLY : IUN,IUR,IUT                     !!! from setup
C SET LOCAL VARIABLES
        IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 GINT,EXPGT
	DATA PI/3.141592653589793D0/
C START CODE
	GG=SQRT(GX*GX+GY*GY+GZ*GZ)*2.D0*PI/PAR
	IATOM=IATOM0
	ISORT=IS(IATOM)
	IF(GG.LE.1.D-10)THEN  ! simply zero
	GINT=4.D0*PI/3.D0*SMT(ISORT)**3
	ELSE
	SCP=GX*TAU(1,IATOM)+GY*TAU(2,IATOM)+GZ*TAU(3,IATOM)
	EXPGT=EXP((0.D0,1.D0)*2.D0*PI*SCP)
	GS=GG*SMT(ISORT)
	GINT=4.D0*PI*EXPGT/GG**3*(SIN(GS)-GS*COS(GS))
	ENDIF
	END
