	SUBROUTINE NMTFILE           
************************************************************
*  <NMTFILE> checks file storage.                          *
************************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL   ,ONLY: MODE,LIFT,LMTO                !!! from readini
      USE COM_NBANDS    ,ONLY: NBNDF,NBNDE,NBNDC,NBNDT       !!! from readini
	USE COM_INPTTR    ,ONLY: NDIVDIR,NDIR                  !!! from readini
	USE COM_LABELS    ,ONLY: PATHSCRT                      !!! from setup
      USE COM_UNIT      ,ONLY: IUT,IUR,IUN                   !!! from setup
	USE COM_CHANNELS  ,ONLY: IUINP                         !!! from setup
C FILE NAMES
      USE COM_LMTINP                                         !!! from readini
      USE COM_LMTOUT                                         !!! from readini
	USE COM_EXTENS                                         !!! from setup
C SET LOCAL VARIBLES
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER UN(100)*2,INF*130,RUN*130
      LOGICAL EXIST,COMPUTE,PRESENT
	DATA PI/3.141592653589793D0/                             
      DATA UN/'01','02','03','04','05','06','07','08','09','10'
     &       ,'11','12','13','14','15','16','17','18','19','20'
     &       ,'21','22','23','24','25','26','27','28','29','30'
     &       ,'31','32','33','34','35','36','37','38','39','40'
     &       ,'41','42','43','44','45','46','47','48','49','50'
     &       ,'51','52','53','54','55','56','57','58','59','60'
     &       ,'61','62','63','64','65','66','67','68','69','70'
     &       ,'71','72','73','74','75','76','77','78','79','80'
     &       ,'81','82','83','84','85','86','87','88','89','90'
     &       ,'91','92','93','94','95','96','97','98','99','00'/
C INPUT/OUTPUT
	INF=INPINFO
	RUN=RUNMODE
	MODE=-1
C ***************************************************************
C HUBBARD CORRECTIONS
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNHUB,60,NBE)
      HUBFILE=PROJECT(:NBP)//'.'//EXTNHUB(:NBE)
	CALL RMBLANK(HUBFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNHUB,LENEXTN)
      CALL SUBSTR_IN_STR(COMPUTE,RUN,130,EXTNHUB,LENEXTN)
      IF(.NOT.PRESENT)ICHUB=0       !!! do not use hubfile
      IF(     PRESENT)ICHUB=2       !!! use hubfile
      IF(COMPUTE)MODE=0
	INQUIRE(FILE=HUBFILE,EXIST=EXIST)
      IF(.NOT.EXIST.AND.ICHUB.EQ.2)THEN
      WRITE(IUT,*)'Terminated in <NMTFILE>::'
      WRITE(IUT,*)'Hubbard corrections HUBFILE ',HUBFILE
      WRITE(IUT,*)'should exist for this mode.'
	CALL FULLSTOP(' ')
	ENDIF
C ***************************************************************
C HOPPINGS FILE
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNHOP,60,NBE)
      HOPFILE=PROJECT(:NBP)//'.'//EXTNHOP(:NBE)
      CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNHOP,LENEXTN)
      CALL SUBSTR_IN_STR(COMPUTE,RUN,130,EXTNHOP,LENEXTN)
      IF(.NOT.PRESENT)ICHOP=0       !!! do not use hopfile
      IF(     PRESENT)ICHOP=2       !!! use hopfile
      IF(COMPUTE)MODE=0             !!! 
	INQUIRE(FILE=HOPFILE,EXIST=EXIST)
      IF(.NOT.EXIST.AND.ICHOP.EQ.2)THEN
      WRITE(IUT,*)'Terminated in <NMTFILE>::'
      WRITE(IUT,*)'Hoppings integrals HOPFILE ',HOPFILE
      WRITE(IUT,*)'should exist for this mode.'
	CALL FULLSTOP(' ')
	ENDIF
C ***************************************************************
C ENERGY BANDS FOR WEIGHTS
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNENR,60,NBE)
      ENRFILE=PROJECT(:NBP)//'.'//EXTNENR(:NBE)
	CALL RMBLANK(ENRFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNENR,LENEXTN)
      CALL SUBSTR_IN_STR(COMPUTE,RUN,130,EXTNENR,LENEXTN)
      IF(.NOT.PRESENT)ICENR=0       !!! do not use enrfile
      IF(     PRESENT)ICENR=2       !!! use enrfile
      IF(     COMPUTE)ICENR=1
      IF(ICENR.EQ.1)MODE=4
	INQUIRE(FILE=ENRFILE,EXIST=EXIST)
      IF(.NOT.EXIST.AND.ICENR.EQ.2)THEN
      WRITE(IUT,*)'Terminated in <NMTFILE>::'
      WRITE(IUT,*)'Energy bands for weights ENRFILE ',ENRFILE
      WRITE(IUT,*)'should exist for this mode.'
	CALL FULLSTOP(' ')
	ENDIF
C ***************************************************************
C POINTS GENERATOR
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNPNT,60,NBE)
      PNTFILE=PROJECT(:NBP)//'.'//EXTNPNT(:NBE)
	CALL RMBLANK(PNTFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNPNT,LENEXTN)
      CALL SUBSTR_IN_STR(COMPUTE,RUN,130,EXTNPNT,LENEXTN)
      IF(.NOT.PRESENT)ICPNT=0       !!! do not use pntfile
      IF(     PRESENT)ICPNT=2       !!! use pntfile
      IF(     COMPUTE)ICPNT=1
      IF(ICPNT.EQ.1)MODE=0
      INQUIRE(FILE=PNTFILE,EXIST=EXIST)
      IF(EXIST.AND.ICPNT.EQ.1)THEN
      WRITE(IUT,*)'Terminated in <NMTFILE>::'
      WRITE(IUT,*)'Q-points PNTFILE ',PNTFILE
      WRITE(IUT,*)'should not exist for this mode.'
	CALL FULLSTOP(' ')
      ELSEIF(EXIST.AND.ICPNT.EQ.2)THEN
C delete it
      OPEN(UNIT=1,FILE=PNTFILE,FORM='UNFORMATTED',
     &STATUS='OLD')
	CALL FIND_LBLANK(PNTFILE,130,NA)
      WRITE(IUT,*)PNTFILE(:NA),' DELETED !'
      CLOSE(UNIT=1,STATUS='DELETE')
      ENDIF
C ***************************************************************
C STRUCTURE CONSTANTS
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNCON,60,NBE)
	CONFILE=PROJECT(:NBP)//'.'//EXTNCON(:NBE)
	CALL RMBLANK(CONFILE,130)
C Automatic handling depending on the running mode
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNCON,LENEXTN)
	COMPUTE=PRESENT    
	IF(.NOT.COMPUTE)ICCON=0       !!! application modes do not require it
	IF(     COMPUTE)ICCON=2       !!! scf modes require permanent storage
	IF(ICCON.GT.0)MODE=0
	INQUIRE(FILE=CONFILE,EXIST=EXIST)
	IF(.NOT.EXIST.AND.ICCON.EQ.2)THEN
	WRITE(IUT,*)'Message from <NMTFILE>::' 
	WRITE(IUT,*)'Structure constants CONFILE ',CONFILE
	WRITE(IUT,*)'cannot be found. It will be created.'
	ICCON=1
	ENDIF
C ***************************************************************
C SCREENED STRUCTURE CONSTANTS:
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNFTR,60,NBE)
	FTRFILE=PROJECT(:NBP)//'.'//EXTNFTR(:NBE)
	CALL RMBLANK(FTRFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNFTR,LENEXTN)
      COMPUTE=PRESENT
	IF(     COMPUTE)ICFTR=2 !!! real space tb lmto requires it
	IF(.NOT.COMPUTE)ICFTR=0 !!! other lmtos do not need this
	IF(LMTO.NE.3)ICFTR=0
	IF(ICFTR.GT.0)MODE=0
	INQUIRE(FILE=FTRFILE,EXIST=EXIST)
	IF(.NOT.EXIST.AND.ICFTR.EQ.2)THEN
	WRITE(IUT,*)'Warning from <NMTFILE>::' 
	WRITE(IUT,*)'Screened  constants FTRFILE ',FTRFILE
	WRITE(IUT,*)'cannot be found. It will be created.'
	ICFTR=1
	ENDIF
C ***************************************************************
C ATOMS & STRUCTURE
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNATM,60,NBE)
      ATMFILE=PROJECT(:NBP)//'.'//EXTNATM(:NBE)
      CALL RMBLANK(ATMFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNATM,LENEXTN)
      COMPUTE=PRESENT
      IF(     COMPUTE)ICATM=2
      IF(.NOT.COMPUTE)ICATM=0
      IF(ICATM.GT.0)MODE=0
      INQUIRE(FILE=ATMFILE,EXIST=EXIST)
      IF(EXIST.AND.ICATM.EQ.2)THEN
C delete it
      OPEN(UNIT=1,FILE=ATMFILE,FORM='UNFORMATTED',
     &STATUS='OLD')
	CALL FIND_LBLANK(ATMFILE,130,NA)
      WRITE(IUT,*)ATMFILE(:NA),' DELETED !'
      CLOSE(UNIT=1,STATUS='DELETE')
      ENDIF
C ***************************************************************
C POINT GROUP ELEMENTS
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNGRP,60,NBE)
      GRPFILE=PROJECT(:NBP)//'.'//EXTNGRP(:NBE)
      CALL RMBLANK(GRPFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNGRP,LENEXTN)
      COMPUTE=PRESENT
      IF(     COMPUTE)ICGRP=2 !!! real space tb lmto requires it
      IF(.NOT.COMPUTE)ICGRP=0 !!! other lmtos do not need this
      IF(ICGRP.GT.0)MODE=0
      INQUIRE(FILE=GRPFILE,EXIST=EXIST)
      IF(EXIST.AND.ICGRP.EQ.2)THEN
C delete it
      OPEN(UNIT=1,FILE=GRPFILE,FORM='UNFORMATTED',
     &STATUS='OLD')
	CALL FIND_LBLANK(GRPFILE,130,NA)
      WRITE(IUT,*)GRPFILE(:NA),' DELETED !'
      CLOSE(UNIT=1,STATUS='DELETE')
      ENDIF
C ***************************************************************
C FULL CHARGE DENSITY
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNSCF,60,NBE)
	SCFFILE=PROJECT(:NBP)//'.'//EXTNSCF(:NBE)
	CALL RMBLANK(SCFFILE,130)
C Automatic handling depending on the running mode
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNSCF,LENEXTN)
      COMPUTE=PRESENT
      IF(     COMPUTE)ICSCF=2 !!! store charge density
      IF(.NOT.COMPUTE)ICSCF=0 !!! do not store charge density
	IF(ICSCF.GT.0)MODE=1
      INQUIRE(FILE=SCFFILE,EXIST=EXIST)
      IF(EXIST.AND.ICSCF.EQ.2)THEN
C delete it
      OPEN(UNIT=1,FILE=SCFFILE,FORM='UNFORMATTED',
     &STATUS='OLD')
	CALL FIND_LBLANK(SCFFILE,130,NA)
      WRITE(IUT,*)SCFFILE(:NA),' DELETED !'
      CLOSE(UNIT=1,STATUS='DELETE')
      ENDIF
C ***************************************************************
C OUTPUT HUBBARD PARAMETERS
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNHBR,60,NBE)
	HBRFILE=PROJECT(:NBP)//'.'//EXTNHBR(:NBE)
	CALL RMBLANK(HBRFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNHBR,LENEXTN)
      COMPUTE=PRESENT
      IF(     COMPUTE)ICHBR=2 !!! store charge density
      IF(.NOT.COMPUTE)ICHBR=0 !!! do not store charge density
	IF(ICHBR.GT.0)MODE=1
      INQUIRE(FILE=HBRFILE,EXIST=EXIST)
      IF(EXIST.AND.ICHBR.EQ.2)THEN
C delete it
      OPEN(UNIT=1,FILE=HBRFILE,FORM='UNFORMATTED',
     &STATUS='OLD')
	CALL FIND_LBLANK(HBRFILE,130,NA)
      WRITE(IUT,*)HBRFILE(:NA),' DELETED !'
      CLOSE(UNIT=1,STATUS='DELETE')
      ENDIF
C ***************************************************************
C OUTPUT HOPPINGS
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNHPP,60,NBE)
	HPPFILE=PROJECT(:NBP)//'.'//EXTNHPP(:NBE)
	CALL RMBLANK(HPPFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNHPP,LENEXTN)
      COMPUTE=PRESENT
      IF(     COMPUTE)ICHPP=2 !!! store hoppings
      IF(.NOT.COMPUTE)ICHPP=0 !!! do not store hoppings
	IF(ICHPP.GT.0)MODE=4
      INQUIRE(FILE=HPPFILE,EXIST=EXIST)
      IF(EXIST.AND.ICHPP.EQ.2)THEN
C delete it
      OPEN(UNIT=1,FILE=HPPFILE,FORM='UNFORMATTED',
     &STATUS='OLD')
	CALL FIND_LBLANK(HPPFILE,130,NA)
      WRITE(IUT,*)HPPFILE(:NA),' DELETED !'
      CLOSE(UNIT=1,STATUS='DELETE')
      ENDIF
C ***************************************************************
C WAVE FUNCTIONS
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNPSI,60,NBE)
	PSIFILE=PROJECT(:NBP)//'.'//EXTNPSI(:NBE)
	CALL RMBLANK(PSIFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNPSI,LENEXTN)
      COMPUTE=PRESENT
	IF(     COMPUTE)ICPSI=2 !!! store wave functions
	IF(.NOT.COMPUTE)ICPSI=0 !!! do not store wave functions
	IF(ICPSI.GT.0.AND.MODE.NE.1)MODE=4
	INQUIRE(FILE=PSIFILE,EXIST=EXIST)
	IF(EXIST.AND.ICPSI.EQ.2)THEN
	OPEN(UNIT=1,FILE=PSIFILE,FORM='UNFORMATTED',
     &STATUS='OLD')
	CALL FIND_LBLANK(PSIFILE,130,NA)
	WRITE(IUT,*)PSIFILE(:NA),' DELETED !'
	CLOSE(UNIT=1,STATUS='DELETE')
	ENDIF
C ***************************************************************
C BAND STRUCTURE
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNBND,60,NBE)
	BNDFILE=PROJECT(:NBP)//'.'//EXTNBND(:NBE)
	CALL RMBLANK(BNDFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNBND,LENEXTN)
      COMPUTE=PRESENT
      IF(     COMPUTE)ICBND=2 !!! store energy bands
      IF(.NOT.COMPUTE)ICBND=0 !!! do not store energy bands
	IF(ICBND.GT.0.AND.MODE.NE.1)MODE=4
C Check whether it exists or not
	IF(EXIST.AND.ICBND.EQ.2)THEN
	OPEN(UNIT=1,FILE=BNDFILE,FORM='UNFORMATTED',
     &STATUS='OLD')
	CALL FIND_LBLANK(BNDFILE,130,NA)
	WRITE(IUT,*)BNDFILE(:NA),' DELETED !'
	CLOSE(UNIT=1,STATUS='DELETE')
	ENDIF
C ***************************************************************
C FERMI SURFACE
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNFRS,60,NBE)
	FRSFILE=PROJECT(:NBP)//'.'//EXTNFRS(:NBE)
	CALL RMBLANK(FRSFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNFRS,LENEXTN)
      COMPUTE=PRESENT
      IF(     COMPUTE)ICFRS=1 !!! store Fermi surface
      IF(.NOT.COMPUTE)ICFRS=0 !!! do not store Fermi surface
	IF(ICFRS.GT.0.AND.MODE.NE.1)MODE=4
	INQUIRE(FILE=FRSFILE,EXIST=EXIST)
	IF(ICFRS.GT.0)CALL GETFRS ! read parameters
C ***************************************************************
C FULL POTENTIAL
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNPOT,60,NBE)
	POTFILE=PROJECT(:NBP)//'.'//EXTNPOT(:NBE)
	CALL RMBLANK(POTFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNPOT,LENEXTN)
      COMPUTE=PRESENT
      IF(     COMPUTE)ICPOT=1 !!! store full potential
      IF(.NOT.COMPUTE)ICPOT=0 !!! do not store wave functions
	IF(ICPOT.GT.0.AND.MODE.NE.1)MODE=4
	INQUIRE(FILE=POTFILE,EXIST=EXIST)
	IF(EXIST.AND.ICPOT.EQ.1)THEN
	WRITE(IUT,*)'Terminated in <NMTFILE>::' 
	WRITE(IUT,*)'Full potential POTFILE ',POTFILE
	WRITE(IUT,*)'should not exist if input parameter ICPOT=1'
	CALL FULLSTOP(' ')
	ELSEIF(EXIST.AND.ICPOT.EQ.2)THEN
	OPEN(UNIT=1,FILE=POTFILE,FORM='UNFORMATTED',
     &STATUS='OLD')
	CALL FIND_LBLANK(POTFILE,130,NA)
	WRITE(IUT,*)POTFILE(:NA),' DELETED !'
	CLOSE(UNIT=1,STATUS='DELETE')
	ENDIF
C ***************************************************************
C DENSITY OF STATES
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNDOS,60,NBE)
	DOSFILE=PROJECT(:NBP)//'.'//EXTNDOS(:NBE)
	CALL RMBLANK(DOSFILE,130)
C Automatic handling depending on the running mode
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNDOS,LENEXTN)
      COMPUTE=PRESENT
      IF(     COMPUTE)ICDOS=1 !!! store dos
      IF(.NOT.COMPUTE)ICDOS=0 !!! do not store dos
	IF(ICDOS.GT.0.AND.MODE.NE.1)MODE=4
C Set # of empty bands to the total # of bands in this case
	IF(ICDOS.GT.0)THEN
	NBNDF(1)=NBNDT(1)
	NBNDE(1)=1
	NBNDC(1)=NBNDT(1)
	ENDIF
C Check whether it exists or not
      INQUIRE(FILE=DOSFILE,EXIST=EXIST)
	IF(ICDOS.GT.0)CALL GETDOS ! read parameters
C ***************************************************************
C TEMPERATURE DENSITY OF STATES IN DYNAMICAL MEAN FIELD THEORY
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNGRF,60,NBE)
	GRFFILE=PROJECT(:NBP)//'.'//EXTNGRF(:NBE)
	CALL RMBLANK(GRFFILE,130)
C Automatic handling depending on the running mode
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNGRF,LENEXTN)
      COMPUTE=PRESENT
      IF(     COMPUTE)ICGRF=1 !!! store grf
      IF(.NOT.COMPUTE)ICGRF=0 !!! do not store grf
	IF(ICGRF.GT.0.AND.MODE.NE.1)MODE=4
C Set # of empty bands to the total # of bands in this case
	IF(ICGRF.GT.0)THEN
	NBNDF(1)=NBNDT(1)
	NBNDE(1)=1
	NBNDC(1)=NBNDT(1)
	ENDIF
C Check whether it exists or not
      INQUIRE(FILE=GRFFILE,EXIST=EXIST)
	IF(ICGRF.GT.0)CALL GETGRF ! read parameters
C ***************************************************************
C OPTICAL PROPERTIES
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNOPT,60,NBE)
      OPTFILE=PROJECT(:NBP)//'.'//EXTNOPT(:NBE)
	CALL RMBLANK(OPTFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNOPT,LENEXTN)
      COMPUTE=PRESENT
      IF(     COMPUTE)ICOPT=1 !!! store optics
      IF(.NOT.COMPUTE)ICOPT=0 !!! do not store optics
	IF(ICOPT.GT.0.AND.MODE.NE.1)MODE=4
C Set # of empty bands to the total # of bands in this case
	IF(ICOPT.GT.0)THEN
	NBNDF(1)=NBNDT(1)
	NBNDE(1)=1
	NBNDC(1)=NBNDT(1)
	ENDIF
C Check whether it exists or not
      INQUIRE(FILE=OPTFILE,EXIST=EXIST)
	IF(ICOPT.GT.0)CALL GETOPT ! read parameters
C ***************************************************************
C OPTICAL PROPERTIES WITHIN DMFT
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNODF,60,NBE)
      ODFFILE=PROJECT(:NBP)//'.'//EXTNODF(:NBE)
	CALL RMBLANK(ODFFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNODF,LENEXTN)
      COMPUTE=PRESENT
      IF(     COMPUTE)ICODF=1 !!! store optics
      IF(.NOT.COMPUTE)ICODF=0 !!! do not store optics
	IF(ICODF.GT.0.AND.MODE.NE.1)MODE=4
C Set # of empty bands to the total # of bands in this case
	IF(ICODF.GT.0)THEN
	NBNDF(1)=NBNDT(1)
	NBNDE(1)=1
	NBNDC(1)=NBNDT(1)
	ENDIF
C Check whether it exists or not
      INQUIRE(FILE=ODFFILE,EXIST=EXIST)
	IF(ICODF.GT.0)CALL GETODF ! read parameters
C ***************************************************************
C SUSCEPTIBILITY
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNCHI,60,NBE)
      CHIFILE=PROJECT(:NBP)//'.'//EXTNCHI(:NBE)
	CALL RMBLANK(CHIFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNCHI,LENEXTN)
      COMPUTE=PRESENT
      IF(     COMPUTE)ICCHI=1 !!! store susceptibility
      IF(.NOT.COMPUTE)ICCHI=0 !!! do not store susceptibility
	IF(ICCHI.GT.0.AND.MODE.NE.1)MODE=4
C Set # of empty bands to the total # of bands in this case
	IF(ICCHI.GT.0)THEN
	NBNDF(1)=NBNDT(1)
	NBNDE(1)=1
	NBNDC(1)=NBNDT(1)
	ENDIF
C Check whether it exists or not
      INQUIRE(FILE=CHIFILE,EXIST=EXIST)
	IF(ICCHI.GT.0)CALL GETCHI ! read parameters
C ***************************************************************
C FAT BANDS
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNFAT,60,NBE)
	FATFILE=PROJECT(:NBP)//'.'//EXTNFAT(:NBE)
	CALL RMBLANK(FATFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNFAT,LENEXTN)
	COMPUTE=PRESENT    
      IF(     COMPUTE)ICFAT=1 !!! store wave functions
      IF(.NOT.COMPUTE)ICFAT=0 !!! do not store wave functions
      IF(ICFAT.GT.0.AND.MODE.GT.0)CALL NMTFILE_MESG01
      IF(ICFAT.GT.0.AND.MODE.LE.0)MODE=5
C Set # of empty bands to the total # of bands in this case
	IF(ICFAT.GT.0)THEN
	NBNDF(1)=NBNDT(1)
	NBNDE(1)=1
	NBNDC(1)=NBNDT(1)
	ENDIF
C Check whether it exists or not
      INQUIRE(FILE=FATFILE,EXIST=EXIST)
	IF(ICFAT.GT.0)CALL GETFAT ! read parameters
C ***************************************************************
C OUTPUT FILE
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNOUT,60,NBE)
	OUTFILE=PROJECT(:NBP)//'.'//EXTNOUT(:NBE)
	CALL RMBLANK(OUTFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNOUT,LENEXTN)
      COMPUTE=PRESENT
      IF(     COMPUTE)ICOUT=2 !!! store output inforamtion
      IF(.NOT.COMPUTE)ICOUT=0 !!! print output information
      INQUIRE(FILE=OUTFILE,EXIST=EXIST)
      IF(EXIST.AND.ICOUT.EQ.1)THEN
	WRITE(IUT,*)'Terminated in <NMTFILE>::' 
	WRITE(IUT,*)'Output OUTFILE ',OUTFILE
	WRITE(IUT,*)'should not exist for this mode.'
      ELSEIF(EXIST.AND.ICOUT.EQ.2)THEN
C delete it
      OPEN(UNIT=1,FILE=OUTFILE,FORM='UNFORMATTED',
     &STATUS='OLD')
	CALL FIND_LBLANK(OUTFILE,130,NA)
      WRITE(IUT,*)OUTFILE(:NA),' DELETED !'
      CLOSE(UNIT=1,STATUS='DELETE')
      ENDIF
      IF(ICOUT.NE.0)THEN
      IUN=2
      OPEN(UNIT=2,FILE=OUTFILE,STATUS='NEW')
      ELSE
      IUN=IUT
      ENDIF
C ***************************************************************
C SET SCRATCH STORAGE FILENAMES
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNSCR,60,NBE)
	SCRFILE(1)=PROJECT(:NBP)//'.'//EXTNSCR(:NBE)
	CALL RMBLANK(SCRFILE(1),130)
	CALL FIND_LBLANK(SCRFILE(1),130,NA)
	ICSCR=-1
	CALL FIND_LBLANK(PATHSCRT,130,NS)
      DO I=2,100
      SCRFILE(I)=PATHSCRT(:NS)//SCRFILE(1)(:NA)//UN(I)
      ENDDO
      SCRFILE(1)=PATHSCRT(:NS)//SCRFILE(1)(:NA)//UN(1)
      DO I=1,100
      INQUIRE(FILE=SCRFILE(I),EXIST=EXIST)
      IF(EXIST)THEN
      OPEN(UNIT=1,FILE=SCRFILE(I),FORM='UNFORMATTED',
     &STATUS='OLD')
	CALL FIND_LBLANK(SCRFILE(I),130,NA)
      WRITE(IUT,*)SCRFILE(I)(:NA)//' DELETED !'
      CLOSE(UNIT=1,STATUS='DELETE')
      ENDIF
      ENDDO
C CHECK KEY CONSISTENCIES
	CALL NMTFILE_MESG02
	CALL NMTFILE_MESG03
	CALL NMTFILE_MESG04
	CALL NMTFILE_MESG05
C Set exit key after structure part
	IF(MODE.EQ.0)LIFT=1
C Set exit key after the bands
	IF(MODE.GT.3)LIFT=2
C Set # of divisions =0 
	IF(MODE.NE.5)NDIVDIR=0
C ***************************************************************
      CONTAINS
C SOME KEY CONSISTENCES
	SUBROUTINE NMTFILE_MESG01
	WRITE(IUT,*)'Terminated in <NMTFILE>:'
	WRITE(IUT,*)'Creation of FATFILE is not possible in this mode'
	WRITE(IUT,*)'since it requires k-point sampling along symmetry'
	WRITE(IUT,*)'lines which is inconsistent with any mode requiring'
	WRITE(IUT,*)'tetrahedron k-point sampling.'
	CALL FULLSTOP(' ')
	END SUBROUTINE NMTFILE_MESG01
	SUBROUTINE NMTFILE_MESG02
	IF(ICFAT.GT.0.AND.NDIVDIR.EQ.0)THEN
	WRITE(IUT,*)'Terminated in <NMTFILE>:'
	WRITE(IUT,*)'Creation of FATFILE is not possible in this mode.' 
	CALL FULLSTOP(' ')
	ENDIF
	END SUBROUTINE NMTFILE_MESG02
	SUBROUTINE NMTFILE_MESG03
	IF(LMTO.EQ.3.AND.ICFTR.EQ.0)THEN
	WRITE(IUT,*)'Terminated in <NMTFILE>:'
	WRITE(IUT,*)'For real-space calculations of the hamiltonian,'
	WRITE(IUT,*)'the screened structure constants in the real'
	WRITE(IUT,*)'space are required. Set input key IFTR=C and'
	WRITE(IUT,*)'specify the name of FTRFILE in the INIFILE.'
	CALL FULLSTOP(' ')
	ENDIF
	END SUBROUTINE NMTFILE_MESG03
	SUBROUTINE NMTFILE_MESG04
	IF(MODE.EQ.-1)THEN
	WRITE(IUT,*)'Terminated in <NMTFILE>:'
	WRITE(IUT,*)'RunMode is not recoginzed. If this is a '
	WRITE(IUT,*)'custom mode, output files must be specified.'
	CALL FULLSTOP(' ')
	ENDIF
	END SUBROUTINE NMTFILE_MESG04
      SUBROUTINE NMTFILE_MESG05
	IF(NDIR.EQ.0.AND.MODE.EQ.5)THEN
      WRITE(IUT,*)'Terminated in <NMTFILE>:'
      WRITE(IUT,*)'Section DIRS in STRFILE '
      WRITE(IUT,*)'does not contain symmetry direction settings,'
      WRITE(IUT,*)'while RUNMODE requires generation of k-points'      
      WRITE(IUT,*)'along symmetry lines.'
      CALL FULLSTOP(' ')
	ENDIF
      END SUBROUTINE NMTFILE_MESG05
	END SUBROUTINE NMTFILE
