	SUBROUTINE RPR48(NGR,KELI,NRP,IRDIM,CHAR,REPR)
******************************************************************
*	     PROGRAM FOR SEARCHING FOR IRREDUCIBLE GROUP           *
*                       REPRESENTATIONS      		  	           *
*								                               *
*	INPUT (BY FORMAL PARAMETERS) :				               *
*		- GROUP ORDER                < NGR >  		           *
*		- KELI TABLE OF THE GROUP    < KELI >		           *
*								                               *
*	OUTPUT (BY FORMAL PARAMETERS) :				               * 
*		-NUMBER OF IRR_REPR AND ITS DIMENSIONS		           *
*					< NRP >,< IRDIM >	                       *
*		-CHARACTERS TABLE	< CHAR >		                   *
*		-MATRIX OF IRR_REPR	< REPR >		                   *
******************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER KELI(NGR,NGR),IRDIM(48)     !KELI TABLE,DIMENSION OF IRR_REPER
	COMPLEX*16 CHAR(NGR,48)	            !CHARACTER TABLE
	COMPLEX*16 REPR(6,6,NGR,48)	        !MATRIX OF IRR_REPR
C     MAX DIMENSION OF IRR_REPR - 6
C     MAX NUMBER OF IRR_REPR    - 48
	INTEGER, ALLOCATABLE :: NLIST(:,:)
	INTEGER, ALLOCATABLE :: NWORK(:)
	INTEGER, ALLOCATABLE :: NLIST1(:,:)
	INTEGER, ALLOCATABLE :: NDEGR(:)
	INTEGER, ALLOCATABLE :: NCLNEW(:)
	INTEGER, ALLOCATABLE :: REGU(:,:,:)
	REAL*8, ALLOCATABLE :: WR(:)
	COMPLEX*16, ALLOCATABLE :: HH(:,:)
	COMPLEX*16, ALLOCATABLE :: HTR(:,:)
	COMPLEX*16, ALLOCATABLE :: VTR(:,:)
	COMPLEX*16, ALLOCATABLE :: VW(:)
	COMPLEX*16 RPR48_SCALAR,SUM
C  MEMORY ALLOCATIONS
	ALLOCATE(NLIST(NGR,NGR))
	ALLOCATE(NWORK(NGR))
	ALLOCATE(NLIST1(NGR,NGR))
	ALLOCATE(NDEGR(NGR))
	ALLOCATE(NCLNEW(NGR))
	ALLOCATE(REGU(NGR,NGR,NGR))
	ALLOCATE(WR(NGR))
	ALLOCATE(HH(NGR,NGR))
	ALLOCATE(HTR(NGR,NGR))
	ALLOCATE(VTR(NGR,NGR))
	ALLOCATE(VW(NGR))
C SET MEMORY
	DO IG=1,NGR
	DO JG=1,NGR
	NLIST(IG,JG)=1
	NLIST1(IG,JG)=1
	ENDDO
	ENDDO
C ********************* REGULAR MATRIX *****************
	DO IG=1,NGR
	DO I=1,NGR
	DO J=1,NGR
	IF(I.EQ.KELI(IG,J))THEN
	REGU(I,J,IG)=1.D0
	ELSE
	REGU(I,J,IG)=0.D0
	ENDIF
	ENDDO
	ENDDO
	ENDDO
C ******* SEARCHING FOR MATRIX COMMUTED WITH ALL *******
	CALL RPR48_BASMX(NGR,HH)
	SHPUR=0.D0
	DO I=1,NGR
	DO J=1,NGR
	IF(I.EQ.J)THEN
	HTR(I,J)=SHPUR
	ELSE
	SUM=(0.D0,0.D0)
	DO IG=1,NGR
	SUM=SUM+HH(KELI(IG,I),KELI(IG,J))
	ENDDO
	HTR(I,J)=SUM
	ENDIF
	VTR(I,J)=(0.D0,0.D0)
	IF(I.EQ.J)VTR(I,J)=(1.D0,0.D0)
	ENDDO
	ENDDO
C **************** EIGEN PROBLEM *****************
      CALL EIGEN1C(NGR,HTR,VTR,WR,1,1,IERR)
C ************** ORDERING OF EIGEN VALUE ************* 
	DO IE=1,NGR
	NWORK(IE)=0
	ENDDO
	NCL=0
	DO IE=1,NGR
	IF(NWORK(IE).EQ.0) THEN
	NCL=NCL+1
	N=0
	DO IE1=1,NGR
	IF(ABS(WR(IE)-WR(IE1)).LE.1D-04) THEN
	N=N+1
	NWORK(IE1)=1
	NLIST(N,NCL)=IE1
	ENDIF
	ENDDO
	NDEGR(NCL)=N
	ENDIF
	ENDDO
	DO IE=1,NCL
	NWORK(IE)=0
	ENDDO
	N=0
 100	DO IE=1,NCL
	IF(NWORK(IE).EQ.0) THEN
	IST=IE
	GOTO 200
	ENDIF
	ENDDO
	GOTO 300
 200	DO ICL=1,NCL
	IF(NWORK(ICL).EQ.0)THEN
	IF(NDEGR(IST).GT.NDEGR(ICL))IST=ICL
	ENDIF
	ENDDO
	N=N+1
	NCLNEW(IST)=N
	NWORK(IST)=1
	GOTO 100
 300	DO I=1,NCL
	IRDIM(NCLNEW(I))=NDEGR(I)
	DO J=1,NDEGR(I)
	NLIST1(J,NCLNEW(I))=NLIST(J,I)
	ENDDO
	ENDDO
C *********************** NEW REPRESENTATION *******************
	DO I=1,NCL
	DO I1=1,NGR
	DO J=1,IRDIM(I)
	DO J1=1,I
	CALL RPR48_MULTYV(NGR,REGU(1,1,I1),VTR(1,NLIST1(J1,I)),VW)
	REPR(J,J1,I1,I)=RPR48_SCALAR(NGR,VTR(1,NLIST1(J,I)),VW)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C ************************ CHARACTER CHECK ********************
	DO I=1,NCL
	DO I1=1,NGR
	SUM=(0.D0,0.D0)
	DO I2=1,IRDIM(I)
	SUM=SUM+REPR(I2,I2,I1,I)
	ENDDO
	CHAR(I1,I)=SUM
	ENDDO
	ENDDO
	N=1
	DO 500 I=2,NCL
	DO 400 J=1,N
	DO I1=1,NGR
	RC0=DREAL(CHAR(I1,J))
	AC0=DIMAG(CHAR(I1,J))
	RC=DREAL(CHAR(I1,I))
	AC=DIMAG(CHAR(I1,I))
	IF(ABS(RC0-RC).GE.1.D-05.OR.ABS(AC0-AC).GE.1.D-04) GOTO400
	ENDDO
	GOTO 500
 400	CONTINUE
	N=N+1
	IRDIM(N)=IRDIM(I)
	DO L1=1,NGR
	CHAR(L1,N)=CHAR(L1,I)
	DO M1=1,IRDIM(N)
	DO M2=1,IRDIM(N)
	REPR(M1,M2,L1,N)=REPR(M1,M2,L1,I)
	ENDDO
	ENDDO
	ENDDO
 500	CONTINUE
	NRP=N
C *********************** CHECK WORK ******************
	N=0
	DO I=1,NRP
	N=IRDIM(I)**2+N
	ENDDO
	IF(NGR.NE.N) PRINT*,'WARNING <1> FROM RPR48'
	DO I=1,NRP
	S=0.
	DO J=1,NGR
	S=S+CHAR(J,I)*CONJG(CHAR(J,I))
	ENDDO
	IF(ABS(NGR-S).GE.1.D-04) GOTO 600
	ENDDO
	GOTO1000
 600	PRINT*,'WARNING <2> FROM RPR48'
	GOTO1000
C  DEALLCATIONS
1000	DEALLOCATE(NLIST,NWORK,NLIST1,NDEGR,NCLNEW,REGU)
	DEALLOCATE(WR,HH,HTR,VTR,VW)
	END SUBROUTINE RPR48



	SUBROUTINE RPR48_BASMX(N,A)	
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 A(N,N)
	SHPUR=0.D0
	W1=5.D0
	W2=7.D0
	W=0.D0
	DO I=1,N
	DO J=1,I
	W=W+1.D0
	IF(I.EQ.J) THEN
	A(I,J)=SHPUR/N
	ELSE
	X=COS(W*W1)
	Y=SIN(W*W2)
	A(I,J)=CMPLX(X**2,Y**2)
	ENDIF
	ENDDO
	ENDDO
	DO I=1,N
	DO J=1,I
	A(J,I)=CONJG(A(I,J))
	ENDDO
	ENDDO
	RETURN
	END SUBROUTINE RPR48_BASMX



	FUNCTION RPR48_SCALAR(N,B,C)
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 B(N),C(N),RPR48_SCALAR,SUM
	SUM=(0.D0,0.D0)
	DO I=1,N
	SUM=SUM+CONJG(B(I))*C(I)
	ENDDO
	RPR48_SCALAR=SUM
	RETURN
	END FUNCTION RPR48_SCALAR



	SUBROUTINE RPR48_MULTYV(N,A,B,D)
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER A(N,N)
	COMPLEX*16 B(N),D(N),SUM
	DO I=1,N
	SUM=(0.D0,0.D0)
	DO K=1,N
	SUM=SUM+A(I,K)*B(K)
	ENDDO
	D(I)=SUM
	ENDDO
	RETURN
	END SUBROUTINE RPR48_MULTYV

	

