	SUBROUTINE SETUP
*************************************************************
*  Sets up default control parameters, variables, etc.      *
*************************************************************
C SET EXTERNAL CONNECTIONS
C Memory controls
      USE COM_LMTMEM  ,ONLY:  CURMEM,TOTMEM                    !!! from setup
C All files
      USE COM_LMTINP
	USE COM_EXTENS 
	USE COM_LMTOUT
C Outputs
      USE COM_MASHDEP ,ONLY:  EPSMAS,NVAL,LENREL,LENINT,LENCMP !!! from setup
      USE COM_LABELS  ,ONLY:  TXTSP,PATHSCRT,NAMESTRC,ELEMENT  !!! from setup
     &                       ,NAMEDENS,NAMEATOM,NAMELMTO 
      USE COM_UNIT    ,ONLY:  IUN,IUT,IUR,IUI                  !!! from setup
C SET LOCAL VARIBLES
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER*2 ELEM(0:104)
C SET PERIODIC TABLE DATA
      DATA ELEM/'e '
     &           ,'h ','he','li','be','b ','c ','n ','o ','f ','ne'
     &           ,'na','mg','al','si','p ','s ','cl','ar','k ','ca'
     &           ,'sc','ti','v ','cr','mn','fe','co','ni','cu','zn'
     &           ,'ga','ge','as','se','br','kr','rb','sr','y ','zr'
     &           ,'nb','mo','tc','ru','rh','pd','ag','cd','in','sn'
     &           ,'sb','te','i ','xe','cs','ba','la','ce','pr','nd'
     &           ,'pm','sm','eu','gd','tb','dy','ho','er','tm','yb'
     &           ,'lu','hf','ta','w ','re','os','ir','pt','au','hg'
     &           ,'tl','pb','bi','po','at','rn','fr','ra','ac','th'
     &           ,'pa','u ','np','pu','am','cm','bk','cf','es','fm'
     &           ,'md','no','lw','??'/
C DIFFERENT INITIALIZATIONS FOR PROGRAM:
      TXTSP(1)='up'   ! UP spin label
      TXTSP(2)='dn'   ! DOWN spin label
	DO IEL=0,104    ! Load elements names
	ELEMENT(IEL)=ELEM(IEL)
	ENDDO
C DATA DEPENDING ON THE COMPUTER:
C 1) Record lenght value for unformatted output
	NVAL=16         ! IBM RISC value
*     NVAL=4          ! DEC VAX  value 
*     NVAL=16         ! CRAY value 
*     NVAL=16         ! MS-DOS FTN77/486 value
C 2) Mashine accuracy
      DO I=-25,1
      SMALL=10.D0**I
      IF(1.D0+SMALL.NE.1.D0)EXIT
      ENDDO
      EPSMAS=SMALL
C 3) Lenghts of integers/reals/complexs
	LENREL=8        ! real double precision
	LENINT=4        ! integer single precision
	LENCMP=16       ! complex double precision
C DEFAULT OUTPUT CHANNELS
	IUT=6           ! default printing-to-terminal channel
      IUR=5           ! default reading-from-terminal channel
      IUI=5           ! standard channel for terminal reading
	IUN=6           ! standard channel for terminal printing
C PATHES
c	PATHSCRT='\Tmp\'                  ! scratch files
        PATHSCRT='/tmp/'                  ! scratch files
C	PATHSCRT='/user/savrasov/scratch/'! scratch files
C FILE NAMES
	CTRFILE='terminal'                     ! terminal input
	LOGFILE='terminal'                     ! terminal errors
	ABRFILE='abortnow'                     ! aborting flag
c	NAMEDENS='D:\PrincetonTech\MStudio BandLab\Atomdat\den.' ! atomic density data
c	NAMEATOM='D:\PrincetonTech\MStudio BandLab\Atomdat\rat.' ! input atomic files
c	NAMESTRC='D:\PrincetonTech\MStudio BandLab\Atomdat\str.' ! structure files
c	NAMELMTO='D:\PrincetonTech\MStudio BandLab\Atomdat\lmt.' ! LMTO atom files
!!!!!!!!!!!!!!!!   CHANGE BELOW    !!!!!!!!!!!!!!!!!!!!!!!!!!!
        NAMEDENS='/home/udo/atomdat/den.' ! atomic density data
        NAMEATOM='/home/udo/atomdat/rat.' ! input atomic files
        NAMESTRC='/home/udo/atomdat/str.' ! structure files
        NAMELMTO='/home/udo/atomdat/lmt.' ! LMTO atom files
C DEFAULT EXTENSIONS
	LENEXTN=3       ! # of characters
C Controls
	EXTNCTR='ctr'   ! CtrFile: Controls input
	EXTNLOG='log'   ! LogFile: Controls output
	EXTNABR='abr'   ! AbrFile: Controls termination
	EXTNINF='inf'   ! InfFile: Information
C Inputs
	EXTNINI='ini'   ! IniFile: Input control and atomic data
	EXTNSCS='scs'   ! ScsFile: Input charge density
	EXTNSTR='str'   ! StrFile: Input structure data
	EXTNHOP='hop'   ! HopFile: Input hopiings
	EXTNHUB='hub'   ! HubFile: Input Hubbard parameters
	EXTNPNT='pnt'   ! PntFile: Input list of q-points
	EXTNENR='enr'   ! EnrFile: Input energies
	EXTNKOV='kov'   ! KovFile: Group symmetry
C Outputs
	EXTNCON='con'   ! ConFile: Bare Structure constants
	EXTNFTR='ftr'   ! FtrFile: Screened structure constants
	EXTNATM='atm'   ! AtmFile: Atoms & Structure
	EXTNGRP='grp'   ! GrpFile: Crystal group elements
	EXTNPSI='psi'   ! PsiFile: Wave functions
	EXTNTMP='tmp'   ! TmpFile: Temporary storage
	EXTNBND='bnd'   ! BndFile: Energy bands
	EXTNFRS='frs'   ! FrsFile: Fermi Surface
	EXTNPOT='pot'   ! PotFile: Full potential
	EXTNFAT='fat'   ! FatFile: Fat bands
	EXTNDOS='dos'   ! DosFile: Density of states
	EXTNGRF='grf'   ! GrfFile: Greens function in DMFT
	EXTNSCF='scf'   ! ScfFile: Output charge density
	EXTNHBR='hbr'   ! HbrFile: Output Hubbard parameters
	EXTNHPP='hpp'   ! HppFile: Output Hoppings
	EXTNOUT='out'   ! OutFile: Current output
	EXTNOPT='opt'   ! OptFile: Optical properties
	EXTNODF='odf'   ! OdfFile: Optical properties using input Sigma(w)
	EXTNCHI='chi'   ! ChiFile: susceptibility
	EXTNSCR='scr'   ! ScrFile: Scratch storage
C NULLIFY MEMORY
	CURMEM=0.D0     ! current memory used
	TOTMEM=0.D0     ! total memory used 
C BLANK FILENAMES
	DO IPOS=1,130
	INIFILE(IPOS:IPOS)=' '
	SCSFILE(IPOS:IPOS)=' '
	SCFFILE(IPOS:IPOS)=' '
	STRFILE(IPOS:IPOS)=' '
	CONFILE(IPOS:IPOS)=' '
	OUTFILE(IPOS:IPOS)=' '
	HOPFILE(IPOS:IPOS)=' '
	HUBFILE(IPOS:IPOS)=' '
	FTRFILE(IPOS:IPOS)=' '
	PSIFILE(IPOS:IPOS)=' '
	TMPFILE(IPOS:IPOS)=' '
	BNDFILE(IPOS:IPOS)=' '
	POTFILE(IPOS:IPOS)=' '
	FATFILE(IPOS:IPOS)=' '
	DOSFILE(IPOS:IPOS)=' '
	GRFFILE(IPOS:IPOS)=' '
	CHIFILE(IPOS:IPOS)=' '
	OPTFILE(IPOS:IPOS)=' '
	ODFFILE(IPOS:IPOS)=' '
	ATMFILE(IPOS:IPOS)=' '
	GRPFILE(IPOS:IPOS)=' '
	DO I=1,100
	SCRFILE(I)(IPOS:IPOS)=' '
	ENDDO
	ENDDO
	END
