	SUBROUTINE ARTOUT(TEXT)
******************************************************
*   Output module of the LMTO package                *
******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,LRWF,NPFR,IEXC    !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS       !!! from readini
     &                      ,ILST,ILSB,ILSV,LRTV,NHSORT
      USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC                  !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS            !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SWZ                          !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC          !!! from readini
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,NDIR,NDIVDIR,HSPNT,PNTNOT! from readstr
      USE COM_KMESH   ,ONLY: NPNT,PNT                         !!! from tetra
      USE COM_FERMI   ,ONLY: EF                               !!! from ttrints
      USE COM_QMESH   ,ONLY: NQPNT,QPNT                       !!! from tetra
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                  !!! from setup
      USE COM_CHANNELS,ONLY: IUAIN,IUDOS,IUCHI                !!! from channels
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                      !!! from setup
      USE COM_LMTOUT                                          !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER TEXT*(*),EQ(64),TEXCH(0:30)*40,TRELATIV(0:1)*4,YH*1
      INTEGER MTR(2)
	LOGICAL EXIST,OPEN
	DATA TEXCH(0)/'Not included!'/ 
     &    ,TEXCH(1)/'Barth-Hedin'/ 
     &    ,TEXCH(2)/'Gunnarson-Lundqvist'/
     &    ,TEXCH(3)/'Janak-Williams-Morruzi'/
     &    ,TEXCH(4)/'Vosko-Wilk-Nussair'/
     &    ,TEXCH(5)/'Perdew-Wang 1991'/
     &    ,TEXCH(6)/'Gaspar-Kohn-Sham'/
     &    ,TRELATIV/'Non-','Semi'/
     &    ,EQ/64*'='/
      DATA MTR/-1,1/
	WRITE(IUN,1000)EQ
	WRITE(IUN,*)TEXT
	IF(LIFT.EQ.1)CALL FULLSTOP(' ')
1000  FORMAT(1X,64A)
	WRITE(IUN,1010)PAR
	WRITE(IUN,1011)ORTH
	ILR=0
	DO ISORT=1,NSORT
	IF(LRTV(ISORT).NE.0)ILR=1
      WRITE(IUN,1012)SMT(ISORT),ILST(ISORT),ILSB(ISORT),ILSV(ISORT),
     &TXTEL(ISORT)
	ENDDO
      ILDA=MOD(IEXC,10)     !!! LDA key
      IGGA=(IEXC-ILDA)/10   !!! GGA key
	WRITE(IUN,*)'Local Exchange-Correlation : ',TEXCH(ILDA)
	IF(IGGA.EQ.1)
     &WRITE(IUN,*)'Including gradient corrections after Perdew 91'
	IF(IGGA.EQ.2)
     &WRITE(IUN,*)'Including gradient corrections after Perdew 96'
	WRITE(IUN,*)TRELATIV(ILR)//'relativistic Version'
	IF(NORBS.EQ.2)WRITE(IUN,*)'with spin-orbit coupling'
	IF(NSPIN.EQ.1)WRITE(IUN,*)'Non-Spin-Polarized Version'
	IF(NSPIN.EQ.2)WRITE(IUN,*)'Spin-Polarized Version'
1010  FORMAT(' Lattice Parameter  =',G14.7)
1011  FORMAT(' B/A =',G14.7,' C/A =',G14.7)
1012  FORMAT(' S   =',G14.7,' Lmax=',3(1X,I2),1X,A10)
C STOP LMTART NOW:
	CALL FULLSTOP(' ')
	END SUBROUTINE ARTOUT




	SUBROUTINE ABORTNOW
************************************************************
*     ABORT LMTART                                         *
************************************************************
      USE COM_UNIT
      USE COM_LMTINP
      USE COM_LMTOUT
	LOGICAL EXIST
	INQUIRE(FILE=ABRFILE,EXIST=EXIST)
	IF(EXIST)THEN
	OPEN(UNIT=102,FILE=ABRFILE,STATUS='OLD')
	CLOSE(102,STATUS='DELETE')
	CALL FULLSTOP('Aborted.')
	ENDIF
	END



	SUBROUTINE FULLSTOP(TSTOP)
************************************************************
*  Stops LMTART program.                                   *
************************************************************
      USE COM_UNIT
      USE COM_LMTINP
      USE COM_LMTOUT
	CHARACTER*(*) TSTOP
      CHARACTER DAYS(7)*9,MONTHES(12)*9,DATE*8,TIME*10,FILE*130
	LOGICAL EXIST,OPEN
      INTRINSIC DATE_AND_TIME
C ********************************************************
C CLOSE SCRATCH FILES
	DO I=1,99
	FILE=SCRFILE(I)
	CALL RMBLANK(FILE,130)
	IF(FILE(1:1).EQ.' ')CYCLE
	INQUIRE(FILE=SCRFILE(I),EXIST=EXIST,OPENED=OPEN)
	IF(EXIST)THEN
	IF(.NOT.OPEN)OPEN(UNIT=I,FILE=SCRFILE(I),FORM='UNFORMATTED',
     &STATUS='OLD')
	CALL FIND_LBLANK(SCRFILE(I),130,NA)
	CLOSE(UNIT=I,STATUS='DELETE')
	WRITE(IUT,*)SCRFILE(I)(:NA)//' DELETED !'
	ENDIF
	ENDDO
C CLOSE CONTROL FILE
	FILE=CTRFILE
	CALL RMBLANK(FILE,130)
	IF(IUR.NE.IUI.AND.FILE(1:1).NE.' ')THEN
	INQUIRE(FILE=CTRFILE,EXIST=EXIST,OPENED=OPEN)
	IF(EXIST.AND.OPEN)CLOSE(IUR)
	ENDIF
C ********************************************************
C CLOSE STANDARD OUTPUT FILE
	FILE=OUTFILE
	CALL RMBLANK(FILE,130)
	IF(FILE(1:1).NE.' ')THEN
	INQUIRE(FILE=OUTFILE,EXIST=EXIST,OPENED=OPEN)
	IF(EXIST.AND.OPEN)THEN
	IF(ICOUT.NE.0)CLOSE(UNIT=IUN,STATUS='KEEP')
	IF(ICOUT.EQ.0)CLOSE(UNIT=IUN,STATUS='DELETE')  !!! output channel 
	ENDIF
	ENDIF
C *********************************************************************
C CLOSE LOGFILE
	WRITE(IUT,*)TSTOP
      CALL GET_DATES(MONTHES,DAYS)
      CALL DATE_AND_TIME(DATE,TIME)
      READ(DATE(5:6),*)IM
      CALL FIND_LBLANK(MONTHES(IM),9,NBL)
      WRITE(IUT,1110)DATE(7:8),MONTHES(IM)(1:NBL),DATE(1:4),
     &               TIME(1:2),TIME(3:4),' , LMTART stopped.'
1110  FORMAT(1X,A2,1X,A,1X,A4,' , time ',A2,':',A2,A)
	FILE=LOGFILE
	CALL RMBLANK(FILE,130)
	IF(FILE(1:1).NE.' ')THEN
	INQUIRE(FILE=LOGFILE,EXIST=EXIST,OPENED=OPEN)
	IF(EXIST.AND.OPEN)CLOSE(IUT)
	ENDIF
	CALL LMTSTOP
	END SUBROUTINE FULLSTOP
