	SUBROUTINE FTBSCF
************************************************************
*   The calculation of the energy band structure in terms  *
*   of tight-binding parameters                            *
************************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                         !!! from setup
      USE COM_LMTINP  ,ONLY : TRACINP                        !!! from readini
      USE COM_CONTROL ,ONLY : LIFT,LMTO                      !!! from readini
      USE COM_SPHERE  ,ONLY : FILING                         !!! from readhop
      USE COM_SCFLOOP ,ONLY : NITER1                         !!! from readini
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT,IUI                !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER ST*8,FN*8,PROGN*8
	LOGICAL EXIT,TRACER
	DATA ST/'started'/,FN/'finished'/
	CALL FTBSET(1)
C CALCULATE STRUCTURE VECTORS
	progn='Vecgen  '
      if(tracer(progn,tracinp,iut,iur,iui))then
	call timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL VECGEN         !!! generate structure vectors
	call timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
	endif
	IF(LIFT.LE.1)CALL ARTOUT('No band structure calculation')
C  *****  THE LOOP OF SELF-CONSISTENCY *****
	DO 100 ITER=1,NITER1
	write(iun,1100)iter
C CALCULATE FULL POTENTIAL
	progn='HubPOT  '
      if(tracer(progn,tracinp,iut,iur,iui))then
	call timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
      CALL HUBPOT
      CALL HUBINT
      CALL PRINTH(IUN,3)
      CALL PRINTH(IUN,4)
      CALL MIXDEN(ITER,1)
	call timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C CALCULATE BAND STRUCTURE WITH TB
	progn='FTBands '
      if(tracer(progn,tracinp,iut,iur,iui))then
	call timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL FTBANDS        !!! find band energies and eigenvectors
	call timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C CALCULATE OPTICAL PROPERTIES WITH TB
      progn='FtbOpt  '
      if(tracer(progn,tracinp,iut,iur,iui))then
      call timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL FTBOPT         !!! find optical properties
      call timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
      endif
C CALCULATE SUSCEPTIBILITY WITH TB
      progn='FtbChi  '
      if(tracer(progn,tracinp,iut,iur,iui))then
      call timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL FTBCHI         !!! find susceptibility
      call timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
      endif
      IF(LIFT.LE.2)CALL ARTOUT('No SCF loop')
      CALL PRINTDM(IUN)   !!! prints density matirx
      CALL PRINTH(IUN,1)  !!! prints partial occupancies
      CALL WRITEHUB(2)    !!! store occupation numbers
C CALCULATE TOTAL ENERGY
	progn='Energy  '
      if(tracer(progn,tracinp,iut,iur,iui))then
	call timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL FTENERGY(EXIT) !!! calculate Etot in LDA or GGA91
	call timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
	endif
	IF(EXIT)CALL ARTOUT('Total energy convergence reached')
C ADMIX DENSITY/SELF-ENERGY FOR THE NEXT ITERATION
      CALL MIXDEN(ITER,2)
	IF(EXIT)CALL ARTOUT('Charge convergence reached')
	write(iun,1130)TOTMEM
	write(iun,1140)TXTMEM
 100  CONTINUE
	CALL ARTOUT('Number of iterations exceeded in the SCF1 loop')
	CALL FTBSET(2)
1100	FORMAT(/'                ITERATION ',I3/)
1110  FORMAT('***** ',A8,1X,A8,'; CPU : ',G12.5,
     &         '; CUR/MAX mem.(Mb): ',G10.3,'/',G10.3)
1120  FORMAT('***** ',A8,1X,A8,'; CPU : ',G12.5,
     &         '; CUR/MAX mem.(Mb): ',G10.3,'/',G10.3)
1130  FORMAT(/' Maximum memory allocated (Mbyte) ==',G14.7)
1140  FORMAT( ' Peak memory reached in ',A)
	END




	SUBROUTINE FTBSET(ISW)
************************************************************
*  Switches pointers from LMTO to TB and vice versa.       *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                               !!! from setup
      USE COM_PARAM   ,ONLY : NATOM,NSORT,NSPIN,IS,ILST,ILSB,LRTV !!! from readini
      USE COM_KAPPAR  ,ONLY : NPAN,NKAP                           !!! from readini
      USE COM_PANPAR  ,ONLY : LTPAN,LSPAN                         !!! from readini
      USE COM_TBBPAR  ,ONLY : LTBAS,LSBAS,INBAS,NTBAS             !!! from readhop
      USE COM_LMTIND  ,ONLY : LMTIND                              !!! from lmtpar
      USE COM_NBANDS  ,ONLY : NBNDF,NBNDE,NBNDT,NBNDC             !!! from readini
	LOGICAL, ALLOCATABLE :: LTLMT(:,:)
	LOGICAL, ALLOCATABLE :: LSLMT(:,:)
	LOGICAL, ALLOCATABLE :: INLMT(:,:,:)
	SAVE
	IF(ISW.EQ.1)THEN
	ALLOCATE(LTLMT(0:LMAXBMEM,NATOMMEM))
	ALLOCATE(LSLMT(0:LMAXBMEM,NATOMMEM))
	ALLOCATE(INLMT(0:LMAXBMEM,NATOMMEM,NSPINMEM))
C REDEFINE # OF BANDS FOR TIGHT-BINDING
	NLMTF=NBNDF(1)
	NLMTE=NBNDE(1)
	NLMTT=NBNDT(1)
	NLMTC=NBNDC(1)
	NPANS=NPAN
	NKAPS=NKAP(1)
      NBNDF(1)=NTBAS
      NBNDT(1)=NTBAS
      NBNDE(1)=1
      NBNDC(1)=NTBAS
	NPAN=1
	NKAP(1)=1
C REDFINE BASIS SET POINTERS
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)
	LTLMT(L,IATOM)=LTPAN(L,IATOM,1,1)
	LTPAN(L,IATOM,1,1)=LTBAS(L,IATOM)
	ENDDO
	ENDDO
	DO ISORT=1,NSORT
	DO L=0,ILSB(ISORT)
	LSLMT(L,ISORT)=LSPAN(L,ISORT,1,1)
	LSPAN(L,ISORT,1,1)=LSBAS(L,ISORT)
	ENDDO
	ENDDO
	DO IPAN=1,NPAN
	IDIM=0
	DO IKAP=1,NKAP(IPAN)
	DO ISPIN=1,NSPIN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)
	IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
	DO M=-L,L
	LM=L*(L+1)+M+1
	IDIM=IDIM+1
	LMTIND(LM,IATOM,IKAP,ISPIN,IPAN)=IDIM
	ENDDO 
	ENDIF
	ENDDO 
	ENDDO 
	ENDDO 
	ENDDO
	ENDDO
	ELSEIF(ISW.EQ.2)THEN
	NBNDF(1)=NLMTF
	NBNDE(1)=NLMTE
	NBNDT(1)=NLMTT
	NBNDC(1)=NLMTC
	NPAN=NPANS
	NKAP(1)=NKAPS
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)
	LTPAN(L,IATOM,1,1)=LTLMT(L,IATOM)
	ENDDO
	ENDDO
	DO ISORT=1,NSORT
	DO L=0,ILSB(ISORT)
	LSPAN(L,ISORT,1,1)=LSLMT(L,ISORT)
	ENDDO
	ENDDO
	IDIM=0
	DO IPAN=1,NPAN
	DO IKAP=1,NKAP(IPAN)
	DO ISPIN=1,NSPIN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))CYCLE
	DO M=-L,L
	LM=L*(L+1)+M+1
	IDIM=IDIM+1
	LMTIND(LM,IATOM,IKAP,ISPIN,IPAN)=IDIM
	ENDDO 
	ENDDO 
	ENDDO 
	ENDDO 
	ENDDO
	ENDDO
	DEALLOCATE(LTLMT,LSLMT,INLMT)
	ENDIF
	END
