	SUBROUTINE FTBOPT
************************************************************
*   The calculation of optical properties                  *
************************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                        !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO                      !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,NHSORT !!! from readini
	USE COM_KAPPAR  ,ONLY: NPAN,NKAP                      !!! from readini
	USE COM_KMESH   ,ONLY: NPNT,PNT                       !!! from tetra
	USE COM_FREQU   ,ONLY: NOMGOPT                        !!! from tetra
      USE COM_SPHERE  ,ONLY: FILING                         !!! from readini
      USE COM_FERMI   ,ONLY: EF                             !!! from ttrints
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
	USE COM_LMTOUT  ,ONLY: ICCON,ICOPT                    !!! from readini
	USE COM_CHANNELS,ONLY: IUCON,IUOPT                    !!! from channels
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	DATA PI/3.141592653589793D0/
	IF(ICOPT.EQ.0)RETURN
C FIND FERMI LEVEL
      CALL BANDS_INSL(EF,FILING)        !!! recognize insulating case
      CALL EFSEARCH(EF,FILING,EF,100,1.D-09,0.8D0)! search for Fermi energy
C Compute radial matrix elements
	CALL NULOPT(1)                    !!! set eps(w)=0
C INTEGRATE OVER BRILLOUIN ZONE
	DO IPNT=1,NPNT(1)                 !!! over k-points
C Optical matrix elements
	CALL OPTDHK(IPNT)                 !!! compute current matrix element
	CALL OPTPTB(IPNT)                 !!! goto band representation
C COMPUTE E2 FOR ALL FREQUENCIES
	DO IOMG=0,NOMGOPT                 !!! over frequencies
	CALL OPTTET(IPNT,IOMG)            !!! k-point tetrahedron weights
	CALL OPTINT(IPNT,IOMG)            !!! integrate dielectric function 
      ENDDO                             !!! over frequencies
 	ENDDO                             !!! over k-points
	CLOSE(UNIT=IUOPT,STATUS='DELETE')
	IF(ICCON.EQ.0)CLOSE(UNIT=IUCON,STATUS='DELETE')
	IF(ICCON.NE.0)CLOSE(UNIT=IUCON,STATUS='KEEP')
	CALL SYMOPT                       !!! symmetrize optical integrals
	CALL SETOPT                       !!! save optical properties
	END
