	SUBROUTINE LMTOPT
************************************************************
*   The calculation of optical properties                  *
************************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                        !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO                      !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,NHSORT !!! from readini
	USE COM_KAPPAR  ,ONLY: NPAN,NKAP                      !!! from readini
	USE COM_KMESH   ,ONLY: NPNT,PNT                       !!! from tetra
	USE COM_FREQU   ,ONLY: NOMGOPT                        !!! from tetra
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC        !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,ZCOR,ZSEM,ZVAL            !!! from readini
      USE COM_FERMI   ,ONLY: EF                             !!! from ttrints
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
	USE COM_LMTOUT  ,ONLY: ICCON,ICOPT                    !!! from readini
	USE COM_CHANNELS,ONLY: IUCON,IUOPT                    !!! from channels
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	DATA PI/3.141592653589793D0/
	IF(ICOPT.EQ.0)RETURN
C FIND FERMI LEVEL
      ZVALTOT=0.D0
      DO ISORT=1,NSORT                         !!! define total valence charge
      ZVALTOT=ZVALTOT+(ZNUC(ISORT)-ZCOR(ISORT))*NHSORT(ISORT)
      ENDDO
      ZSEMTOT=0.D0
      DO IPAN=2,NPAN                           !!! define semicore charge
      ZSEMTOT=ZSEMTOT+2.D0*NBNDT(IPAN)
      ENDDO
      CALL BANDS_INSL(EF,ZVALTOT-ZSEMTOT)      !!! recognize insulating case
      CALL EFSEARCH(EF,ZVALTOT-ZSEMTOT,EF,100,1.D-09,0.8D0)! search for Fermi energy
C Compute radial matrix elements
	CALL POTPAR(1)                    !!! different potential partameters
	CALL LMTPAR(1)                    !!! some combinations of parameters
	CALL OVRPAR(1)                    !!! potential parameters for overlapping
	CALL OPTPAR(1)                    !!! optical matrix elements
	CALL NULOPT(1)                    !!! set eps(w)=0
C INTEGRATE OVER BRILLOUIN ZONE
	DO IPNT=1,NPNT(1)                 !!! over k-points
C Structure constants
      CALL STRSUM(IPNT,1,0)             !!! calculate lattice sums
      CALL STRGNT(IPNT,1,0,1)           !!! restore bare structure matrices
      CALL STRALP(IPNT,1,0)             !!! screen structure constants
      CALL SCRSTR(IPNT,1,0)             !!! restore screened structure constants
C Optical matrix elements
	CALL OPTMAT(IPNT)                 !!! compute current matrix element
	CALL OPTHAN(IPNT)                 !!! add interstitial region
	CALL OPTPSI(IPNT)                 !!! goto band representation
C COMPUTE E2 FOR ALL FREQUENCIES
	DO IOMG=0,NOMGOPT                 !!! over frequencies
	CALL OPTTET(IPNT,IOMG)            !!! k-point tetrahedron weights
	CALL OPTINT(IPNT,IOMG)            !!! integrate dielectric function 
      ENDDO                             !!! over frequencies
 	ENDDO                             !!! over k-points
	CLOSE(UNIT=IUOPT,STATUS='DELETE')
	IF(ICCON.EQ.0)CLOSE(UNIT=IUCON,STATUS='DELETE')
	IF(ICCON.NE.0)CLOSE(UNIT=IUCON,STATUS='KEEP')
	CALL SYMOPT                       !!! symmetrize optical integrals
	CALL SETOPT                       !!! save optical properties
	END
