	SUBROUTINE OPTDHK(IPNT)
*********************************************************
*  Computes derivative of the hamiltonian with respect  *
*  to k-point                                           *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_LATTICE ,ONLY: RBAS,GBAS,TAU                    !!! from readstr
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB  !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS          !!! from readhop
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_ENVSITE ,ONLY: NENV,TENV,ISENV                  !!! from envmesh
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC          !!! from readini
      USE COM_HOPCOM  ,ONLY: TMAT,SMAT                        !!! from readhop
	USE COM_OPTMAT  ,ONLY: OPTN                             !!! from optmat
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,SH                     !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                         !!! from tetra
      USE COM_MASHDEP ,ONLY: LENCMP                           !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT                          !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 EXPKR,TMU
	LOGICAL LOG
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
C none
C K-POINT
	XK=PNT(1,IPNT,1)+SH(1,1)
	YK=PNT(2,IPNT,1)+SH(2,1)
	ZK=PNT(3,IPNT,1)+SH(3,1)
	DO MU=-1,1
	DO IDIM1=1,NBNDT(1)*NSPIN
	DO IDIM =1,NBNDT(1)*NSPIN
	OPTN(IDIM1,IDIM,MU)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
C CALCULATE HAMILTONIAN AND OVERLAP MATRICES IN K-SPACE
	DO 3000 MU=-1,1
      DO 2000 IORBS=1,NORBS
      DO 1000 IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IATOM1=1,NATOM                   !!! over iatom1
	ISORT1=IS(IATOM1)
	DO L1=0,ILSB(ISORT1)                !!! over l1
	DO M1=-L1,L1                        !!! over m1
	IF(.NOT.LTBAS(L1,IATOM1))EXIT
	L1M1=L1*(L1+1)+M1+1
	IDIM1=INBAS(L1M1,IATOM1)+NTBAS*(ISPIN1-1)
C  DO OVER CLUSTER SITES SURROUNDING IATOM1
	DO IENV=0,NENV(IATOM1)              !!! over ienv
	IATOM=ISENV(IENV,IATOM1) 
	ISORT=IS(IATOM)
C  Current matrix element is slightly altered here
C  It is not just dH/dk for TB representation since
C  M(k)=dH/dk=Sum(R) e(ikR)*iR*H(R+tau-tau') does not obey 
C  proper rotation rules as <chi|Nabla|chi>. We use instead
C  M(k)=Sum(R) e(ikR)*i(R+tau-tau')*H(R+tau-tau')
C  where R+tau-tau' is a cluster vector Tenv
C  which obeys the same rotation rules as matrix element of nabla operator.
	RX=TENV(1,IENV,IATOM1)+(TAU(1,IATOM1)-TAU(1,IATOM))
	RY=TENV(2,IENV,IATOM1)+(TAU(2,IATOM1)-TAU(2,IATOM))
	RZ=TENV(3,IENV,IATOM1)+(TAU(3,IATOM1)-TAU(3,IATOM))
	TX=TENV(1,IENV,IATOM1)
	TY=TENV(2,IENV,IATOM1)
	TZ=TENV(3,IENV,IATOM1)
      IF(MU.EQ.-1)TMU=+1.D0/SQRT(2.D0)*(TX+(0.D0,1.D0)*TY) ! R^mu, not R_mu here
      IF(MU.EQ.+1)TMU=-1.D0/SQRT(2.D0)*(TX-(0.D0,1.D0)*TY) ! because of k_mu
      IF(MU.EQ. 0)TMU=TZ
	SCP=XK*RX+YK*RY+ZK*RZ
	EXPKR=EXP((0.D0,+1.D0)*SCP*2.D0*PI) 
	DO L=0,ILSB(ISORT)                  !!! over l
	DO M=-L,L                           !!! over m
	IF(.NOT.LTBAS(L,IATOM))EXIT
	LM=L*(L+1)+M+1
	IDIM=INBAS(LM,IATOM)+NTBAS*(ISPIN-1)
C Extra i goes for hermitianness; Extra 0.5 goes from the fact that 0.5*dH/dk=<k|i*Nabla|k>
C whihch is most easy to see for free electrons: 0.5*dE/dk= k = - <k|i*Nabla|k>
	OPTN(IDIM1,IDIM,MU)=OPTN(IDIM1,IDIM,MU)+(0.D0,0.5D0)*
     &(0.D0,1.D0)*TMU*PAR*EXPKR*TMAT(L1M1,LM,IATOM1,IENV,ISPIN,IORBS)
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over ienv
      ENDDO                               !!! over m1
      ENDDO                               !!! over l1
      ENDDO                               !!! over iatom1
1000	CONTINUE                            !!! over spins
2000	CONTINUE                            !!! over iorbs
3000	CONTINUE                            !!! over polarizations
	END
