	SUBROUTINE OPTINT(IPNT,IOMG)
************************************************************
*   The calculation of optical properties                  *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                        !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO                      !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,NHSORT !!! from readini
     &                      ,IS,ILST,ILSB
	USE COM_KAPPAR  ,ONLY: NPAN,NKAP                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                    !!! from readini
	USE COM_KMESH   ,ONLY: NPNT,PNT                       !!! from tetra
      USE COM_FREQU   ,ONLY: NOMGOPT,OMGOPT                 !!! from readini
	USE COM_OPTMAT  ,ONLY: WGTOPT,WGTDOS,OPTN,E2W,V2A     !!! from optmat
      USE COM_ENERGY  ,ONLY: WEIGH,WEIGD                    !!! from bands
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC        !!! from readini
      USE COM_LMTIND  ,ONLY: LMTIND                         !!! from lmtpar
	USE COM_CHANNELS,ONLY: IUPSI                          !!! from readini
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
	USE COM_LMTOUT  ,ONLY: ICOPT                          !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 DIM
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
	IF(ICOPT.EQ.0)RETURN
C MEMORY ALLOCATIONS
C none
C COMPUTE CONTRIBUTION TO OPTICAL MATRIX
	DO MU=-1,1                                    !!! over polarizations
	DO NU=-1,1                                    !!! over polarizations
	DO IBNDS=1,NSPIN                              !!! over spin subbands
      DO IBNDT=1,NBNDT(1)                           !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IBNDS1=1,NSPIN                             !!! over spin subbands
      DO IBNDT1=1,NBNDT(1)                          !!! over bands
      IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	E2W(IOMG,MU,NU)=E2W(IOMG,MU,NU)+WGTOPT(IBAND,IBAND1)*
     &(-DIM)*(-1)**MU*OPTN(IBAND,IBAND1,-MU)*
     &(-DIM)*         OPTN(IBAND1,IBAND,+NU)        !!! -iNabla = momentum operator
	ENDDO                                         !!! over bands
	ENDDO                                         !!! over spin subbands
	ENDDO                                         !!! over bands
	ENDDO                                         !!! over spin subbands
	ENDDO                                         !!! over polarizations
	ENDDO                                         !!! over polarizations
C COMPUTE CONTRIBUTION TO AVERAGE VELOCITY
	IF(IOMG.EQ.0)THEN
	DO MU=-1,1                                    !!! over polarizations
	DO NU=-1,1                                    !!! over polarizations
	DO IBNDS=1,NSPIN                              !!! over spin subbands
      DO IBNDT=1,NBNDT(1)                           !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	V2A(MU,NU)=V2A(MU,NU)+DIM*(-1)**MU*OPTN(IBAND,IBAND,-MU)*
     &DIM*OPTN(IBAND,IBAND,+NU)*WEIGD(IBAND,IPNT)*4.D0 !  4=1/m^2
	ENDDO                                         !!! over bands
	ENDDO                                         !!! over spin subbands
	ENDDO                                         !!! over polarizations
	ENDDO                                         !!! over polarizations
	ENDIF
C MEMORY DEALLOCATIONS
C none
	END





	SUBROUTINE NULOPT(IDUM)
************************************************************
*   Set optical properties to zero                         *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                        !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO                      !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,NHSORT !!! from readini
     &                      ,IS,ILST,ILSB
	USE COM_KAPPAR  ,ONLY: NPAN,NKAP                      !!! from readini
	USE COM_KMESH   ,ONLY: NPNT,PNT                       !!! from tetra
      USE COM_FREQU   ,ONLY: NOMGOPT,OMGOPT                 !!! from readini
	USE COM_OPTMAT  ,ONLY: WGTOPT,WGTDOS,OPTN,E2W,V2A     !!! from optmat
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC        !!! from readini
	USE COM_CHANNELS,ONLY: IUOPT                          !!! from channels
      USE COM_MASHDEP ,ONLY: LENCMP,NVAL                    !!! from readini
      USE COM_LMTOUT  ,ONLY: SCRFILE                        !!! from readini
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
	USE COM_LMTOUT  ,ONLY: ICOPT                          !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: OPTP(:,:,:,:)
	DATA PI/3.141592653589793D0/
	IF(ICOPT.EQ.0)RETURN
C MEMORY ALLOCATIONS
	ALLOCATE(V2A(-1:1,-1:1))
	ALLOCATE(E2W(0:NOMGOPT,-1:1,-1:1))
	ALLOCATE(WGTOPT(NBNDT(1)*NSPINMEM,NBNDT(1)*NSPINMEM))
	ALLOCATE(WGTDOS(NBNDT(1)*NSPINMEM))
	ALLOCATE(OPTN(NBNDT(1)*NSPINMEM,NBNDT(1)*NSPINMEM,-1:1))
C SET IMAGINARY DIELECTRIC FUNCTIONS TO ZERO
	DO IOMG=0,NOMGOPT
	DO MU=-1,1
	DO NU=-1,1
      V2A(MU,NU)=0.D0
	E2W(IOMG,MU,NU)=0.D0
	ENDDO
	ENDDO
	ENDDO
C MEMORY DEALLOCATIONS
	END