	SUBROUTINE OPTMAT(IPNT)
************************************************************
*   The calculation of optical matrix elements             *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LMTO,IASA,NPFR,NOVR              !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS
     &                      ,IS,ILSB,ILST                     !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SWZ                          !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT                !!! from readini
      USE COM_HAMPAR  ,ONLY: HPARHH,HPARJH,HPARHJ,HPARJJ      !!! from optpar
      USE COM_LMTIND  ,ONLY: LMTIND                           !!! from lmtpar
	USE COM_OPTMAT  ,ONLY: OPTN                             !!! from optmat
      USE COM_CHANNELS,ONLY: IUOPT                            !!! from lmtmat
      USE COM_STRCON  ,ONLY: SSCON,SDCON                      !!! from strgnt
	USE COM_LMTOUT  ,ONLY: ICOPT                            !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: HSS(:,:)
      COMPLEX*16  OMTS
	DATA PI/3.141592653589793D0/
	CALL  ABORTNOW()
C MEMORY ALLOCATIONS
	ALLOCATE(HSS(LIMTMEM,NATOMMEM))
C SET ZEROES
	DO MU=-1,1
	DO IDIM1=1,NBNDT(1)*NSPIN
	DO IDIM =1,NBNDT(1)*NSPIN
	OPTN(IDIM1,IDIM,MU)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
C ********************************************
C SET OPTICAL MATRIX ELEMENTS: MT-SPHERES PART
	DO 3000 MU=-1,1                   !!! over polarizations
	DO 2000 IORBS=1,NORBS             !!! over iorbs
	DO 1000 IUPDN=1,NSPIN             !!! over spins
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
C Skip off-diagonal-over-spins elements
	IF(ISPIN1.NE.ISPIN)CYCLE
	DO IKAP1=1,NKAP(1)                !!! over energy
	DO IKAP =1,NKAP(1)                !!! over energy
	DO IATOM=1,NATOM                  !!! read three-center parameter
	ISORT=IS(IATOM)
	IREC=IKAP1+NKAP(1)*(IKAP-1)+NKAP(1)**2*(IATOM-1)+
     &NKAP(1)**2*NATOM*(IUPDN-1)+
     &NKAP(1)**2*NATOM*NSPIN*(IORBS-1)+
     &NKAP(1)**2*NATOM*NSPIN*NORBS*(MU+1)
	READ(IUOPT,REC=IREC)((HPARHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((HPARJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
      ENDDO         
	DO IATOM1=1,NATOM                 !!! over iatom1
	ISORT1=IS(IATOM1) 
	DO L1=0,ILSB(ISORT1)              !!! over l1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,1))CYCLE
	DO M1=-L1,L1                      !!! over m1
	L1M1=L1*(L1+1)+M1+1
	IDIM1=LMTIND(L1M1,IATOM1,IKAP1,ISPIN1,1)
	DO KATOM=1,NATOM
	DO L3M3=1,(ILST(IS(KATOM))+1)**2
	HSS(L3M3,KATOM)=(0.D0,0.D0)
	DO L2M2=1,(ILST(IS(KATOM))+1)**2
	HSS(L3M3,KATOM)=HSS(L3M3,KATOM)+
     &CONJG(SSCON(L2M2,KATOM,L1M1,IATOM1,IKAP1))*
     &HPARJJ(L2M2,L3M3,KATOM)
      ENDDO         
      ENDDO         
      ENDDO         
	DO IATOM=1,NATOM                  !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                !!! over l
	IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	DO M=-L,L                         !!! over m
	LM=L*(L+1)+M+1
	IDIM=LMTIND(LM,IATOM,IKAP,ISPIN,1)
	OMTS=(0.D0,0.D0)
C ONE-CENTER TERM :
	IF(IATOM1.EQ.IATOM)THEN
	OMTS=OMTS+HPARHH(L1M1,LM,IATOM)
	ENDIF
C TWO-CENTER TERM :
	DO L2M2=1,(ILST(ISORT)+1)**2      !!! over l2m2
	OMTS=OMTS-HPARJH(L2M2,LM,IATOM)*
     &CONJG(SSCON(L2M2,IATOM,L1M1,IATOM1,IKAP1))
      ENDDO                             !!! over l2m2
	DO L2M2=1,(ILST(ISORT1)+1)**2     !!! over l2m2
	OMTS=OMTS-HPARHJ(L1M1,L2M2,IATOM1)*
     &SSCON(L2M2,IATOM1,LM,IATOM,IKAP)
      ENDDO                             !!! over l2m2
C THREE-CENTER TERM :
	DO KATOM=1,NATOM                  !!! over katom
	KSORT=IS(KATOM)
	DO L2=0,ILST(KSORT)               !!! over l2
	DO M2=-L2,L2                      !!! over m2
	L2M2=L2*(L2+1)+M2+1
	OMTS=OMTS+HSS(L2M2,KATOM)*SSCON(L2M2,KATOM,LM,IATOM,IKAP)
      ENDDO                             !!! over m2
      ENDDO                             !!! over l2
      ENDDO                             !!! over katom
C SET OPTICAL MATRIX ELEMENT
      OPTN(IDIM1,IDIM,MU)=OPTN(IDIM1,IDIM,MU)+OMTS
      ENDDO                             !!! over m
      ENDDO                             !!! over l
      ENDDO                             !!! over iatom
      ENDDO                             !!! over m1
      ENDDO                             !!! over l1
      ENDDO                             !!! over iatom1
      ENDDO                             !!! over energy
      ENDDO                             !!! over energy
 1000 CONTINUE                          !!! over spins
 2000 CONTINUE                          !!! over iorbs
 3000	CONTINUE                          !!! over polarizations
C MEMORY DEALLOCATIONS
	DEALLOCATE(HSS)
	END
