	SUBROUTINE OPTPAR(IPAN)
***************************************************************
*   Calculate optical matrix elements                         *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM
      USE COM_CONTROL ,ONLY: LMTO,IASA,NOVR,NPFR                    !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS
     &                      ,IS,ILST,ILSB,ILSV,LRTV                 !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS                  !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,SMT,SASA,SWZ                      !!! from readini
      USE COM_SYMMLM  ,ONLY: SYM,LMSYM                              !!! from symlmm
      USE COM_POTDAT  ,ONLY: POT,POTSPH,POTRWF                      !!! from potfull
      USE COM_INPPAR  ,ONLY: ENY,DNY                                !!! from readini
      USE COM_INTPAR  ,ONLY: WHH,WJH,WHJ,WJJ                        !!! from ovrpar
      USE COM_LMTPAR  ,ONLY: GAM,AAH,AAJ,BBH,BBJ                    !!! from potpar
      USE COM_HAMPAR  ,ONLY: HPARHH,HPARJH,HPARHJ,HPARJJ            !!! from potpar
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT,RL                  !!! from radmesh
      USE COM_GAUNT   ,ONLY: C                                      !!! from gdata
      USE COM_CHANNELS,ONLY: IUOPT                                  !!! from readini
      USE COM_LMTOUT  ,ONLY: ICSCR,SCRFILE                          !!! from readini
      USE COM_MASHDEP ,ONLY: NVAL,LENREL,LENCMP                     !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: AFI(:,:)
	REAL*8, ALLOCATABLE :: AFID(:,:)
	REAL*8, ALLOCATABLE :: AFIP(:,:)
	REAL*8, ALLOCATABLE :: AFIDP(:,:)
	REAL*8, ALLOCATABLE :: AFIDDS(:)
	REAL*8, ALLOCATABLE :: AFIDDPS(:)
	COMPLEX*16, ALLOCATABLE :: RADMAT(:,:,:)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: FIH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIJ(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FDH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FDJ(:,:,:,:)
	LOGICAL LOG1,LOG
	DATA PI/3.141592653589793D0/
	SQPI43=SQRT(4.D0*PI/3.D0)
      CALL ABORTNOW()
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
	ALLOCATE(RADMAT(4,0:LMAXTMEM,2))
      SIZE_RADMAT=DBLE(SIZE(RADMAT)*LENCMP)/1024.D0**2
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(FIH(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIJ(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FDH(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FDJ(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
      SIZE_FIS=4.D0*DBLE(SIZE(FIH)*LENCMP)/1024.D0**2
	ALLOCATE(AFI(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFID(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDP(0:NRADMEM,0:LMAXTMEM))
	SIZE_AFI=4.D0*DBLE(SIZE(AFI)*LENREL)/1024.D0**2
	ALLOCATE(AFIDDS(0:LMAXTMEM))
	ALLOCATE(AFIDDPS(0:LMAXTMEM))
      CURMEM=CURMEM+SIZE_RADMAT+SIZE_FIS+SIZE_AFI
      IF(TOTMEM.LT.CURMEM)TXTMEM='<OPTPAR> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C OPEN SCRATCH FILE FOR STORING POTENTIAL PARAMETERS
	NRECL=0
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	LMAXH=((ILSB(ISORT)+1)**2+(ILST(ISORT)+1)**2)**2
	NRECL=MAX(NRECL,NVAL*LMAXH)
	ENDDO
	OPEN(UNIT=IUOPT,FILE=SCRFILE(IUOPT),STATUS='NEW',
     &ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
C *******************************************************
C CALCULATE OPTICAL MATRIX ELEMENTS
	DO 5000 IATOM=1,NATOM           !!! over atoms
	ISORT=IS(IATOM)
C Find FIny and FIny-dot radial functions:
	DO ISPIN=1,NSPIN
	DO IKAP=1,NKAP(IPAN)           !!! over energies
      CALL RADSCH_PHIS(ENY(0,ISORT,IKAP,IPAN,ISPIN),AFI,AFIP,
     &AFID,AFIDP,AFIDDS,AFIDDPS,SMT(ISORT),POTRWF(0,ISORT,ISPIN),
     &ILST(ISORT),NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),
     &LRTV(ISORT))
C Transfere to FIH and FIJ convinient functions:
	DO L=0,ILST(ISORT)
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP,ISPIN)=AAH(L,ISORT,IKAP,IPAN,ISPIN)*
     &AFI(IRAD,L)+BBH(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
	FIJ(IRAD,L,IKAP,ISPIN)=AAJ(L,ISORT,IKAP,IPAN,ISPIN)*
     &AFI(IRAD,L)+BBJ(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
	FDH(IRAD,L,IKAP,ISPIN)=AAH(L,ISORT,IKAP,IPAN,ISPIN)*
     &AFID(IRAD,L)+BBH(L,ISORT,IKAP,IPAN,ISPIN)*AFIDP(IRAD,L)
	FDJ(IRAD,L,IKAP,ISPIN)=AAJ(L,ISORT,IKAP,IPAN,ISPIN)*
     &AFID(IRAD,L)+BBJ(L,ISORT,IKAP,IPAN,ISPIN)*AFIDP(IRAD,L)
      ENDDO    
      ENDDO   
      ENDDO                          !!! over energies
	ENDDO                          !!! over spins
	DO 4000 IORBS=1,NORBS          !!! over spins
	DO 3000 IUPDN=1,NSPIN          !!! over spins
	IF(IORBS.EQ.1)THEN
	IUPDN1=IUPDN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNF=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	IUPDN1=NSPIN+1-IUPDN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNF=-SQRT(2.D0) ! B^{+} * <S_{+}>
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNF=+SQRT(2.D0) ! B^{-} * <S_{-}>
	ENDIF
	DO 2000 IKAP1=1,NKAP(IPAN)     !!! over ikap1
	DO 1000 IKAP=1,NKAP(IPAN)      !!! over ikap
C CALCULATE DIFFERENT RADIAL MATRIX ELEMENTS
	DO L=0,ILST(ISORT)             !!! over l
	RADMAT(1,L,1)=(0.D0,0.D0)
	RADMAT(2,L,1)=(0.D0,0.D0)
	RADMAT(3,L,1)=(0.D0,0.D0)
	RADMAT(4,L,1)=(0.D0,0.D0)
	RADMAT(1,L,2)=(0.D0,0.D0)
	RADMAT(2,L,2)=(0.D0,0.D0)
	RADMAT(3,L,2)=(0.D0,0.D0)
	RADMAT(4,L,2)=(0.D0,0.D0)
C <FiH|Nabla|FiH>
	LOG1=L.LT.ILSB(ISORT)
	IF(LOG1)LOG1=LTPAN(L+1,IATOM,IKAP1,IPAN)
	LOG=LTPAN(L,IATOM,IKAP,IPAN)
	IF(LOG1.AND.LOG)THEN
	DO IRAD=0,NRAD(ISORT)           !!! over radial mesh
	WORK1(IRAD)=R(IRAD,ISORT)*DR(IRAD,ISORT)*
     &DCONJG(FIH(IRAD,L+1,IKAP1,ISPIN1))*(FDH(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)-DBLE(L)*FIH(IRAD,L,IKAP,ISPIN))
      ENDDO                           !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(1,L,1)=WORK2(NRAD(ISORT))
	ENDIF
	LOG1=L.GT.0
	IF(LOG1)LOG1=LTPAN(L-1,IATOM,IKAP1,IPAN)
	LOG=LTPAN(L,IATOM,IKAP,IPAN)
	IF(LOG1.AND.LOG)THEN
	DO IRAD=0,NRAD(ISORT)           !!! over radial mesh
	WORK1(IRAD)=R(IRAD,ISORT)*DR(IRAD,ISORT)*
     &DCONJG(FIH(IRAD,L-1,IKAP1,ISPIN1))*(FDH(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)+DBLE(L+1)*FIH(IRAD,L,IKAP,ISPIN))
      ENDDO                           !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(1,L,2)=WORK2(NRAD(ISORT))
	ENDIF
C <FiJ|Nabla|FiH>
	LOG1=L.LT.ILST(ISORT)
	LOG=LTPAN(L,IATOM,IKAP,IPAN)
	IF(LOG1.AND.LOG)THEN
	DO IRAD=0,NRAD(ISORT)           !!! over radial mesh
	WORK1(IRAD)=R(IRAD,ISORT)*DR(IRAD,ISORT)*
     &DCONJG(FIJ(IRAD,L+1,IKAP1,ISPIN1))*(FDH(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)-DBLE(L)*FIH(IRAD,L,IKAP,ISPIN))
      ENDDO                           !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(2,L,1)=WORK2(NRAD(ISORT))*GAM(L+1,ISORT)
	ENDIF
	LOG1=L.GT.0
	LOG=LTPAN(L,IATOM,IKAP,IPAN)
	IF(LOG1.AND.LOG)THEN
	DO IRAD=0,NRAD(ISORT)           !!! over radial mesh
	WORK1(IRAD)=R(IRAD,ISORT)*DR(IRAD,ISORT)*
     &DCONJG(FIJ(IRAD,L-1,IKAP1,ISPIN1))*(FDH(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)+DBLE(L+1)*FIH(IRAD,L,IKAP,ISPIN))
      ENDDO                           !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(2,L,2)=WORK2(NRAD(ISORT))*GAM(L-1,ISORT)
	ENDIF
C <FiH|Nabla|FiJ>
	LOG1=L.LT.ILSB(ISORT)
	IF(LOG1)LOG1=LTPAN(L+1,IATOM,IKAP1,IPAN)
	LOG=.TRUE.
	IF(LOG1.AND.LOG)THEN
	DO IRAD=0,NRAD(ISORT)           !!! over radial mesh
	WORK1(IRAD)=R(IRAD,ISORT)*DR(IRAD,ISORT)*
     &DCONJG(FIH(IRAD,L+1,IKAP1,ISPIN1))*(FDJ(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)-DBLE(L)*FIJ(IRAD,L,IKAP,ISPIN))
      ENDDO                           !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(3,L,1)=WORK2(NRAD(ISORT))*GAM(L,ISORT)
	ENDIF
	LOG1=L.GT.0
	IF(LOG1)LOG1=LTPAN(L-1,IATOM,IKAP1,IPAN)
	LOG=.TRUE.
	IF(LOG1.AND.LOG)THEN
	DO IRAD=0,NRAD(ISORT)           !!! over radial mesh
	WORK1(IRAD)=R(IRAD,ISORT)*DR(IRAD,ISORT)*
     &DCONJG(FIH(IRAD,L-1,IKAP1,ISPIN1))*(FDJ(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)+DBLE(L+1)*FIJ(IRAD,L,IKAP,ISPIN))
      ENDDO                           !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(3,L,2)=WORK2(NRAD(ISORT))*GAM(L,ISORT)
	ENDIF
C <FiJ|Nabla|FiJ>
	LOG1=L.LT.ILST(ISORT)
	LOG=.TRUE.
	IF(LOG1.AND.LOG)THEN
	DO IRAD=0,NRAD(ISORT)           !!! over radial mesh
	WORK1(IRAD)=R(IRAD,ISORT)*DR(IRAD,ISORT)*
     &DCONJG(FIJ(IRAD,L+1,IKAP1,ISPIN1))*(FDJ(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)-DBLE(L)*FIJ(IRAD,L,IKAP,ISPIN))
      ENDDO                           !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(4,L,1)=WORK2(NRAD(ISORT))*GAM(L+1,ISORT)*GAM(L,ISORT)
	ENDIF
	LOG1=L.GT.0
	LOG=.TRUE.
	IF(LOG1.AND.LOG)THEN
	DO IRAD=0,NRAD(ISORT)           !!! over radial mesh
	WORK1(IRAD)=R(IRAD,ISORT)*DR(IRAD,ISORT)*
     &DCONJG(FIJ(IRAD,L-1,IKAP1,ISPIN1))*(FDJ(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)+DBLE(L+1)*FIJ(IRAD,L,IKAP,ISPIN))
      ENDDO                           !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(4,L,2)=WORK2(NRAD(ISORT))*GAM(L-1,ISORT)*GAM(L,ISORT)
	ENDIF
      ENDDO                          !!! over l
C DO OVER POLARIZATIONS
	DO 500 MU=-1,1                 !!! over polarizations
C ******************************
C GET TOTAL POTENTIAL PARAMETERS
C ******************************
	DO L1=0,ILST(ISORT)            !!! over l1
	DO M1=-L1,L1                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO L=0,ILST(ISORT)             !!! over l
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
C Zeroise
	IF(L1.LE.ILSB(ISORT).AND.L.LE.ILSB(ISORT))
     &HPARHH(L1M1,LM,IATOM)=(0.D0,0.D0)
	IF(L.LE.ILSB(ISORT))
     &HPARJH(L1M1,LM,IATOM)=(0.D0,0.D0)
	IF(L1.LE.ILSB(ISORT))
     &HPARHJ(L1M1,LM,IATOM)=(0.D0,0.D0)
	HPARJJ(L1M1,LM,IATOM)=(0.D0,0.D0)
C Set values
	IF(L1.EQ.L+1.AND.M1.EQ.M+MU)THEN
	IF(LOG1.AND.LOG)HPARHH(L1M1,LM,IATOM)=
     &HPARHH(L1M1,LM,IATOM)+(0.D0,1.D0)**(L-L1)*
     &SQPI43*C(0,L1M1,LM)*RADMAT(1,L,1)
	IF(LOG)HPARJH(L1M1,LM,IATOM)=
     &HPARJH(L1M1,LM,IATOM)+(0.D0,1.D0)**(L-L1)*
     &SQPI43*C(0,L1M1,LM)*RADMAT(2,L,1)
	IF(LOG1)HPARHJ(L1M1,LM,IATOM)=
     &HPARHJ(L1M1,LM,IATOM)+(0.D0,1.D0)**(L-L1)*
     &SQPI43*C(0,L1M1,LM)*RADMAT(3,L,1)
	HPARJJ(L1M1,LM,IATOM)=
     &HPARJJ(L1M1,LM,IATOM)+(0.D0,1.D0)**(L-L1)*
     &SQPI43*C(0,L1M1,LM)*RADMAT(4,L,1)
	ENDIF
C Set values
	IF(L1.EQ.L-1.AND.M1.EQ.M+MU.AND.ABS(M+MU).LE.L-1)THEN
	IF(LOG1.AND.LOG)HPARHH(L1M1,LM,IATOM)=
     &HPARHH(L1M1,LM,IATOM)+(0.D0,1.D0)**(L-L1)*
     &SQPI43*C(0,L1M1,LM)*RADMAT(1,L,2)
	IF(LOG)HPARJH(L1M1,LM,IATOM)=
     &HPARJH(L1M1,LM,IATOM)+(0.D0,1.D0)**(L-L1)*
     &SQPI43*C(0,L1M1,LM)*RADMAT(2,L,2)
	IF(LOG1)HPARHJ(L1M1,LM,IATOM)=
     &HPARHJ(L1M1,LM,IATOM)+(0.D0,1.D0)**(L-L1)*
     &SQPI43*C(0,L1M1,LM)*RADMAT(3,L,2)
	HPARJJ(L1M1,LM,IATOM)=
     &HPARJJ(L1M1,LM,IATOM)+(0.D0,1.D0)**(L-L1)*
     &SQPI43*C(0,L1M1,LM)*RADMAT(4,L,2)
	ENDIF
      ENDDO                          !!! over m
      ENDDO                          !!! over l
      ENDDO                          !!! over m1
      ENDDO                          !!! over l1
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+
     &NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)+
     &NKAP(IPAN)**2*NATOM*NSPIN*NORBS*(MU+1)
	WRITE(IUOPT,REC=IREC)((HPARHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((HPARJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
 500	CONTINUE                       !!! over polarizations
1000  CONTINUE                       !!! over ikap
2000  CONTINUE                       !!! over ikap1
3000	CONTINUE                       !!! over spins
4000	CONTINUE                       !!! over iorbs
5000  CONTINUE                       !!! over atoms
C MEMORY DEALLOCATIONS
	DEALLOCATE(RADMAT,WORK1,WORK2,FIH,FIJ,FDH,FDJ)
	DEALLOCATE(AFI,AFID,AFIP,AFIDP,AFIDDS,AFIDDPS)
      CURMEM=CURMEM-SIZE_RADMAT-SIZE_FIS-SIZE_AFI
	END
