	SUBROUTINE OPTPSI(IPNT)
************************************************************
*   The calculation of optical properties                  *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                        !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO                      !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,NHSORT !!! from readini
     &                      ,IS,ILST,ILSB
	USE COM_KAPPAR  ,ONLY: NPAN,NKAP                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                    !!! from readini
	USE COM_KMESH   ,ONLY: NPNT,PNT                       !!! from tetra
      USE COM_FREQU   ,ONLY: NOMGOPT,OMGOPT                 !!! from readini
	USE COM_OPTMAT  ,ONLY: WGTOPT,OPTN,E2W                !!! from optmat
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC        !!! from readini
      USE COM_LMTIND  ,ONLY: LMTIND                         !!! from lmtpar
	USE COM_CHANNELS,ONLY: IUPSI                          !!! from readini
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
	USE COM_LMTOUT  ,ONLY: ICOPT                          !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: ATMP(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: ALMT(:,:)
	COMPLEX*16, ALLOCATABLE :: OTMP(:,:)
	COMPLEX*16 OINT
	DATA PI/3.141592653589793D0/
	IF(ICOPT.EQ.0)RETURN
C MEMORY ALLOCATIONS
	ALLOCATE(ATMP(LIMBMEM,NATOMMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(ALMT(NBNDT(1)*NSPINMEM,NBNDT(1)*NSPINMEM))
	ALLOCATE(OTMP(NBNDT(1)*NSPINMEM,NBNDT(1)*NSPINMEM))
C  READ EIGENVECTORS
	DO IBNDS=1,NSPIN                              !!! over spin subbands
      DO IBNDT=1,NBNDT(1)                           !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IDIM=1,NBNDT(1)*NSPIN
	ALMT(IDIM,IBAND)=(0.D0,0.D0)
	ENDDO
	DO IORBS=1,NORBS                              !!! over spinors
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
	DO IKAP=1,NKAP(1)
      IREC=IKAP+NKAP(1)*(IBNDT-1)+
     &NKAP(1)*NBNDT(1)*(IBNDS-1)+
     &NKAP(1)*NBNDT(1)*NSPIN*(ISPIN-1)*(NORBS-1)+
     &NKAP(1)*NBNDT(1)*NSPIN*NORBS*(IPNT-1)
      READ(IUPSI,REC=IREC)
     &((ATMP(LM,IATOM,IKAP,ISPIN),LM=1,(ILSB(IS(IATOM))+1)**2),
     &IATOM=1,NATOM)
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)
	IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	DO M=-L,L
	LM=L*(L+1)+M+1
	IDIM=LMTIND(LM,IATOM,IKAP,ISPIN,1)
	ALMT(IDIM,IBAND)=ATMP(LM,IATOM,IKAP,ISPIN)	
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO                                         !!! over spinors
	ENDDO                                         !!! over bands
	ENDDO                                         !!! over spin subbands
C COMPUTE CONTRIBUTION TO OPTICAL MATRIX
	DO 1000 MU=-1,1                               !!! over polarizations
	DO IBNDS=1,NSPIN                              !!! over spin subbands
      DO IBNDT=1,NBNDT(1)                           !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IDIM1=1,NBNDT(1)*NSPIN
	OTMP(IDIM1,IBAND)=(0.D0,0.D0)
	DO IDIM=1,NBNDT(1)*NSPIN
	OTMP(IDIM1,IBAND)=OTMP(IDIM1,IBAND)+
     &OPTN(IDIM1,IDIM,MU)*ALMT(IDIM,IBAND)
      ENDDO                                         !!! over idim
      ENDDO                                         !!! over idim1
	ENDDO                                         !!! over bands
	ENDDO                                         !!! over spin subbands
	DO IBNDS1=1,NSPIN                             !!! over spin subbands
      DO IBNDT1=1,NBNDT(1)                          !!! over bands
      IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	DO IBNDS=1,NSPIN                              !!! over spin subbands
      DO IBNDT=1,NBNDT(1)                           !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	OPTN(IBAND1,IBAND,MU)=(0.D0,0.D0)
	DO IDIM1=1,NBNDT(1)*NSPIN                     !!! over idim1
	OPTN(IBAND1,IBAND,MU)=OPTN(IBAND1,IBAND,MU)+
     &DCONJG(ALMT(IDIM1,IBAND1))*OTMP(IDIM1,IBAND)
      ENDDO                                         !!! over idim1
	ENDDO                                         !!! over bands
	ENDDO                                         !!! over spin subbands
	ENDDO                                         !!! over bands
	ENDDO                                         !!! over spin subbands
 1000	CONTINUE                                      !!! over polarizations
C CHECK HERMITIANNES 
C NOTE THAT MATRIX ELEMENT IS TAKEN WITH NABLA ONLY! NO (0.0,1.0) IS ADDED!
	DIF=0.D0
	ID1=0
	ID2=0
	MU0=0
	DO MU=-1,1
	DO IDIM1=1,NBNDT(1)*NSPIN
	DO IDIM =1,NBNDT(1)*NSPIN
	DEL=ABS(OPTN(IDIM1,IDIM,MU)+(-1)**MU*DCONJG(OPTN(IDIM,IDIM1,-MU)))
	IF(DIF.LE.DEL)THEN
	DIF=DEL
	ID1=IDIM1
	ID2=IDIM
	MU0=MU
	ENDIF
	ENDDO
	ENDDO
	ENDDO
C PRINT MAXIMUM ERROR FOR DEBUGGING PURPOSES
C	PRINT*,'In band representation',ID1,ID2,MU0
C	PRINT*,OPTN(ID1,ID2,MU0)
C	PRINT*,-(-1)**MU0*DCONJG(OPTN(ID2,ID1,-MU0))
C ENFORCE HERMITIANNESS
	DO MU=-1,1
	DO IDIM1=1,NBNDT(1)*NSPIN
	DO IDIM =1,NBNDT(1)*NSPIN
	OINT=0.5D0*(OPTN(IDIM1,IDIM,+MU)-(-1)**MU*
     &     DCONJG(OPTN(IDIM,IDIM1,-MU)))
	OPTN(IDIM1,IDIM,+MU)=OINT
	OPTN(IDIM,IDIM1,-MU)=-(-1)**MU*DCONJG(OINT)
	ENDDO
	ENDDO
	ENDDO
C MEMORY DEALLOCATIONS
	DEALLOCATE(ATMP,ALMT,OTMP)
	END



