	SUBROUTINE SYMOPT
************************************************************
*   Symmetrize optical matrix                              *
************************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                        !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO                      !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,NHSORT !!! from readini
     &                      ,IS,ILST,ILSB
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                     !!! from readini
	USE COM_KAPPAR  ,ONLY: NPAN,NKAP                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                    !!! from readini
	USE COM_KMESH   ,ONLY: NPNT,PNT                       !!! from tetra
      USE COM_FREQU   ,ONLY: NOMGOPT,OMGOPT                 !!! from readini
	USE COM_GROUPS  ,ONLY: NGROUP,U,IP,RDC,SHIFT,INV,IKOV !!! from groups
	USE COM_OPTMAT  ,ONLY: E2W,V2A                        !!! from optmat
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC        !!! from readini
      USE COM_LMTIND  ,ONLY: LMTIND                         !!! from lmtpar
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
	USE COM_LMTOUT  ,ONLY: ICOPT                          !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: E2T(:,:)
	COMPLEX*16, ALLOCATABLE :: E2R(:,:)
	DATA PI/3.141592653589793D0/
	IF(ICOPT.EQ.0)RETURN
C MEMORY ALLOCATIONS
	ALLOCATE(E2T(-1:1,-1:1))
	ALLOCATE(E2R(-1:1,-1:1))
C START LOOPING OVER FREQUENCIES
	DO 1000 IOMG=0,NOMGOPT
C SYMMETRIZE IMAGINARY DIELECTRIC FUNCTION
	DO MU=-1,1
	DO NU=-1,1
	E2T(MU,NU)=(0.D0,0.D0)
	IF(IOMG.EQ.0)
     &E2R(MU,NU)=(0.D0,0.D0)
	ENDDO
	ENDDO
	DO IR=1,NGROUP
	IG=IKOV(IR)
	DO MU=-1,1
	DO NU=-1,1
      DO MU1=-1,1
      DO NU1=-1,1
      MUMU1=3+3*(1+MU1)+MU
      NUNU1=3+3*(1+NU1)+NU
      E2T(MU,NU)=E2T(MU,NU)+
     &DCONJG(U(MUMU1,IG))*E2W(IOMG,MU1,NU1)*U(NUNU1,IG)
	IF(IOMG.EQ.0)
     &E2R(MU,NU)=E2R(MU,NU)+
     &DCONJG(U(MUMU1,IG))*V2A(     MU1,NU1)*U(NUNU1,IG)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C PROPERLY NORMALIZED INTERBAND IMAGINARY SUSCEPTIBILITY
	DO MU=-1,1
	DO NU=-1,1
	E2W(IOMG,MU,NU)=(0.D0,0.D0)
	IF(ABS(OMGOPT(IOMG)).GT.1.D-10)
     &E2W(IOMG,MU,NU)=E2T(MU,NU)/DBLE(NGROUP)*
     &8.D0*PI*PI/OMEGAC/OMGOPT(IOMG)**2/0.5D0/0.5D0  !!! 4pi^2e^2/V/m^2
	IF(IOMG.EQ.0)
     &V2A(     MU,NU)=E2R(MU,NU)/DBLE(NGROUP)
	ENDDO
	ENDDO
 1000	CONTINUE                                       !!! over frequencies
C MEMORY DEALLOCATIONS
	DEALLOCATE(E2T,E2R)
	END

