	SUBROUTINE HSTR(XK,YK,ZK,ILS2,ILD2,NE,E,FIRST,LAST,
     &NLPMAX,NLDMAX,NKPMAX,SIGMA,SIGMADOT)
********************************************************************
*    Subroutine calculates Sigma-structure constants for           *
*    negative values of energy E                                   *
*                                                                  *
*      k       _  ikR              l *                             *
* Sigma  (E)=K > e   H (K|R-T|)(-i) Y (R-T)  ; E=K*K ; T-basis     *
*      LT      -      l              L                             *
*              R                                                   *
*   as well as their energy derivatives                            *
*   Method: direct summation                                       *
********************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM,   ONLY : NATOM                           !!! from readini
	USE COM_LATTICE, ONLY : RBAS,GBAS                       !!! from readstr
      USE COM_VECGEN,  ONLY : LIMDT,NIVEC,NRVEC,NGVEC,NSVEC   !!! from vecgen
     &                       ,RVEC,GVEC,SVEC,DELTAU,ALPHEVL
     &                       ,ETAEVLD
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, ALLOCATABLE :: LIMLDL(:)
      INTEGER, ALLOCATABLE :: LIMLPL(:)
      REAL*8,  ALLOCATABLE :: BETT(:)
      COMPLEX*16, ALLOCATABLE :: EN(:)
      COMPLEX*16, ALLOCATABLE :: HAN(:,:)
      COMPLEX*16, ALLOCATABLE :: YY(:)
      COMPLEX*16, ALLOCATABLE :: AKAP(:)
      COMPLEX*16, ALLOCATABLE :: HT(:)
C Passed parameters
	INTEGER ILD2(LIMDTMEM),ILS2(LIMDTMEM)
	COMPLEX*16 SIGMA(NLPMAX,LIMDTMEM,NKPMAX),E(NKPMAX)
     &    ,SIGMADOT(NLDMAX,LIMDTMEM,NKPMAX)
	COMPLEX*16 COEF,COEFDOT,EXPKR,DIMUNIT
	DIMENSION GL(3)
	LOGICAL FIRST,LAST
	SAVE
	DATA PI/3.141592653589793D0/,DIMUNIT/(0.D0,1.D0)/
	SQPI4=SQRT(4.D0*PI)
      LPLMEM=(2*LMAXVMEM+3)**2
	IF(FIRST)THEN  !!! set k-independent variables
C MEMORY ALLOCATIONS
      ALLOCATE(LIMLDL(LIMDTMEM))
      ALLOCATE(LIMLPL(LIMDTMEM))
      ALLOCATE(BETT(LPLMEM))
      ALLOCATE(YY(LPLMEM))
      ALLOCATE(HAN(3,0:2*LMAXVMEM+2))
      ALLOCATE(EN(NKAPMEM))
      ALLOCATE(AKAP(NKAPMEM))
      ALLOCATE(HT(NKAPMEM))
C CALCULATE K-INDEPENDENT VALUES
	CALL CROSS(GL,RBAS(1,2),RBAS(1,3))
	OMEGA=ABS(RBAS(1,1)*GL(1)+RBAS(2,1)*GL(2)+RBAS(3,1)*GL(3)) 
	RMAXR=(3.D0*DBLE(NRVEC)*OMEGA/4.D0/PI)**(1.D0/3.D0) ! accuracy
	ILS2MAX=0
	DO 10 ITAU=1,LIMDT
	LIMLPL(ITAU)=(ILS2(ITAU)+1)**2
	LIMLDL(ITAU)=(ILD2(ITAU)+1)**2
	ILS2MAX=MAX(ILS2MAX,ILS2(ITAU))
  10  CONTINUE
	CALL SPHHARM_BETT(2*LMAXVMEM+2,BETT)
	SWZ=(3.D0/(4.D0*PI)*OMEGA/DBLE(NATOM))**(1.D0/3.D0) !!! WZ-radius
	IE0=0
	DO 20 IEN=1,NE
	EN(IEN)=E(IEN)
	IF(DREAL(EN(IEN)).GE.0.D0)
     &CALL FULLSTOP('<HSTR>:: ENERGY .GE. 0')
	HT(IEN)=-(0.D0,1.D0)/SQRT(EN(IEN))/SWZ
	AKAP(IEN)=SQRT(ABS(EN(IEN)))
  20  CONTINUE
	ENDIF
C  SET LIMIT BEHAVIOR
	DO 50 IEN=1,NE
	DO 40 ITAU=1,LIMDT
	DO 30 LM=1,LIMLPL(ITAU)
	SIGMA(LM,ITAU,IEN)=(0.D0,0.D0)
	IF(LM.LE.LIMLDL(ITAU))SIGMADOT(LM,ITAU,IEN)=(0.D0,0.D0)
  30  CONTINUE
  40  CONTINUE
  50  CONTINUE
C****************** LATTICE SUMMATION ************************
	DO 100 ITAU=1,LIMDT                          !!! over basis:tau'-tau
	CALL REDUC2(DELTAU(1,ITAU),DELTAU(2,ITAU),DELTAU(3,ITAU),
     &NSVEC,SVEC,DX,DY,DZ,R0X,R0Y,R0Z)
	DO 90  ISVEC=1,NSVEC                         !!! over layers
	RX=SVEC(1,ISVEC)
	RY=SVEC(2,ISVEC)
	RZ=SVEC(3,ISVEC)
	DRX=RX-DX
	DRY=RY-DY
	DRZ=RZ-DZ
	DR=SQRT(DRX*DRX+DRY*DRY+DRZ*DRZ)
	IF(DR.NE.0.D0)THEN                  !!! i.e only when R+tau-tau'.ne.0
C   CALCULATE SIGMA_CONSTANTS
	EXPKR=EXP(((RX-R0X)*XK+(RY-R0Y)*YK+(RZ-R0Z)*ZK)*2.D0*PI*
     &DIMUNIT)
	DO 80 IEN=1,NE                             !!! over energies
	IF(EXP(-AKAP(IEN)*DR).EQ.0.D0)GOTO80
	CALL SPHHARM(DRX/DR,DRY/DR,DRZ/DR,ILS2(ITAU),YY)   !!! sph. harm.
	CALL HANKEL(DR,EN(IEN),SWZ,HAN,ILS2(ITAU))
	DO 70 L=0,ILS2(ITAU)                       !!! over l
	L0=L*(L+1)+1
	COEF=EXPKR*SQPI4*(-DIMUNIT)**L*HAN(1,L)
	IF(L.NE.0)COEFDOT=EXPKR*SQPI4*(-DIMUNIT)**L*
     &0.5D0*DR/SWZ/(2.D0*L-1.D0)*HAN(1,L-1)      !<--- Hankel-dot
	IF(L.EQ.0)COEFDOT=EXPKR*SQPI4*(-DIMUNIT)**L*
     &0.5D0*DR/SWZ/(2.D0*L-1.D0)*HAN(1,0)*HT(IEN)!<--- Hankel-dot L=0
	SIGMA(L0,ITAU,IEN)=SIGMA(L0,ITAU,IEN)+COEF*DCONJG(YY(L0))
	IF(L.LE.ILD2(ITAU))SIGMADOT(L0,ITAU,IEN)=
     &SIGMADOT(L0,ITAU,IEN)+COEFDOT*DCONJG(YY(L0))
	DO 60 M=1,L                                !!! over m
	LM =L0+M
	LMM=L0-M
	SIGMA(LM ,ITAU,IEN)=SIGMA(LM ,ITAU,IEN)+COEF*
     &DCONJG(YY(LM))
	SIGMA(LMM,ITAU,IEN)=SIGMA(LMM,ITAU,IEN)+COEF*
     &DCONJG(YY(LMM))
	IF(L.LE.ILD2(ITAU))THEN
	SIGMADOT(LM ,ITAU,IEN)=SIGMADOT(LM ,ITAU,IEN)+COEFDOT*
     &DCONJG(YY(LM))
	SIGMADOT(LMM,ITAU,IEN)=SIGMADOT(LMM,ITAU,IEN)+COEFDOT*
     &DCONJG(YY(LMM))
	ENDIF
  60  CONTINUE                                   !!! over m
  70  CONTINUE                                   !!! over l
  80  CONTINUE                                   !!! over energies
	ENDIF                               ! i.e only when R+tau-tau'.ne.0
  90  CONTINUE                                   !!! over vectors
 100  CONTINUE                                   !!! over basis
C MEMORY DEALLOCATIONS
	IF(LAST)THEN
      DEALLOCATE(LIMLDL)
      DEALLOCATE(LIMLPL)
      DEALLOCATE(BETT)
      DEALLOCATE(YY)
      DEALLOCATE(HAN)
      DEALLOCATE(EN)
      DEALLOCATE(AKAP)
      DEALLOCATE(HT)
	ENDIF
	RETURN
	END
